<?php

/**
 * General Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: imrsnik $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-09 20:49:23 +0000 (Wed, 09 Sep 2015) $
 * @version        $Rev: 6861 $
 * @package		Clientix.Classes
 * @abstract		General Class
 * CHANGE LOG
 *  Included label
 */
class xDebug {

    function dumpUserData() {
        return xDebug::dump($_SESSION);
    }

    static function dump($a, $title = '') {
        $contents = '';
        if (!empty($title)) {
            $contents .= '<h3>$title</h3>';
        }
        if ((is_array($a)) or ( is_object($a))) {
            $contents .= '<table border=' . "'1'" . ' cellspacing=' . "'1'" . ' cellpadding=' . "'1'" . '>';
            reset($a);
            foreach ($a as $key => $value) {
                $contents .= '<tr><td>' . $key . '</td><td>' . xDebug::dump($value) . '</td></tr>';
            }
            $contents .= '</table>';
        } else {
            $a = str_replace(CLX_CHAR_NL, '<10>' . CLX_CHAR_NL, $a);
            $a = str_replace(chr(CLX_NUM_13), '<13>' . chr(CLX_NUM_13), $a);
            $a = str_replace(chr(CLX_NUM_NINE), '<9>' . chr(CLX_NUM_NINE), $a);
            $a = str_replace(chr(CLX_NUM_32), '.', $a);
            $contents .= $a;
        }
        return $contents;
    }

    function report($a, $title = '') {
        $headers = true;
        if (!empty($title)) {
            $contents .= '<h3>' . $title . '</h3>' . CLX_CHAR_NL;
        }
        foreach ($a as $line) {
            if ($headers === true) {
                $contents .= '<table border="1" cellspacing="1" cellpadding="1">' . CLX_CHAR_NL;
                $keys = array_keys($line);
                $contents .= '<tr>';
                foreach ($keys as $key) {
                    $contents .= '<td>' . $key . '</td>';
                }
                $contents .= '</tr>' . CLX_CHAR_NL;
                $headers = false;
            }
            $contents .= '<tr>';
            foreach ($line as $key => $value) {
                $contents .= '<td>' . $value . '</td>';
            }
            $contents .= '</tr>' . CLX_CHAR_NL;
        }
        $contents .= '</table>' . CLX_CHAR_NL;
        return $contents;
    }

    function showInvisibles($text) {
        return '';
    }

}
