<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: imrsnik $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-10-17 18:43:20 -0400 (Sat, 17 Oct 2015) $
 * @version        $Rev: 7344 $
 *
 * CHANGE LOG
 *  File loaded
 */
class Incf {

    /**
     * Contructor
     *
     * @param array $procParameters
     * @return void
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('INCF'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
    }

    function download() {
        $active = companyParameter('INBK_INCF_RENAME_ACTIVE');
        $search = companyParameter('INBK_INCF_RENAME_PATH_FROM');
        $replace = companyParameter('INBK_INCF_RENAME_PATH_TO');
        ob_start();
        $idlist = toString(getIdlist());
        $sql = 'SELECT LA_CONFIR_URI FROM ' . $this->incfname . ' WHERE ID IN (' . $idlist . ')';
        $rs = ClxCommon::$db->executeQuery($sql);
        while (($r = ClxCommon::$db->getNextRecord($rs, NUMERIC))) {
            $fname = file_get_name($r[CLX_NUM_ZERO]);
            $mime = file_get_mime($r[CLX_NUM_ZERO]);
            if ($active === true) {
                $r[CLX_NUM_ZERO] = str_replace($search, $replace, $r[CLX_NUM_ZERO]);
            }
            header('Content-disposition: attachment; filename="' . $fname . '"');
            header('Content-type: ' . $mime);
            if (!file_exists($r[CLX_NUM_ZERO])) {
                echo dict('GEN_ERR_FILE_NOTFOUND', $fname);
            } else {
                readfile($r[CLX_NUM_ZERO]);
            }
            ob_end_flush();
            salir(CLX_NUM_ZERO);
        }
    }

}
