<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author	   $Author: fsantana $
 * @copyright	Alenet, Inc.
 * @since		$Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version		$Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Invr {

    /**
     * Constructor
     * @param array [$procParameters]
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('INVR', 'INFA', 'INFU', 'FIAS', 'INPR'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
        $this->je_source = '';
    }

    /**
     * Initialice form - Executed on init event
     *
     * @param array $record
     */
    function init_form(&$record) {

    }

    /**
     * Events post aras save commit
     * @param array $record
     */
    function post_save_form($record) {

    }

    /**
     * Validate record information
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     * @return boolean
     */
    function validate_form(&$record, &$msg) {
        return (count($msg) > CLX_NUM_ZERO) ? false : true;
    }

    /**
     * Renew btn
     * @param bool $inpr
     */
    function btn_schedule_renew($inpr = true) {

    }

}
