/**
 * Performs exchange rate calculation
 */
function jelnCalculateAmt() {

    var xrt = parseFloat($('#JELN_EXCHANGE_RT').val());
    $('#JELN_DEBIT_TRANS_AMT').val($('#JELN_DEBIT_TRANS_AMT').val().replace(/,/g, ''));
    $('#JELN_CREDIT_TRANS_AMT').val($('#JELN_CREDIT_TRANS_AMT').val().replace(/,/g, ''));
    var dr = parseFloat($('#JELN_DEBIT_TRANS_AMT').val());
    var cr = parseFloat($('#JELN_CREDIT_TRANS_AMT').val());
    var oper = parseFloat($('#JELN_CUR_OPERATOR').val());
    var base_dr;
    var base_cr;
    if (oper == 1) {
        base_dr = dr * xrt;
        base_cr = cr * xrt;
    } else {
        base_dr = dr / xrt;
        base_cr = cr / xrt;
    }
    $('#JELN_DEBIT_AMT').val(numDec(base_dr, 2));
    $('#JELN_CREDIT_AMT').val(numDec(base_cr, 2));
}

/*
 * Sets currency exchange for fiat see also JELN_JS
 */
function jelnCurrChangeRate() {
    var comp_code = $('input[name="JELN_COMP_CODE"]').val();
    var currency_code = $('#JELN_CURRENCY_CODE').val();
    var url = 'window.php?to=DBQY&ac=QXML&qy=CURR_GL_JS&no_menu=1&no_alerts=1&fn[]=COMP_CODE&fv[]='
            + comp_code + '&fn[]=BASE_CURRENCY&fv[]=' + currency_code;
    $.ajax({
        type: 'GET',
        url: url,
        dataType: 'xml',
        async: false,
        success: function (xml) {
            $(xml).find('CURR_GL_JS').each(function () {
                var self = this;
                var exchange_rt = $(self).find('CURR_EXCHANGE_RT').text();
                var cur_operator = $(self).find('CURR_CUR_OPERATOR ').text();
                $('#JELN_EXCHANGE_RT').val(exchange_rt);
                $('#JELN_CUR_OPERATOR').val(cur_operator);
                jelnCalculateAmt();
            });
        }
    });
}// End function

/**
 * Sets event
 */
function jelnSetEvents() {

    $('#JELN_CURRENCY_CODE').change(jelnCurrChangeRate);
    $('#JELN_CUR_OPERATOR').change(jelnCalculateAmt);
    $('#JELN_EXCHANGE_RT').change(jelnCalculateAmt);
    $('#JELN_DEBIT_TRANS_AMT').change(jelnCalculateAmt);
    $('#JELN_CREDIT_TRANS_AMT').change(jelnCalculateAmt);
}

//$(document).ready(jelnSetEvents);
