var msg1_DBQT = 'You must first select an item.';
function updateForm() {
    var form = $('#theForm')[0];
    var qty = form.elements['DBQT_selected'].length;
    var index = form.elements['DBQT_selected'].selectedIndex;
    form.elements['delete_btn'].disabled = ((qty == 0) || (index == -1));
}

function updateTables() {
    var form = $('#theForm')[0];
    var m = form.elements['DBQT_modules'].selectedIndex;

    clearpop(form.elements['DBQT_tables']);

    var qty = tables[m].length;

    for (var i = 0; i < qty; i++) {
        additem(form.elements['DBQT_tables'], tables[m][i]);
    }
    form.elements['DBQT_tables'].selectedIndex = 0;
    updateForm();
}

function clearpop(pop) {
    var i = 0;
    var o = pop.options;

    for (var i = o.length; i >= 0; --i)
        o[i] = null;
    pop.disabled = true;
}

function additem(pop, info) {
    var list = pop.options;
    var nIdx;

    if (list.length < 0) { //IE for Mac 4.5 sets length to -1 if list is empty
        nIdx = 0;
    }
    else {
        nIdx = list.length;
    }
    var values = info.split('?');
    list[nIdx] = new Option(values[1], values[0]);
    pop.disabled = false;
}

function copyItem(fromListName, toListName) {
    var form = $('#theForm')[0];
    var fromList = form.elements[fromListName];
    var toList = form.elements[toListName];

    var index = fromList.selectedIndex;
    if (index == -1) {
        alert(msg1_DBQT);
    } else {
        var option = fromList[index];
        var i = toList.length;
        toList[i] = new Option(option['text'], option['value']);
        toList.selectedIndex = i;
    }
    updateForm();
}

function deleteItem(fromListName) {
    var form = $('#theForm')[0];
    var fromList = form.elements[fromListName];
    var index = fromList.selectedIndex;
    fromList[index] = null;
    updateForm();
}

function processForm() {
    var form = $('#theForm')[0];
    var selected = form.elements['DBQT_selected'].options;
    var qty = selected.length;
    var tables = '';
    var delim = '';

    for (var i = 0; i < qty; i++) {
        tables += delim + selected[i].value;
        delim = ',';
    }

    form.elements['tables'].value = tables;

    //	form.elements['viewfields'].value = getIDs(form.elements['fieldList'])
    //	form.elements['sortfields'].value = getIDs(form.elements['sortList'])
    //	return true
}
