<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-10-15 10:19:43 -0400 (Mon, 15 Oct 2018) $
 * @version        $Rev: 10245 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('util') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'util.php';

class util_cache extends util {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'CACH';
        $this->name = 'Cache change Information and Time';
        $this->type = 'UTIL';
        $this->version = '0.1.0.0';
        $this->description = 'Clears all the data stored in the diferent log tables.';
        $this->haspanel = true;
        $this->interface = array(array('name' => 'CACHE INFORMATION',
                'dict' => 'GEN_LBL_CACHE_INFORMATION',
                'init' => false,
                'table' => 'CLX_CACHE_INFORMATION',
                'dir' => '',
                'archive' => 'true',
                'tool' => 'CLX'
            ) 
		);
    }
	function default(&$CT,&$EX,&$DT,&$RT,&$active) {
		$CT=array(0,9000,3600,1800,3600,1200,1200,1800,1800,1200,7200,1800,1800,1800,1800,1800,1800,1800,240,600,30,1800,30,2000,7200,300,7200);

		$EX=array_fill(0,27,'');
		$EX[22]='COUNT>4000';
		$DT=/*array_fill(0,27,'');*/ array('util.php(1033)'.chr(13).chr(10).'function dict'.chr(13).chr(10).'define("kApcTtl_1",9000);'.chr(13).chr(10).'publica','dictionary_heap.php(114)'.chr(13).chr(10).'function entry'.chr(13).chr(10).'define("kApcTtl_1",9000);'.chr(13).chr(10).'publica','util.php(176)'.chr(13).chr(10).'function apc_cache_get_tables_queries'.chr(13).chr(10).'define("kApcTtl_2",3600);'.chr(13).chr(10).'publica','util.php(723)'.chr(13).chr(10).'function loadtool'.chr(13).chr(10).'define("kApcTtl_3",1800);'.chr(13).chr(10).'privada','actn_code.php(144)'.chr(13).chr(10).'function includelibrary'.chr(13).chr(10).'define("kApcTtl_4",3600);'.chr(13).chr(10).'publica','dbft_lookup.php(977)'.chr(13).chr(10).'function formatField'.chr(13).chr(10).'define("kApcTtl_5",1200);'.chr(13).chr(10).'publica','ac_users.php(181)'.chr(13).chr(10).'function describe'.chr(13).chr(10).'define("kApcTtl_6",1200);'.chr(13).chr(10).'publica','db_field.php(820)'.chr(13).chr(10).'function getfield'.chr(13).chr(10).'define("kApcTtl_7",1800);'.chr(13).chr(10).'publica','db_lists.php(666,745)'.chr(13).chr(10).'function getListItem - getListItems'.chr(13).chr(10).'define(kApcTtl_8, 1800);'.chr(13).chr(10).'publica','events.php(542,568)'.chr(13).chr(10).'function getOwnerEvents'.chr(13).chr(10).'getOwnerEventsByAction'.chr(13).chr(10).'define("kApcTtl_9",1200);'.chr(13).chr(10).'publica','ui_filters.php(703)'.chr(13).chr(10).'function pop'.chr(13).chr(10).'define("kApcTtl_10",7200);'.chr(13).chr(10).'publica','sys_parameters.php(226,249,258)'.chr(13).chr(10).'function sys_parameters,staticparameters'.chr(13).chr(10).'define("kApcTtl_11",1800);'.chr(13).chr(10).'publica','db_queries.php(1332)'.chr(13).chr(10).'function getquery'.chr(13).chr(10).'define("kApcTtl_12",1800);'.chr(13).chr(10).'publica','db_tablefields.php(738)'.chr(13).chr(10).'function getTableFields'.chr(13).chr(10).'define("kApcTtl_13",1800);'.chr(13).chr(10).'publica','db_tables.php(1665)'.chr(13).chr(10).'function get_table'.chr(13).chr(10).'define("kApcTtl_14",1800);'.chr(13).chr(10).'publica','db_tables.php(1689)'.chr(13).chr(10).'function getTableAllFields'.chr(13).chr(10).'define("kApcTtl_15",1800);'.chr(13).chr(10).'publica','db_tables.php(43)'.chr(13).chr(10).'function __construct'.chr(13).chr(10).'define("kApcTtl_16",1800);'.chr(13).chr(10).'publica','objects.php(337)'.chr(13).chr(10).'function formatField'.chr(13).chr(10).'define("kApcTtl_17",1800);'.chr(13).chr(10).'publica','ui_calendar.php(1001)'.chr(13).chr(10).'function existsActivity'.chr(13).chr(10).'define("kApcTtl_18",240);'.chr(13).chr(10).'publica','ui_menuitems.php(620)'.chr(13).chr(10).'function getmenu'.chr(13).chr(10).'define("kApcTtl_19",600);'.chr(13).chr(10).'privada','ui_pages.php(603)'.chr(13).chr(10).'function drawPageRow'.chr(13).chr(10).'define("kApcTtl_20",30);'.chr(13).chr(10).'publica','clx_tool.php(1671)'.chr(13).chr(10).'function getToolRecord'.chr(13).chr(10).'define("kApcTtl_21",1800);'.chr(13).chr(10).'publica','xpagging.php(176)'.chr(13).chr(10).'function pageinit'.chr(13).chr(10).'define("kApcTtl_22",30);'.chr(13).chr(10).'MysqliDatabase.php'.chr(13).chr(10).'privada','kApcTtl_23 table exists','clxdatabase.php(774)'.chr(13).chr(10).'function fileinfo'.chr(13).chr(10).'define("kApcTtl_24",7200);'.chr(13).chr(10).'publica','kApcTtl_25 ui_listing','object.php(309)'.chr(13).chr(10).'function loadToolRecord'.chr(13).chr(10).'define("kApcTtl_26",7200);'.chr(13).chr(10).'publica','','');
		$RT=array('','diccionario','record queryname vs tables','record del tool','informacion de la libreia','formato field','information fields','get fields','opciones de lista','events','filters','el query information','el query information','inf.  campos de tabla','get tables information','get tables information',  'get queries information','formato de los fields','actividades','menus','count for pages','record del tool','count pagina-listado','','info table fields','','load record tool');
    	if (!function_exists('cacheconfig') && file_exists(kPathToWebSite.  'includes/cache_information.php'))
			include kPathToWebSite.  'includes/cache_information.php';
		if (function_exists('cacheconfig'))
			cacheconfig($CT,$EX,$active);
		
	}
	function panel($msg) {
		$this->default($CT,$EX,$DT,$RT,$active);
	    $contents = '';
       
		$form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, 'UTIL');
        $form->addArgument('ut', $this->code);	
        $form->addArgument('ac', 'PANEL');
        $form->addArgument('confirm', '1');
        
		$table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $table->addCell(dict('TOOL_CACHE_CHANGE'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_TWO ));
        $yesno = new htmlSelect( 'CACHE_ACTIVE');
		$yesno->addItem(dict('GEN_LBL_NO'), '0', (isset($active)&& $active==0));
        $yesno->addItem(dict('GEN_LBL_YES'), '1', (isset($active)&& $active==1));
        $table->addData(dict('GEN_LBL_ACTIVE') . ':', $yesno->source());
		
		$yesno = new htmlSelect( 'CACHE_RESET');
		$yesno->addItem(dict('GEN_LBL_NO'), '0', true);
        $yesno->addItem(dict('GEN_LBL_YES'), '1', false);
        $table->addData(dict('GEN_LBL_RESET') . ':', $yesno->source());
		
        $c = new htmlSubmit(dict('GEN_LBL_SAVE_CACHE'));
        $buttons = $c->source();
        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
        $form->setContents($table->source());
        $contents = $form->source();

		//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
		$form = new htmlForm(CLX_PROP_ACTION, 'tool.php');
        $form->addArgument(CLX_PROP_TO, 'UTIL');
        $form->addArgument('ut', $this->code);	
        $form->addArgument('ac', 'PANEL');
        $form->addArgument('confirm', '1');
        $table = new htmlTable(CLX_WIDTH_SIX);
		$table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
		$table->addCell(dict('TOOL_CACHE_CHANGE2'), array(CLX_PROP_CLASS => CLX_CLASS_TITLE, CLX_PROP_COLSPAN => CLX_WIDTH_SIX ));
        
		//$table->addCell(, array(CLX_PROP_CLASS => CLX_CLASS_DATA)
		$table->addcell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_ONE));
		$table->addcell(DICT('GEN_LBL_TIME_OPTIONS'), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_ONE));
		$table->addcell(DICT('GEN_LBL_EXTRA_OPTIONS'), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_THREE));
		$table->addcell(DICT('GEN_LBL_DESCRIPTIONS'), array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_ONE));
		for ($t=1;$t<27;$t++) {
			$table->addField($msg, 'CACHE '.$t.' (' .$RT[$t]. '):', 'CT['.$t.']', $CT[$t], CLX_NUM_16, CLX_NUM_16);
			IF ($t==22) {
				$c = new htmlField('EX['.$t.']', $EX[$t], CLX_NUM_16, CLX_NUM_16);
				$table->addCell($c->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
				$table->addcell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_TWO));
			}
			else {
				$table->addcell(CLX_CHAR_HTML_NBSP, array(CLX_PROP_CLASS => CLX_CLASS_DATA, CLX_PROP_COLSPAN => CLX_WIDTH_THREE));
			}
			$c = new htmlTextArea('DT['.$t.']', $DT[$t], CLX_NUM_THREE, CLX_NUM_45);
			$table->addCell($c->source(), array(CLX_PROP_CLASS => CLX_CLASS_DATA));
		}
		
        $c = new htmlSubmit(dict('GEN_LBL_SAVE_CACHE'));
        $buttons = $c->source();
        $c = new htmlButtonCancel();
        $buttons .= $c->source();
        $table->addCell($buttons, array(CLX_PROP_CLASS => CLX_CLASS_FOOTERS, CLX_PROP_COLSPAN => CLX_WIDTH_FOUR));
        $form->setContents($table->source());
        $contents .= $form->source();
		
		
		
        return $contents;
    }

    function checkPanel(&$msg) {
        $msg = array();
        return count($msg) == CLX_NUM_ZERO;
    }
	function execute_() {
		$this->default($CT,$EX,$DT,$RT,$active);
		if(isset($_POST['CT'])) {
			for($t=1; $t<=count($_POST['CT']);$t++) { 
				if (is_numeric($_POST['CT'][$t]))
					$CT[$t]=$_POST['CT'][$t];
			}
			$cortes=explode(">",$_POST['EX'][22]);
			if (count($cortes)==2 and is_numeric($cortes[1]) and is_string($cortes[0])) {
				$EX[22]=$_POST['EX'][22];
			}
			apc_clear_cacheFct();
		}
		
		if (isset($_POST['CACHE_RESET']) && $_POST['CACHE_RESET']==1)
			apc_clear_cacheFct();
		
		$fx=fopen(kPathToWebSite.  'includes/cache_information.php','w+');	
		fwrite($fx,'<?php'.chr(13).chr(10));
		fwrite($fx,'function cacheconfig(&$CT,&$EX,&$active) {'.chr(13).chr(10));
		fwrite($fx,chr(9).'$CT=array('.implode(',',$CT).');'.chr(13).chr(10));
		fwrite($fx,chr(9).'$EX[22]="'.$EX[22].'";'.chr(13).chr(10));
		
		IF (isset($_POST['CACHE_ACTIVE'])) {
			fwrite($fx,chr(9).'$active='.$_POST['CACHE_ACTIVE'].';'.chr(13).chr(10));
		}
		else {
			fwrite($fx,chr(9).'$active=0;'.chr(13).chr(10));
		}
		fwrite($fx,'}'.chr(13).chr(10));
		fwrite($fx,'function cachedefine() {'.chr(13).chr(10));
		IF (isset($_POST['CACHE_ACTIVE'])) {
			fwrite($fx,chr(9).'define(\'kApcEnabled\','.$_POST['CACHE_ACTIVE'].');'.chr(13).chr(10));
		}
		else {
			fwrite($fx,chr(9).'define(\'kApcEnabled\',0);'.chr(13).chr(10));
		}
//		fwrite($fx,chr(9).'echo ";",kApcEnabled,";";'.chr(13).chr(10));
		for($t=1; $t<count($CT);$t++) { 
			fwrite($fx,chr(9).'define(\'kApcTtl_'.$t.'\','.$CT[$t].');'.chr(13).chr(10));
		}
		fwrite($fx,chr(9).'define(\'kApcTtl_Count_22\','.singlequote($EX[22]).');'.chr(13).chr(10));
		fwrite($fx,'}'.chr(13).chr(10));
		fclose($fx);
		if (function_exists('opcache_reset'))
			opcache_reset();
        return '';
    }

}
