<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-10-15 10:19:43 -0400 (Mon, 15 Oct 2018) $
 * @version        $Rev: 10245 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('util') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'util.php';

class util_phpinfo extends util {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'PINF';
        $this->name = 'PHP Information';
        $this->type = 'UTIL';
        $this->version = '1.0.0.0';
        $this->description = 'Shows a lot of information about the current PHP Installed on server.';
        $this->haspanel = false;
    }

    function execute_() {
        pushHistory($this->code, 'IGNORE_THIS_ENTRY', CLX_NUM_ZERO);

		ob_start();
        phpinfo(-CLX_NUM_ONE);
        $contents = ob_get_contents();
        ob_clean();
		$contents = preg_replace( '%^.*<body>(.*)</body>.*$%ms','$1',$contents);
        $contents = '<TABLE><TR><TD ALIGN=' . singleQuote('left') . '><INPUT TYPE=' . singleQuote('button') . ' VALUE=' . singleQuote('Return / Salir') . ' onClick=' . singleQuote('javascript: history.back(-1)') . '><br><br></TD></TR><td><tr>' . $contents . '</tr></td></TABLE>';
        return $contents;
    }
}
?>
