<?php

/**
 * Tool Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Included label
 */
class ui_skins extends clx_tool {

    function __construct() {
        $this->code = 'UISK';
        $this->name = 'Skins Manager';
        $this->system = 'Interface';
        $this->version = '1.0.0.0';
        $this->has_preferences = true;



        $this->tablename = '';
        $this->record_name_singular = '';
        $this->record_name_plural = '';
    }

    function preferencesForm($record, &$form, &$table) {
        $table->addCell(dict('TOOL_UISK_TITLE_PREFS'), array(CLX_PROP_CLASS => CLX_CLASS_SUBTITLE, CLX_PROP_COLSPAN => $table->width));
        $pop = new htmlSelect('UIKP_PREF_SKIN');
        $f = new clx_filesystem();
        $skins = $f->rDir(kPathToWebSite . kPathToSkins);
        reset($skins);
        foreach ($skins as $key => $val) {
            if ($f->isDirectory(kPathToWebSite . kPathToSkins . '/' . $val) && $val !== '.' && $val !== '..') {
                $pop->addItem($val, $val, ($record['UIKP_PREF_SKIN'] == $val));
            }
        }
        $table->addData(dict('TOOL_UISK_PROMPT_PREF_SKIN') . ':', $pop->source());
    }

    function preferencesLoad(&$record) {
        $record['UIKP_PREF_SKIN'] = $_SESSION['skin'];
    }

    function preferencesSave() {
        $USPR = &getTool('USPR');
        $USPR->prfSavePref($_SESSION['user_record']['username'], 'UIKP_PREF_SKIN', UserRequest::$post['UIKP_PREF_SKIN']);
        $_SESSION['skin'] = UserRequest::$post['UIKP_PREF_SKIN'];
    }

    function preferencesDefault(&$record) {
        return array('UIKP_PREF_SKIN' => 'default');
    }

}
