<?php

/*
 * Code Library: ACCO-REC
 */

function initAccoRecord(&$record) {
    ClxFreeReturn($record);
    //e cho 'initAccoRecord<br>';
}

function loadAccoRecord(&$record) {
    ClxFreeReturn($record);
    //e cho 'loadAccoRecord<br>';
}

// ACCO Record Validation: Mandatory Fields for e-IBS Client export
function validateAccoRecord(&$msg1, $record) {
    ClxFreeReturn($record);
    ClxFreeReturn($msg1);
}

// Method End
function createpostAccoRecord(&$record) {
    ClxFreeReturn($record);

}

function createpreAccoRecord(&$record) {
    ClxFreeReturn($record);
}

function updatepreAccoRecord(&$record) {
    ClxFreeReturn($record);
}

function updateAccoRecord(&$record) {
    ClxFreeReturn($record);
}

function deleteAccoRecord(&$record) {
    ClxFreeReturn($record);
}

function LoadAccountcode($session_values, $record) {
    ClxFreeReturn($session_values);
    return $record;
}

function verfy_city_stat_code($record, &$msg, $fm = '') {
    ClxFreeReturn($record);
    ClxFreeReturn($msg);
    ClxFreeReturn($fm);
}

/**
 * Construct leads name
 *
 * @param unknown_type $record
 */
function accoIdname(&$record, $prefix = '') {
    //En servicios web como el de LA se regresa el cuscun y se actualiza lo que arroja un warning.
    //si no existe idname el cual no viene en la trama del servicio
    //entonces no hay que hacer nada con el campo de idname
    if (!array_key_exists($prefix . 'IDNAME', $record))
        return;
    $idname = (!empty($record[$prefix . 'IDNAME'])) ? $record[$prefix . 'IDNAME'] : 'AUTO';
    $fname = $record[$prefix . 'FIRSTNAME'];
    $lname = $record[$prefix . 'LASTNAME'];
    if (array_key_exists($prefix . 'SECOND_NAME', $record)) {
        $fname .= ' ' . $record[$prefix . 'SECOND_NAME'];
    }
    if (array_key_exists($prefix . 'SECOND_LASTNAME', $record)) {
        $lname .= ' ' . $record[$prefix . 'SECOND_LASTNAME'];
    }
    if (array_key_exists($prefix . 'LEGAL_NAME', $record)) {
        $cname = $record[$prefix . 'LEGAL_NAME'];
    } elseif (array_key_exists($prefix . 'COMPANY', $record)) {
        $cname = $record[$prefix . 'COMPANY'];
    } else {
        $cname = 'null';
    }
    $idname = uppercase($idname);
    if ($fname === 'null')
        $fname = '';
    if ($lname === 'null')
        $lname = '';
    if ($cname === 'null')
        $cname = '';
    if ($idname === 'AUTO') {
        if (!empty($lname) && !empty($fname) && !empty($cname)) {
            $idname = $lname . ',' . $fname . '-' . $cname;
        } elseif (!empty($lname) && !empty($fname) && empty($cname)) {
            $idname = $lname . ',' . $fname;
        } elseif (!empty($lname) && empty($fname) && !empty($cname)) {
            $idname = $lname . '-' . $cname;
        } elseif (empty($lname) && !empty($fname) && !empty($cname)) {
            $idname = $fname . '-' . $cname;
        } elseif (empty($lname) && empty($fname) && !empty($cname)) {
            $idname = $cname;
        } else {
            $idname = 'N/A';
        }
        $record[$prefix . 'IDNAME'] = uppercase($idname);
    }
}

function set_isindividual_record(&$record) {
    ClxFreeReturn($record);
}

function set_isindividual($s_legal_type) {
    ClxFreeReturn($s_legal_type);
}
