/*
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2016-11-10 15:04:29 -0500 (Thu, 10 Nov 2016) $
 * @version        $Rev: 8906 $
 *
 * CHANGE LOG
 * 2009/09/02 Included svn prop
 */

var inat_valorized_gain_amt = 0;
var inat_valorized_loss_amt = 0;

function inatInitFormPanels() {
    var self = this;

    //Listeners
    $('#INAT_COMP_CODE').change(inatSetEfftDate);
    $('#INAT_PORTFOLIO_CODE').change(inatTotal_v2);
    $('#INAT_INVESTMENT_CODE').change(inatTotal_v2);
    $('#INAT_INVEST_ACTIVITY').change(inatTotal_v2);
    $('#INAT_INVEST_AMT').change(inatTotal_v2);
    $('#INAT_AMORTIZED_AMT').change(inatTotal_v2);
    $('#INAT_DIVIDEND_AMT').change(inatTotal_v2);
    $('#INAT_FACE_VALUE').change(inatTotal_v2);
    $('#INAT_SHARES').change(inatTotalUnitPrice);
    $('#INAT_UNIT_PRICE').change(inatTotalUnitPrice);
    $('#INAT_UNIT_PRICE_PCT').change(inatTotalUnitPricePct);
    $('#INAT_EFFTDATE').change(function () {
        copyFormFieldData('INAT_EFFTDATE', 'INAT_REAL_DATE');
    });

    $('#INAT_UNIT_PRICE_PCT').change(inatYTM);
    $('#INAT_EFFTDATE').change(inatYTM);
    $('#INPR_PAYMENT_FREQ').change(inatYTM);
    $('#INPR_PAYMENT_FREQ').change(inatSetInvPeriod);
    $('#INPR_ISSUE_DATE').change(inatYTM);
    $('#INPR_COUPON_RT').change(inatYTM);
    $('#INAT_INVEST_AMT').change(inatYTM);
    $('#INAT_MATURITY_DATE').change(inatYTM);
    $('#INPR_NO_PERIODS').change(inatYTM);
    $('#INAT_FACE_VALUE').change(inatYTM);
    $('#INPR_PERIOD_TYPE').change(inatYTM);

    $('#INAT_CASH_AMT').change(inatSetCashAmt);
    $('#INAT_GAIN_AMT').change(inatCalculateCashAmt);
    $('#INAT_ACCRUED_INT_AMT').change(inatCalculateCashAmt);
    $('#INAT_TAX_AMT').change(inatCalculateCashAmt);
    $('#INAT_FEES_AMT').change(inatCalculateCashAmt);
    //$('#INAT_PORTFOLIO_CODE').change(inatGetPortfolioType);
    //$('#INAT_INVEST_ACTIVITY').change(inatSetActivityFields);
    //inatSetProductDetails
    $('#INAT_POSITION_NUMBER').change(InatSetPositionDetails);
    $('#INAT_INVESTMENT_CODE').change(inatSetProductDetails);
    //$('#INAT_MATURITY_DATE').change(inatSetInvPeriod);
    $('#INAT_EFFTDATE').change(inatSetInvPeriod);
    $('#INAT_CUR_COUPON_SDATE').change(inatSetInvPeriod);
    $('#INPR_MATURITY_DATE').change(inatSetInvPeriod);

    //$('#INAT_ACQUISITION_DATE').change(inatSetInvPeriod);
    $('#INPR_IS_FIXINCOME').change(inatGetMarketType);
    $('#INAT_COMP_CODE').change(function () {
        $('#INPR_COMP_CODE').val($('#INAT_COMP_CODE').val());
    });
    $('#INPR_COMP_CODE').change(function () {
        $('#INAT_COMP_CODE').val($('#INPR_COMP_CODE').val());
    });
    //INAT_IS_FIXINCOME
    $('#4570').hide();//fix
    $('#4571').show();//non fix
    $('#4574').hide();//Product Detail
    inatSetActivityFields();
    inatSetInvPeriod();
    //Init ytm
    inatYTM();


    //Disable unided items from
    $(function () {

        $('#INPR_INTEREST_CALC option').each(function (i) {
            self = this;
            switch ($(self).val()) {
                case '30/360':
                case 'AC/360':
                case '':
                case '30/365':
                case 'AC/365':
                case 'AC/AC':
                    break;
                default:
                    //$(self).hide();//donot work on ie
                    $('select#INPR_INTEREST_CALC option').filter("[value='" + $(self).val() + "']").remove();
                    break;
                                 }
            ;
        });
    });
    //$('#INPR_INTEREST_CALC option[value='360']').hide();
}


function inatSetActivityFields() {
    //Lock all and open
    var operation = $('#INAT_INVEST_ACTIVITY').val();

    //   inatGetPortfolioType();
    inatActivityProduct();
    inatGetMarketType();
    inatInitAllValues();
    inatFormatAllValues();
    $('#INAT_CASH_AMT').attr('readonly', true);
    $('#INAT_INVEST_AMT').attr('readonly', true);
    $('#INAT_FACE_VALUE').attr('readonly', true);
    $('#INAT_TAX_AMT').attr('readonly', true);
    $('#INAT_FEES_AMT').attr('readonly', true);
    $('#INAT_ACCRUED_INT_AMT').attr('readonly', true);
    $('#INAT_AMORTIZED_AMT').attr('readonly', true);
    $('#INAT_SHARES').attr('readonly', true);
    $('#INAT_UNIT_PRICE').attr('readonly', true);
    $('#INAT_GAIN_AMT').attr('readonly', true);
    $('#INAT_DIVIDEND_AMT').attr('readonly', true);
    if (operation == 'BY' || operation == 'BYT' || operation == 'APINV') {
        $('#INAT_CASH_AMT').attr('readonly', false);
        $('#INAT_INVEST_AMT').attr('readonly', false);
        $('#INAT_FACE_VALUE').attr('readonly', false);
        $('#INAT_ACCRUED_INT_AMT').attr('readonly', false);
        $('#INAT_TAX_AMT').attr('readonly', false);
        $('#INAT_FEES_AMT').attr('readonly', false);
        $('#INAT_SHARES').attr('readonly', false);
        $('#INAT_UNIT_PRICE').attr('readonly', false);
    } else if (operation == 'SL' || operation == 'CA' || operation == 'VE') {
        $('#INAT_CASH_AMT').attr('readonly', false);
        $('#INAT_INVEST_AMT').attr('readonly', false);
        $('#INAT_FACE_VALUE').attr('readonly', false);
        $('#INAT_ACCRUED_INT_AMT').attr('readonly', false);
        $('#INAT_TAX_AMT').attr('readonly', false);
        $('#INAT_FEES_AMT').attr('readonly', false);
        $('#INAT_SHARES').attr('readonly', false);
        $('#INAT_UNIT_PRICE').attr('readonly', false);
        $('#INAT_GAIN_AMT').attr('readonly', false);
        $('#INAT_VALORIZED_AMT').attr('readonly', false);
        $('#INAT_AMORTIZED_AMT').attr('readonly', false);
        $('#INAT_GAIN_AMT').attr('readonly', false);
    } else if (operation == 'AVAL') {
        $('#INAT_VALORIZED_AMT').attr('readonly', false);
    } else if (operation == 'PA' || operation == 'DA') {
        $('#INAT_AMORTIZED_AMT').attr('readonly', false);
        $('#INAT_VALORIZED_AMT').attr('readonly', true);
    } else if (operation == 'RD') {
        $('#INAT_ACCRUED_INT_AMT').attr('readonly', false);
        $('#INAT_TAX_AMT').attr('readonly', false);
        $('#INAT_FEES_AMT').attr('readonly', false);
        $('#INAT_FACE_VALUE').attr('readonly', false);
        $('#INAT_VALORIZED_AMT').attr('readonly', false);
        $('#INAT_AMORTIZED_AMT').attr('readonly', false);
    } else if (operation == 'UEI' || operation == 'PINT' || operation == 'REU' || operation == 'PINTR') {
        $('#INAT_ACCRUED_INT_AMT').attr('readonly', false);
        $('#INAT_TAX_AMT').attr('readonly', false);
        $('#INAT_FEES_AMT').attr('readonly', false);
    } else if (operation == 'DIVAO') {
        $('#INAT_DIVIDEND_AMT').attr('readonly', false);
        $('#INAT_SHARES').attr('readonly', false);
        $('#INAT_UNIT_PRICE').attr('readonly', false);
    } else if (operation == 'DIVEO') {
        $('#INAT_DIVIDEND_AMT').attr('readonly', false);
        $('#INAT_SHARES').attr('readonly', false);
        $('#INAT_UNIT_PRICE').attr('readonly', false);
    } else if (operation == 'DIVA') {
        //$('#INAT_ACCRUED_INT_AMT').attr('readonly', false);
        $('#INAT_DIVIDEND_AMT').attr('readonly', false);
        $('#INAT_INVEST_AMT').attr('readonly', false);
        $('#INAT_SHARES').attr('readonly', false);
        $('#INAT_UNIT_PRICE').attr('readonly', false);
        $("#INAT_DIVIDEND_SHARES").attr("readonly", false);
    } else if (operation == 'DIVE') {
        $('#INAT_DIVIDEND_AMT').attr('readonly', false);
        //$('#INAT_ACCRUED_INT_AMT').attr('readonly', false);
        $('#INAT_CASH_AMT').attr('readonly', false);
        $('#INAT_SHARES').attr('readonly', false);
        $('#INAT_UNIT_PRICE').attr('readonly', false);
    } else if (operation.length > 0) {
        $('#INAT_CASH_AMT').attr('readonly', false);
        $('#INAT_INVEST_AMT').attr('readonly', false);
        $('#INAT_SHARES').attr('readonly', false);
        $('#INAT_UNIT_PRICE').attr('readonly', false);
    }else {

    }
    inatInitAllValues();
    inatSetPremiumAndPrices();
    inatFormatAllValues();
}//end method


function inatTotal_v2() {
    inatInitAllValues();
    inatSetActivityFields();
    var operation = $('#INAT_INVEST_ACTIVITY').val();
    if (operation != 'SL' && operation != 'BY' && operation != 'APINV' && operation != 'BYT' && operation != 'CA' && operation != 'VE' && operation != 'RD') {
        $('#INAT_FACE_VALUE').val(0);
        $('#INAT_ACCRUED_INT_AMT').val(0);
    } else if (parseFloat($('#INAT_FACE_VALUE').val()) == 0 && $('#INPR_IS_FIXINCOME').val() == 1 && operation != 'RD') {
        $('#INAT_FACE_VALUE').val($('#INAT_INVEST_AMT').val());
    } else {

    }
    if($('#INPR_IS_FIXINCOME').val() == 0){
        inatTotalUnitPrice();
    }else{
        inatTotalUnitPricePct();
    }
    //inatSetGain();
    inatSetAmortization();
    inatSetPremiumAndPrices();
    inatCalculateCashAmt();
    inatFormatAllValues();

}// End function

function inatSetAmortization() {

    var operation = $('#INAT_INVEST_ACTIVITY').val();
    if (operation == 'PA' || operation == 'DA' || operation == 'AVAL') {

        if (parseFloat($('#INAT_INVEST_AMT').val()) != 0) {
            $((operation == 'AVAL') ?
              '#INAT_VALORIZED_AMT' :
              '#INAT_AMORTIZED_AMT').val($('#INAT_INVEST_AMT').val())
        }
        $('#INAT_INVEST_AMT').val(0);
        $('#INAT_CASH_AMT').val(0);
        $('#INAT_TAX_AMT').val(0);
        $('#INAT_FEES_AMT').val(0);
        $('#INAT_FEES_AMT').val(0);
        $('#INAT_DISCOUNT_AMT').val(0);
        $('#INAT_PREMIUM_AMT').val(0);
        $('#INAT_UNIT_PRICE_PCT').val(0);
    }
}//end method


function setPremiumAndDiscount() {
    var operation = $('#INAT_INVEST_ACTIVITY').val()
    if (operation == 'BY' || operation == 'BYT' || operation == 'APINV') {
        if (parseFloat($('#INAT_INVEST_AMT').val()) > parseFloat($('#INAT_FACE_VALUE').val())) {
            $('#INAT_PREMIUM_AMT').val(parseFloat($('#INAT_INVEST_AMT').val()) - parseFloat($('#INAT_FACE_VALUE').val()));
            $('#INAT_DISCOUNT_AMT').val(0);
        } else {
            $('#INAT_DISCOUNT_AMT').val(parseFloat($('#INAT_FACE_VALUE').val()) - parseFloat($('#INAT_INVEST_AMT').val()));
            $('#INAT_PREMIUM_AMT').val(0);
        }
    } else if (operation == 'SL' || operation == 'CA' || operation == 'VE') {
        $('#INAT_DISCOUNT_AMT').val(0);
        $('#INAT_PREMIUM_AMT').val(0);
    } else {

    }
}
/**
 * Premium and discount operations
 */
function inatSetPremiumAndPrices() {

    var calculo = 0;
    var operation = $('#INAT_INVEST_ACTIVITY').val();

    if (parseFloat($('#INAT_FACE_VALUE').val()) != 0) {
        calculo = numDec((parseFloat($('#INAT_INVEST_AMT').val())
                          / parseFloat($('#INAT_FACE_VALUE').val())) * 100,5);
    }

    setPremiumAndDiscount();
    var pricepct = parseFloat($('#INAT_UNIT_PRICE_PCT').val());
    if (operation == 'BY' || operation == 'BYT' || operation == 'APINV') {
        $('#INAT_GAIN_AMT').val(0);
        if (pricepct == 0) {
            $('#INAT_UNIT_PRICE_PCT').val(calculo);
        }
    }
    if (pricepct == 0 && (operation == 'SL' || operation == 'CA' || operation == 'VE')) {
        $('#INAT_UNIT_PRICE_PCT').val(calculo);
    }
}//end function

/**
 * Set investment amount from cash
 */
function inatSetCashAmt() {

    var fix = $('#INPR_IS_FIXINCOME').val();
    var operation = $('#INAT_INVEST_ACTIVITY').val();
    $('#INAT_CASH_AMT').val(parseFloat($('#INAT_CASH_AMT').val()));
    var conditionOperation = (operation == 'BY' || operation == 'BYT' || operation == 'APINV' || operation == 'SL' || operation == 'CA' || operation == 'VE' || operation == 'PINT' || operation == 'RD')
    if (fix > 0 && conditionOperation) {
        $('#INAT_FACE_VALUE').val($('#INAT_CASH_AMT').val());
        $('#INAT_SHARES').val(0);
        $('#INAT_UNIT_PRICE').val(0);
    } else if (conditionOperation) {
        if (parseFloat($('#INAT_UNIT_PRICE').val()) == 0) {
            $('#INAT_UNIT_PRICE').val($('#INAT_CASH_AMT').val());
        }
        if (parseFloat($('#INAT_SHARES').val()) == 0) {
            $('#INAT_SHARES').val(1);
        }

    }

    $('#INAT_ACCRUED_INT_AMT').val(0);
    $('#INAT_TAX_AMT').val(0);
    $('#INAT_FEES_AMT').val(0);

    inatSetPremiumAndPrices();
    inatFormatAllValues();
}

/**
 * Set the panel to display based on product
 */
function inatGetMarketType() {

    if ($('#INPR_IS_FIXINCOME').val() == 1) {
        $('#4570').show();//non fix
        $('#4571').hide();//fix
    } else {
        $('#4570').hide();//non fix
        $('#4571').show();//fix
    }

}//end function

/*
 * Set the panel to display based on product
 */
function inatSetEfftDate() {
    var comp_code = $('#INAT_COMP_CODE').val();
    $.ajax({type: 'GET',
            url: 'window.php?to=DBQY&ac=QXML&no_menu=1&no_alerts=1&qy=INFU_FORM&fn=INFU.COMP_CODE&fv=' + comp_code,
            dataType: 'xml',
            async: false,
            success: function (xml) {
                $(xml).find('INFU_FORM').each(function () {
                    var self = this;
                    var operdate = $(self).find('GLCP_OPERATION_DATE').text();
                    $('#INAT_EFFTDATE').val(operdate);
                    $('#INAT_REAL_DATE').val(operdate);
                    $('#INAT_ISSUE_DATE').val(operdate);
                    $('#INAT_CUR_COUPON_SDATE').val(operdate);
                });

            }
           });
}//end function

function inatSetGain() {

    //var gain = 0;

    var port = $('#INAT_PORTFOLIO_CODE').val();
    var prod = $('#INAT_INVESTMENT_CODE').val();
    var pos = $('#INAT_POSITION_NUMBER').val();
    var operation = $('#INAT_INVEST_ACTIVITY').val();
    if (operation == 'CA' || operation == 'SL' || operation == 'VE' || operation == 'PINT' || operation == 'RD' || operation == 'DIVA' || operation == 'DIVE') {
        $.ajax({type: 'GET',
                url: 'window.php?to=DBQY&ac=QXML&qy=INFA_FORM&no_menu=1&no_alerts=1&fn[]=INFA.POSITION_NUMBER&fv[]=' + pos + '&fn[]=INFA.INVESTMENT_CODE&fv[]=' + prod + '&fn[]=INFA.PORTFOLIO_CODE&fv[]=' + port,
                dataType: 'xml',
                async: false,
                success: function (xml) {

                    $(xml).find('INFA_FORM').each(function () {
                        var self = this;
                        //var fix = $(self).find('ININ_MARKET_TYPE').text();
                        var inve = parseFloat($(self).find('INFA_INVEST_AMT').text());
                        var face = parseFloat($(self).find('INFA_FACE_VALUE').text());
                        var share = parseFloat($(self).find('INFA_SHARES').text());
                        var amort = parseFloat($(self).find('INFA_AMORTIZED_AMT').text());
                        var valor = parseFloat($(self).find('INFA_VALORIZED_AMT').text());
                        var accrued_int = parseFloat($(self).find('INFA_ACCRUED_INT_AMT').text());

                        $('#INAT_CUR_INVEST_AMT').val(numDec(inve,2));
                        $('#INAT_CUR_FACE_VALUE').val(numDec(face,2));
                        $('#INAT_CUR_SHARES').val(numDec(share,2));
                        $('#INAT_CUR_AMORTIZED_AMT').val(numDec(amort,2));
                        $('#INAT_CUR_VALORIZED_AMT').val(numDec(valor,2));
                        $('#INAT_BOOK_VALUE_AMT').val(numDec(parseFloat($(self).find('INFA_BOOK_VALUE_AMT').text()),2));
                        inat_valorized_gain_amt = parseFloat($(self).find('INFA_VALORIZED_GAIN_AMT').text());
                        inat_valorized_loss_amt = parseFloat($(self).find('INFA_VALORIZED_LOSS_AMT').text());
                        $('#INAT_VALORIZED_GAIN_AMT').val(inat_valorized_gain_amt);
                        $('#INAT_VALORIZED_LOSS_AMT').val(inat_valorized_loss_amt);
                        $('#INAT_CUR_INTEREST').val(numDec(accrued_int,2));

                        if (operation == 'DIVE') {
                            $('#INAT_SHARES').val(share);
                        }


                        if (operation == 'PINT' || operation == 'PINTR' || operation == 'RD') {
                            if (parseFloat($('#INAT_ACCRUED_INT_AMT').val()) == 0) {
                                $('#INAT_ACCRUED_INT_AMT').val(accrued_int);
                            }

                            if (operation == 'RD' && parseFloat($('#INAT_FACE_VALUE').val()) == 0) {
                                $('#INAT_FACE_VALUE').val(face);
                            }
                            inatCalculateCashAmt();
                        }

                        if ((operation == 'CA' || operation == 'SL' || operation == 'VE' || operation == 'RD')) {

                            if (parseFloat($('#INAT_INVEST_AMT').val()) == 0) {
                                $('#INAT_INVEST_AMT').val(inve);
                            }
                            if (parseFloat($('#INAT_FACE_VALUE').val()) == 0) {
                                $('#INAT_FACE_VALUE').val(face);
                            }
                            if (parseFloat($('#INAT_SHARES').val()) == 0) {
                                $('#INAT_SHARES').val(share);
                            }

                            //if(parseFloat($('#INAT_ACCRUED_INT_AMT').val())==0){
                            $('#INAT_ACCRUED_INT_AMT').val(accrued_int);
                            //}

                            if (parseFloat($('#INAT_VALORIZED_AMT').val()) == 0) {
                                $('#INAT_VALORIZED_AMT').val(valor);
                            }

                            if ($('#INPR_IS_FIXINCOME').val() == 1 && parseFloat($('#INAT_AMORTIZED_AMT').val()) == 0) {//call in price recal

                                //$('#INAT_AMORTIZED_AMT').val(amort);
                                $('#INAT_AMORTIZED_AMT').val(inve - face);
                            }
                            inatCalculateCashAmt();

                            //---------------------------------------------------------
                            //Gain
                            //----------------------------------------------------------

                            //if($('#INAT_IS_FIXINCOME').val()==1){
                            if ($('#INPR_IS_FIXINCOME').val() == 1 && parseFloat($('#INAT_UNIT_PRICE_PCT').val()) == 0) {
                                $('#INAT_UNIT_PRICE_PCT').val(parseFloat($(self).find('INFA_UNIT_PRICE_PCT').text()));
                                //$('#INAT_INVEST_AMT').val(numDec(parseFloat($('#INAT_UNIT_PRICE_PCT').val()) * parseFloat($('#INAT_FACE_VALUE').val()) / 100, 2));
                            }
                            if ($('#INPR_IS_FIXINCOME').val() == 1) {
                                var curinve = parseFloat($('#INAT_INVEST_AMT').val());
                                // var curface = parseFloat($('#INAT_FACE_VALUE').val());
                                var ratio = parseFloat($('#INAT_FACE_VALUE').val()) / face;
                                //Ventas parciales
                                $('#INAT_VALORIZED_AMT').val(numDec(valor * ratio, 2));
                                $('#INAT_VALORIZED_GAIN_AMT').val(numDec(inat_valorized_gain_amt * ratio, 2));
                                $('#INAT_VALORIZED_LOSS_AMT').val(numDec(inat_valorized_loss_amt * ratio, 2));
                                //$('#INAT_AMORTIZED_AMT').val(numDec(parseFloat((inve-face)-amort)*ratio,2));
                                $('#INAT_AMORTIZED_AMT').val(numDec(parseFloat((inve - face)) * ratio, 2));
                                $('#INAT_ACCRUED_INT_AMT').val(numDec(accrued_int * ratio, 2));

                                // curinve = curinve * ratio;
                                $('#INAT_INVEST_AMT').val(numDec(curinve, 2));

                                //see infa for notes
                                var gain = numDec((curinve - (inve * ratio)), 2);
                                $('#INAT_GAIN_AMT').val(gain);

                            }

                            if ($('#INPR_IS_FIXINCOME').val() == 0 && parseFloat($('#INAT_UNIT_PRICE').val()) == 0) {
                                $('#INAT_UNIT_PRICE').val(parseFloat($(self).find('INFA_UNIT_PRICE').text()));
                                //$("#INAT_INVEST_AMT").val(parseFloat($("#INAT_UNIT_PRICE").val()) * parseFloat($("#INAT_SHARES").val()));
                            }
                            if ($('#INPR_IS_FIXINCOME').val() == 0) {
                                var ratio = parseFloat($('#INAT_SHARES').val()) / share;
                                $('#INAT_VALORIZED_AMT').val(numDec(valor * ratio, 2));
                                $('#INAT_VALORIZED_GAIN_AMT').val(numDec(inat_valorized_gain_amt * ratio, 2));
                                $('#INAT_VALORIZED_LOSS_AMT').val(numDec(inat_valorized_loss_amt * ratio, 2));
                                var curshares = parseFloat($('#INAT_SHARES').val());
                                var curprice = parseFloat($('#INAT_UNIT_PRICE').val());
                                var gain = numDec((curshares * (curprice - (inve / share))), 2);
                                $('#INAT_GAIN_AMT').val(numDec(gain, 2));


                            }
                            inatCalculateCashAmt();
                        }

                    });
                }
               });

    } else {
        $('#INAT_GAIN_AMT').val(0);
    }//end if operation

    inatFormatAllValues();
}


/*
 * Initialices all form values
 */

function inatInitAllValues() {

    //Init not numbers
    if (isNaN(parseFloat($('#INAT_CASH_AMT').val())) || ($('#INAT_CASH_AMT').attr('readonly') && parseFloat($('#INAT_CASH_AMT').val()) == 0))
    {
        $('#INAT_CASH_AMT').val(0);
    }
    if (isNaN(parseFloat($('#INAT_INVEST_AMT').val())) || $('#INAT_INVEST_AMT').attr('readonly'))
    {
        $('#INAT_INVEST_AMT').val(0);
    }
    if (isNaN(parseFloat($('#INAT_TAX_AMT').val())) || $('#INAT_TAX_AMT').attr('readonly'))
    {
        $('#INAT_TAX_AMT').val(0);
    }
    if (isNaN(parseFloat($('#INAT_TAX_AMT').val())) || $('#INAT_TAX_AMT').attr('readonly'))
    {
        $('#INAT_TAX_AMT').val(0);
    }
    if (isNaN(parseFloat($('#INAT_FEES_AMT').val())) || $('#INAT_FEES_AMT').attr('readonly'))
    {
        $('#INAT_FEES_AMT').val(0);
    }
    if (isNaN(parseFloat($('#INAT_AMORTIZED_AMT').val())) || $('#INAT_AMORTIZED_AMT').attr('readonly'))
    {
        $('#INAT_AMORTIZED_AMT').val(0);
    }
    if (isNaN(parseFloat($('#INAT_VALORIZED_AMT').val())) || $('#INAT_VALORIZED_AMT').attr('readonly'))
    {
        $('#INAT_VALORIZED_AMT').val(0);
    }
    if (isNaN(parseFloat($('#INAT_DISCOUNT_AMT').val())) || $('#INAT_DISCOUNT_AMT').attr('readonly'))
    {
        $('#INAT_DISCOUNT_AMT').val(0);
    }
    if (isNaN(parseFloat($('#INAT_PREMIUM_AMT').val())) || $('#INAT_PREMIUM_AMT').attr('readonly'))
    {
        $('#INAT_PREMIUM_AMT').val(0);
    }
    if (isNaN(parseFloat($('#INAT_SHARES').val())) || $('#INAT_SHARES').attr('readonly'))
    {
        $('#INAT_SHARES').val(0);
    }
    if (isNaN(parseFloat($('#INAT_UNIT_PRICE').val())) || $('#INAT_UNIT_PRICE').attr('readonly'))
    {
        $('#INAT_UNIT_PRICE').val(0);
    }
}//end method

/*
 * Format decimals on display
 */
function inatFormatAllValues() {

    $('#INAT_CASH_AMT').val(numDec($('#INAT_CASH_AMT').val(), 2));
    $('#INAT_INVEST_AMT').val(numDec($('#INAT_INVEST_AMT').val(), 2));
    $('#INAT_FACE_VALUE').val(numDec($('#INAT_FACE_VALUE').val(), 2));
    $('#INAT_DISCOUNT_AMT').val(numDec($('#INAT_DISCOUNT_AMT').val(), 2));
    $('#INAT_PREMIUM_AMT').val(numDec($('#INAT_PREMIUM_AMT').val(), 2));
    $('#INAT_GAIN_AMT').val(numDec($('#INAT_GAIN_AMT').val(), 2));
    $('#INAT_ACCRUED_INT_AMT').val(numDec($('#INAT_ACCRUED_INT_AMT').val(), 2));
    $('#INAT_TAX_AMT').val(numDec($('#INAT_TAX_AMT').val(), 2));
    $('#INAT_FEES_AMT').val(numDec($('#INAT_FEES_AMT').val(), 2));
    $('#INAT_SHARES').val(numDec($('#INAT_SHARES').val(), 5));
    $('#INAT_UNIT_PRICE').val(numDec($('#INAT_UNIT_PRICE').val(), 5));
    $('#INAT_AMORTIZED_AMT').val(numDec($('#INAT_AMORTIZED_AMT').val(), 2));
    $('#INAT_VALORIZED_AMT').val(numDec($('#INAT_VALORIZED_AMT').val(), 2));
    $('#INAT_INV_PERIOD').val(numDec($('#INAT_INV_PERIOD').val(), 0));

}//end function

function inatCalculateCashAmt() {
    var cash_amt = 0;
    var operation = $('#INAT_INVEST_ACTIVITY').val();
    if (operation == 'DIVAO' || operation == 'DIVEO' || operation == 'UEI' || operation == 'PA' || operation == 'DA' || operation == 'AVAL') {
        cash_amt = 0;
    } else if (operation == 'DIVA') {

        cash_amt = 0;

    } else if (operation == 'DIVE') {
        cash_amt = parseFloat($('#INAT_DIVIDEND_AMT').val());

    } else if (operation == 'PINT' || operation == 'PINTR' || operation == 'RD') {
        cash_amt = parseFloat($('#INAT_ACCRUED_INT_AMT').val()) -
            parseFloat($('#INAT_TAX_AMT').val()) -
            parseFloat($('#INAT_FEES_AMT').val());
        //Redentions
        if (operation == 'RD') {
            cash_amt += parseFloat($('#INAT_FACE_VALUE').val());
        }
    } else if (operation == 'SL' || operation == 'CA' || operation == 'VE') {
        cash_amt = (
            parseFloat($('#INAT_INVEST_AMT').val())
        )
            + parseFloat($('#INAT_ACCRUED_INT_AMT').val())
            -
            (parseFloat($('#INAT_TAX_AMT').val()) +
             parseFloat($('#INAT_FEES_AMT').val()));
    } else {
        cash_amt = (
            parseFloat($('#INAT_INVEST_AMT').val())
        ) +
            parseFloat($('#INAT_ACCRUED_INT_AMT').val()) +
            parseFloat($('#INAT_TAX_AMT').val()) +
            parseFloat($('#INAT_FEES_AMT').val());
    }
    $('#INAT_CASH_AMT').val(cash_amt);
    inatFormatAllValues();
}//end function

function inatTotalUnitPrice() {

    var operation = $('#INAT_INVEST_ACTIVITY').val();
    var inve_amt = parseFloat($('#INAT_UNIT_PRICE').val()) * parseFloat($('#INAT_SHARES').val());
    if (operation == 'DIVAO' || operation == 'DIVEO') {
        $('#INAT_DIVIDEND_AMT').val(inve_amt);
        $("#INAT_DIVIDEND_SHARES").val(parseFloat($("#INAT_SHARES").val()));
    } else {
        $('#INAT_INVEST_AMT').val(inve_amt);
    }
    if (operation == 'DIVA' || operation == 'DIVE') {
        //$('#INAT_ACCRUED_INT_AMT').val(inve_amt);
        $('#INAT_DIVIDEND_AMT').val(inve_amt);
        $("#INAT_DIVIDEND_SHARES").val(parseFloat($("#INAT_SHARES").val()));
    }
    $('#INAT_DISCOUNT_AMT').val(0);
    $('#INAT_PREMIUM_AMT').val(0);
    $('#INAT_UNIT_PRICE_PCT').val(0);
    $('#INAT_FACE_VALUE').val(0);

    inatSetGain();
    inatCalculateCashAmt();
    inatFormatAllValues();
}// End function

function inatTotalUnitPricePct() {

    $('#INAT_INVEST_AMT').val(numDec(parseFloat($('#INAT_UNIT_PRICE_PCT').val()) * parseFloat($('#INAT_FACE_VALUE').val()) / 100, 2));
    inatSetGain();
    setPremiumAndDiscount();
    inatCalculateCashAmt();
    inatFormatAllValues();
}// End function


function inatActivityProduct() {
    var inat = $('#INAT_INVEST_ACTIVITY').val();
    if (inat == '') {
        $('#4574').hide();//Discretioary Options
        return;
    }
    $.ajax({type: 'GET',
            url: 'window.php?to=DBQY&ac=QXML&no_menu=1&no_alerts=1&qy=INTT&fn=INTT.IDCODE&fv=' + inat,
            dataType: 'xml',
            async: false,
            success: function (xml) {
                $(xml).find('INTT').each(function () {
                    var self = this;
                    var fix = $(self).find('INTT_PROMPT_PROD_INFO').text();
                    //setting panel
                    if (fix == 1) {
                        $('#4574').show();//non fix
                    } else {
                        $('#4574').hide();//non fix
                    }

                });
            }
           });
    inatSetProductDetails();
}

function InatSetPositionDetails() {

    var port = $('#INAT_PORTFOLIO_CODE').val();
    var pos = $('#INAT_POSITION_NUMBER').val();
    if (pos == '') {
        return;
    }

    //Adding product values INPR_FORM
    $.ajax({type: 'GET',
            url: 'window.php?to=DBQY&ac=QXML&qy=INFA&no_menu=1&no_alerts=1&fn[]=INFA.POSITION_NUMBER&fv[]=' + pos + '&fn[]=INFA.PORTFOLIO_CODE&fv[]=' + port,
            dataType: 'xml',
            async: true,
            success: function (xml) {
                var invest_code = $(xml).find('INFA_INVESTMENT_CODE').text();
                if (invest_code) {
                    $('#INAT_INVESTMENT_CODE').val($(xml).find('INFA_INVESTMENT_CODE').text());
                    inatSetProductDetails();
                }

            }
           });
}

function inatSetProductDetails() {

    var inpr = $('#INAT_INVESTMENT_CODE').val();

    if (inpr == '') {
        return;
    }
    $('#INPR_INVESTMENT_CODE').val(inpr);
    
    //Adding product values INPR_FORM
    $.ajax({type: 'GET',
            url: 'window.php?to=DBQY&ac=QXML&no_menu=1&no_alerts=1&qy=INPR_FORM&fn=INPR.INVESTMENT_CODE&fv=' + inpr,
            dataType: 'xml',
            async: true,
            success: function (xml) {
                $(xml).find('INPR_FORM').each(function () {
                    var self = this;
                    //$('#INPR_IDNAME').val($(self).find('INPR_PRODUCTNAME_WRK').text());
                    $('#INPR_IDNAME').val($(self).find('INPR_IDNAME').text());
                    $('#INPR_PRODUCT_CODE').val($(self).find('INPR_PRODUCT_CODE').text());
                    $('#INPR_PRODUCT_CODE_prim').val($(self).find('INPR_PRODUCT_CODE').text());

                    //console.log("INPR_IS_FIXINCOME: "+$(self).find('INPR_IS_FIXINCOME').text());
                    //var is_fixincome_sql=$(self).find('INPR_IS_FIXINCOME').text();
                    $('#INPR_IS_FIXINCOME').val($(self).find('INPR_IS_FIXINCOME').text());
                    //obtengo el valor a deseleccionar de la lista
                    //var is_fixincome_actual = $('select[name="INPR_IS_FIXINCOME"]').val();

                    //deselecciono el valor actual en la lista
                    //$("#INPR_IS_FIXINCOME option[value='"+is_fixincome_actual+"']").attr("selected",false);
                    //selecciono el valor en la lista y que fue obtenido de la consulta query
                    //$("#INPR_IS_FIXINCOME option[value='"+is_fixincome_sql+"']").attr("selected",true);

                    $('#INPR_COUNTRY').val($(self).find('INPR_COUNTRY').text());
                    $('#INPR_INV_SECTOR').val($(self).find('INPR_INV_SECTOR').text());
                    $('#INPR_RATING').val($(self).find('INPR_RATING').text());
                    $('#INPR_INV_RISK_LEVEL').val($(self).find('INPR_INV_RISK_LEVEL').text());
                    $('#INPR_INVCRED_RATING').val($(self).find('INPR_INVCRED_RATING').text());
                    $('#INPR_ISSUE_DATE').val($(self).find('INPR_ISSUE_DATE').text());
                    if($('#INPR_IS_FIXINCOME').val()==1){
                        $('#INPR_MATURITY_DATE').val(toparseDate($(self).find('INPR_MATURITY_DATE').text()));
                    }else{
                        $('#INPR_MATURITY_DATE').val('');
                    }
                    if ($(self).find('INPR_CALC_INTEREST').text() == 1) {
                        $('input[name=INPR_CALC_INTEREST][value=1]').attr('checked', 'checked');
                    } else {
                        $('input[name=INPR_CALC_INTEREST][value=0]').attr('checked', 'checked');
                    }
                    $('#INPR_INTEREST_TYPE').val($(self).find('INPR_INTEREST_TYPE').text());
                    $('#INPR_INTEREST_CALC').val($(self).find('INPR_INTEREST_CALC').text());
                    $('#INPR_EARNING_PERIOD').val($(self).find('INPR_EARNING_PERIOD').text());
                    $('#INPR_PAYMENT_FREQ').val($(self).find('INPR_PAYMENT_FREQ').text());
                    $('#INPR_COUPON_RT').val($(self).find('INPR_COUPON_RT').text());
                    $('#INPR_ADJ_INDEX').val($(self).find('INPR_ADJ_INDEX').text());
                    $('#INPR_INVEST_CLASS').val($(self).find('INPR_INVEST_CLASS').text());
                    $('#INPR_SERIES_FROM').val($(self).find('INPR_SERIES_FROM').text());
                    $('#INPR_SERIES_TO').val($(self).find('INPR_SERIES_TO').text());
                    $('#INPR_EMISSION_NO').val($(self).find('INPR_EMISSION_NO').text());
                    $('#INPR_SEC_ISSUER').val($(self).find('INPR_SEC_ISSUER').text());
                    $('#INPR_SEC_ISSUER_secd').val($(self).find('INPR_SEC_ISSUER_NAME_WRK').text());
                    $('#INPR_SEC_ISSUER').val($(self).find('INPR_SEC_ISSUER').text());
                    $('#INPR_ISSUER_REL').val($(self).find('INPR_ISSUER_REL').text());
                    $('#INPR_SEC_TITLECODE').val($(self).find('INPR_SEC_TITLECODE').text());
                    $('#INPR_DEAL_TICKET_NO').val($(self).find('INPR_DEAL_TICKET_NO').text());
                    //$('#INAT_CUR_COUPON_SDATE').val($(self).find('INPR_FIRST_PYMNT_DATE').text());
                    $('#INPR_DENOMINATION_AMT').val(numDec(parseFloat($(self).find('INPR_DENOMINATION_AMT').text()), 2));
                    $('#INPR_PAY_DAY').val(numDec(parseFloat($(self).find('INPR_PAY_DAY').text()), 0));
                    if (isNaN($('#INPR_NO_PERIODS').val()) || $('#INPR_NO_PERIODS').val() == '0.00') {
                        $('#INPR_NO_PERIODS').val(0.00);
                    } else {
                        $('#INPR_NO_PERIODS').val(numDec(parseFloat($(self).find('INPR_NO_PERIODS').text()), 0));
                    }
                    $('#INPR_FIRST_PYMNT_DATE').val($(self).find('INPR_FIRST_PYMNT_DATE').text());
                    $('#INPR_DENOMINATION_AMT').val(numDec($(self).find('INPR_DENOMINATION_AMT').text(), 2));
                    $('#INPR_CUSIP').val($(self).find('INPR_CUSIP').text());
                    $('#INPR_ISIN').val($(self).find('INPR_ISIN').text());
                    $('#INPR_SYMBOL').val($(self).find('INPR_SYMBOL').text());
                    $('#INPR_RATING_AGENCY').val($(self).find('INPR_RATING_AGENCY').text());
                    inatSetInvPeriod();
                });
            }
           });
    //setting market type
    inatGetMarketType();
}

function inatSetFirstPayment() {
    //days from emision to
    if ($('#INPR_IS_FIXINCOME').val() == 0) {
        $('#INAT_CUR_COUPON_SDATE').val('');
        return;
    }

    if ($('#INAT_CUR_COUPON_SDATE').val() == '' && parseDate($('#INAT_CUR_COUPON_SDATE').val()) < parseDate($('#INAT_EFFTDATE').val())) {
        $('#INAT_CUR_COUPON_SDATE').val(
            ($('#INPR_PAYMENT_FREQ').val() == '99') ? '#INPR_MATURITY_DATE' : '#INAT_EFFTDATE'
        ).val();
    }
}

function inatSetInvPeriod() {

    //Calculating next cupon date
    var b = parseInt($('#INPR_PAYMENT_FREQ').val());

    inatSetFirstPayment();
    if (parseDate($('#INAT_CUR_COUPON_SDATE').val()) < parseDate($('#INAT_EFFTDATE').val())) {
        $('#INAT_CUR_COUPON_SDATE').val($('#INAT_EFFTDATE').val());
    }
    var a = days_between_360($('#INAT_EFFTDATE').val(), $('#INAT_CUR_COUPON_SDATE').val(), true);

    switch (b) {
        case 2:
            a = 180 - a;
            break;
        case 12:
            a = 30 - a;
            break;
        case 6:
            a = 60 - a;
            break;
        case 1:
            a = 360 - a;
            break;
        case 4:
            a = 120 - a;
            break;
        default:
            break;
             }

    if (isNaN(parseFloat(a))) {
        $('#INPR_ACCRUEDINT_DAYS').val(0);
    } else {
        $('#INPR_ACCRUEDINT_DAYS').val(a);
    }


    //INPR_CPN_COUNT
    a = days_between_360($('#INAT_EFFTDATE').val(), $('#INPR_MATURITY_DATE').val(), true);

    if (b == 0) {
        $('#INPR_CPN_COUNT').val(0);
    } else {
        //a = numDec((a/(360/b)),2);
        a = numDec((a / (360 / b)), 0);
        $('#INPR_CPN_COUNT').val(a);
    }

}



function inatYTMDPF() {
    //INPR_NO_PERIODS
    //INAT_YIELD_MATURITY
    var freq = $('#INPR_PAYMENT_FREQ').val();
    if (freq == '99' || freq == '52' || freq == '00' || freq == '26') {
        freq = 1;
    }

    var ytm = 0;
    var c = 0;
    var ytm_rt = 0;
    var factor = 1;
    var base = 1;
    var inat = $('#INAT_INVEST_ACTIVITY').val();
    if (inat == 'BY' || inat == 'BYT' || inat == 'APINV') {


        var no_periods = parseFloat($('#INPR_NO_PERIODS').val());// 30
        var interest = parseFloat($('#INPR_COUPON_RT').val());// int
        switch ($('#INPR_INTEREST_CALC').val()) {
            case 'AC/360':
                base = 360;
                break;
            case 'AC/365':
                base = 365;
                break;
            default:
                base = parseFloat($('#INPR_INTEREST_CALC').val());// 360
                if (isNaN(base)) {
                    base = 0;
                }
                break;
                                              }
        var amt = parseFloat($('#INAT_FACE_VALUE').val());
        var period_type = $('#INPR_PERIOD_TYPE').val();//d, y

        switch (period_type) {
                /*case 'Y':
             break;*/
            default:
                factor = 1;
                break;
                           }
        /*H Hours
         D Days
         W Weeks
         M Months
         Q Quarters
         S Semesters
         Y Years*/


        ytm = amt * ((interest / factor) / 100) * (no_periods / base);
        if (isNaN(parseFloat(ytm))) {
            ytm = 0;
        }
    }


    c = 0;
    //ytm_rt = ytm;
    $('#INAT_COUPON_AMT').val(numDec(c, 2));
    $('#INAT_YIELD_MATURITY').val(numDec(ytm, 2));
    $('#INAT_YIELD_RT').val(numDec(ytm_rt * 100, 5));
    $('#INAT_YIELD_RT').val(numDec(ytm, 2));



}

function inatYTM() {


    var sdate = $('#INAT_EFFTDATE').val();
    var mdate = $('#INPR_MATURITY_DATE').val();
    var p = parseFloat($('#INAT_INVEST_AMT').val());
    var f = parseFloat($('#INAT_FACE_VALUE').val());//
    var pr = (p / f) * 100;
    var rt = parseFloat($('#INPR_COUPON_RT').val());
    var freq = $('#INPR_PAYMENT_FREQ').val();
    if (freq == '99' || freq == '52' || freq == '00' || freq == '26') {
        freq = 1;
    }

    freq = parseFloat(freq);

    var c = parseFloat(((parseFloat($('#INPR_COUPON_RT').val()) / 100) * parseFloat($('#INAT_FACE_VALUE').val())));//cupon
    $('#INAT_COUPON_AMT').val(numDec(c, 2));
    var url = 'window.php?to=FINN&ac=YTM&sdate=' + sdate + '&mdate=' + mdate + '&rt=' + rt + '&rd=100&pr=' + pr + '&freq=' + freq;
    $.ajax({type: 'GET',
            url: url,
            dataType: 'text',
            async: true,
            success: function (data) {
                data = parseFloat(data);
                if (isNaN(data)) {
                    data = 0.00;
                }
                $('#INAT_YIELD_MATURITY').val(numDec(data / 100, 5));
                $('#INAT_YIELD_RT').val(numDec(data, 7));
            }
           });

    /*Yield for premium only */
    url = 'window.php?to=FINN&ac=YTM&sdate=' + sdate + '&mdate=' + mdate + '&rt=0&rd=' + f + '&pr=' + p + '&freq=' + freq;
    $.ajax({type: 'GET',
            url: url,
            dataType: 'text',
            async: true,
            success: function (data) {
                if (isNaN(data)) {
                    data = 0;
                }
                $('#INAT_PD_YIELD_RT').val(numDec(data, 7));
            }
           });
}


function inatGetPortfolioType()
{
}
function inatInitLists()
{
}