<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Creb {

    function __construct($procParameters = array()) {
        multiTableName($this, array('CREB'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->je_source = '';
    }

    /**
     * Validate record information
     * Executed on table validate
     *
     * @param array $record
     * @param array $msg
     */
    function validate_form(&$record, &$msg) {
        if (empty($record['CREB_LOAN_INTEREST'])) {
            $msg['CREB_LOAN_INTEREST'] = smsg('MSG-198');
        }
    }

}
