<?php

/**
 * Auto generated code file from embeded sources. Changes will be lost.
 * For more information contact  support@alenet.com
 * @since        $Date: 2015-09-28 09:47:35
 */
function validateAccoFieldCode(&$record, &$msg) {
    $data = array('format' => $record['IDCO_IDCODE_FORMAT']);
    $a = new clx_validate_code($data);
    $a->check('IDCO_LAST_IDCODE', $record, $msg, $form);
   
}

/**
 * Fix next idcode
 */
function fix_next_idcode($execute = false) {

    if (!function_exists('setCreationData')) {
        includeCodeLib('GEN_REC_UTIL');
    }
    $local_base_idcodes = array();
    $contents = '';
    $table_open = '<table border=1>';
    $table_close = '</table>';
    $tr_open = '<tr>';
    $tr_close = '</tr>';
    $td_open = '<td>';
    $td_close = '</td>';
    $bold_open = '<b>';
    $bold_close = '</b>';
    $newline = '<br />';

    $final_sql_script = 'CLX FIX_NEXT_IDCODE' . CLX_CHAR_NL;
    $final_sql_script .= ' * Date: ' . date('Y-m-d H:i:s') . '';
    $final_sql_script .= CLX_CHAR_NL;
    $final_sql_script .= ' * Server: ' . kDatabaseDisplay . '@' . UserRequest::$server['HTTP_HOST'];
    $final_sql_script .= CLX_CHAR_NL;
    $final_sql_script .= ' * Excecute SQLs: ' . ($execute ? 'Yes' : 'NO ');

    $contents .= str_replace(CLX_CHAR_NL, $newline, $final_sql_script);
    $contents .= str_repeat($newline, 2);

    $final_sql_script = '/*' . $final_sql_script . '*/' . CLX_CHAR_NL;
    $contents .= $table_open;
    $contents .= $tr_open;
    $contents .= $td_open . 'TABLE' . $td_close;
    $contents .= $td_open . 'FORMAT' . $td_close;
    $contents .= $td_open . 'PREVIOUS VALUE' . $td_close;
    $contents .= $td_open . 'NEW VALUE' . $td_close;
    $contents .= $td_open . 'TRIES' . $td_close;
    $contents .= $td_open . 'OTHER INFO' . $td_close;
    $contents .= $tr_close;
    $contents .= $tr_open . '<td colspan=6>&nbsp;</td>' . $tr_close;


    $idco_sql = 'SELECT IDCO.ID, IDCO.TABLECODE, IDCO.LAST_IDCODE, IDCO.IDCODE_FORMAT, IDCO.INCREMENTS, IDCO.CDATE, IDCO.MDATE FROM BASE_IDCODES IDCO ORDER BY IDCO.TABLECODE';
    $idco_records = ClxCommon::$db->executeQuery($idco_sql);
    while ($idco_record = ClxCommon::$db->getNextRecord($idco_records, ASSOCIATIVE)) {

        $this_tablename = tableName($idco_record['TABLECODE']);
        $loop_counter = 0;
        $col1_tab_code = $idco_record['TABLECODE'];
        $col1_format = $idco_record['IDCODE_FORMAT'];
        $col2_prev_val = $idco_record['LAST_IDCODE'];
        $col3_new_val = '&nbsp;';
        $col4_tries = '&nbsp;';
        $col5_msg = '&nbsp;';
        $max_idcode = CLX_CHAR_EMPTY_STRING;

        if ($this_tablename == '' || $this_tablename == '_') {
            $col5_msg = $bold_open . 'WARNING: Table doesn´t exist' . $bold_close;
        } elseif (!ClxCommon::$db->fieldExists($this_tablename, 'IDCODE')) {
            $col5_msg = $bold_open . 'WARNING: Column IDCODE doesn´t exist in Table ' . $idco_record['TABLECODE'] . $bold_close;
        } else {
            $sql = 'SELECT COUNT(*) NUM_RECS FROM ' . $this_tablename;
            $record = ClxCommon::$db->getOneRecord($sql);
            if (empty($record)) {
                $col5_msg = $bold_open . 'Couldn´t count records ????' . $bold_close;
            } elseif ($record['NUM_RECS'] == 0) {
                // Empty Table, so initialize counter
                $s_idcode = str_replace('#', '0', $idco_record['IDCODE_FORMAT']);

                //Setting New ID Codes Entry
                $col3_new_val = $s_idcode;
                $col4_tries = $loop_counter;
                $col5_msg = $bold_open . "Re-started from zero because table is empty" . $bold_close;
            } else {
                // Look for las IDCODE for table X
                if (!isset($local_base_idcodes[$idco_record['TABLECODE']])) {
                    $sql = 'SELECT * FROM BASE_IDCODES WHERE TABLECODE = ' . singleQuote($idco_record['TABLECODE']);
                    $idco_record_2 = ClxCommon::$db->getOneRecord($sql);
                    $local_base_idcodes[$idco_record['TABLECODE']] = $idco_record_2;
                }
                $idco_record_2 = $local_base_idcodes[$idco_record['TABLECODE']];

                // Verify if maximun IDCODE on table is less than Last IDCODE registered
                $sql = 'SELECT MAX(IDCODE) IDCODE FROM ' . $this_tablename;
                $record = ClxCommon::$db->getOneRecord($sql);
                $do_interaction = true;
                if (!empty($record)) {
                    $max_idcode = $record['IDCODE'];

                    // Verifica si el formato es todo numerico y el maximo IDCODE de la tabla no lo es...
                    if (format_is_all_numeric($idco_record_2['IDCODE_FORMAT']) && !all_numeric($max_idcode)) {
                        $sql = "SELECT MAX(0+IDCODE) IDCODE FROM " . $this_tablename . " WHERE IDCODE REGEXP '^[0-9]+$'";
                        $record = ClxCommon::$db->getOneRecord($sql);
                        if (!empty($record)) {
                            // Este es el maximo pero totalmente numerico
                            $max_idcode = $record['IDCODE'];
                        }
                    }

                    if (have_any_number($max_idcode)) {
                        if ($max_idcode < $idco_record_2['LAST_IDCODE']) {
                            $col3_new_val = $max_idcode;
                            $col4_tries = $loop_counter;
                            $col5_msg = $bold_open . 'NOTICE: Max IDCODE ' . $col3_new_val . ' from Table ' . $idco_record['TABLECODE'] . ' is less than Last IDCODE ' . $idco_record_2['LAST_IDCODE'] . $bold_close;
                            $do_interaction = false;
                        } elseif ($max_idcode >= $idco_record_2['LAST_IDCODE']) {
                            $col3_new_val = $max_idcode;
                            $col4_tries = $loop_counter;
                            $do_interaction = false;
                        }
                    }
                }

                if ( $do_interaction == true) {
                    while (TRUE) {
                        $idco_record_2 = $local_base_idcodes[$idco_record['TABLECODE']];
                        // Look for next IDCODE stored en IDCO in table X
                        $sql = 'SELECT IDCODE FROM ' . $this_tablename . ' WHERE IDCODE =  ' . singleQuote($idco_record_2['LAST_IDCODE']);
                        $record = ClxCommon::$db->getOneRecord($sql);

                        if (empty($record)) {
                            // IDCODE doesn´t exist, so it´s done with table X
                            $col3_new_val = $idco_record_2['LAST_IDCODE'];
                            $col4_tries = $loop_counter;
                            break;
                        } else {
                            $record['IDCODE'] = 'AUTO';
                            setCreationIdCode_Local($local_base_idcodes, $contents, $record, $idco_record['TABLECODE'], false);
                            $loop_counter++;
                        }
                    }
                }
            }
        }

        $different = ($col2_prev_val <> $col3_new_val);

        if ($col3_new_val != '&nbsp;' && $different) {

            $sql = 'UPDATE BASE_IDCODES SET LAST_IDCODE = ' . singleQuote($col3_new_val) . ', MDATE = ' . singleQuote(xFormat::getNow()) . ' WHERE TABLECODE = ' . singleQuote($col1_tab_code);
            if ($execute) {
                ClxCommon::$db->executeQuery($sql);
            }
            $final_sql_script .= $sql . ';' . CLX_CHAR_NL;
        }

        if ($max_idcode != '') {
            $col5_msg = 'Max IDCODE = ' . $max_idcode . ($col5_msg != 'nbsp;' ? $newline : CLX_CHAR_EMPTY_STRING) . $col5_msg;
        }
        $contents .= $tr_open;
        $contents .= $td_open . $col1_tab_code . $td_close;
        $contents .= $td_open . $col1_format . $td_close;
        $contents .= $td_open . $col2_prev_val . $td_close;
        $contents .= $td_open . ($different ? $bold_open : "") . $col3_new_val . ($different ? $bold_close : "") . $td_close;
        $contents .= $td_open . $col4_tries . $td_close;
        $contents .= $td_open . $col5_msg . $td_close;
        $contents .= $tr_close;
    }

    $contents .= $table_close;
    $contents .= $newline;
    $contents .= str_replace(CLX_CHAR_NL, $newline, $final_sql_script);
    return $contents.'<br>';
}

function setCreationIdCode_Local(&$local_base_idcodes, &$contents, &$record, $tablecode, $execute) {//Creating new IDCode
    if (array_key_exists('IDCODE', $record)) {
        $record = array_change_key_case($record, CASE_UPPER);
        if (trim(uppercase($record['IDCODE'])) == 'AUTO')
            $record['IDCODE'] = 'NEW';

        if (empty($tablecode) || $record['IDCODE'] <> 'NEW')
            return $record;
        if (ClxCommon::$db->oneExistsRecords('BASE_IDCODES', 'TABLECODE= ' . singleQuote($tablecode)) > 0) {
            if ($execute) {
                $sql = 'SELECT * FROM BASE_IDCODES WHERE TABLECODE = ' . singleQuote($tablecode) . ' FOR UPDATE';
                $crec = ClxCommon::$db->getOneRecord($sql);

                $record['IDCODE'] = getIdcode($crec['IDCODE_FORMAT'], $crec['LAST_IDCODE'], $crec['INCREMENTS']);

                //Setting New ID Codes Entry
                ClxCommon::$db->updateRecord($idco_tablename, array('LAST_IDCODE' => $record['IDCODE'], 'CDATE' => $crec['CDATE'], 'MDATE' => xFormat::getNow()), 'ID=' . $crec['ID']);
            } else {
                if (!isset($local_base_idcodes[$tablecode])) {
                    $sql = 'SELECT * FROM BASE_IDCODES WHERE TABLECODE = ' . singleQuote($tablecode);
                    $crec = ClxCommon::$db->getOneRecord($sql);
                    $local_base_idcodes[$tablecode] = $crec;
                } else {
                    $crec = $local_base_idcodes[$tablecode];
                }
                $record['IDCODE'] = getIdcode($crec['IDCODE_FORMAT'], $crec['LAST_IDCODE'], $crec['INCREMENTS']);
                $local_base_idcodes[$tablecode]['LAST_IDCODE'] = $record['IDCODE'];
                $local_base_idcodes[$tablecode]['MDATE'] = xFormat::getNow();
            }
        }
    }
    return $record;
}

//end function

function have_any_number($s_idcode) {
    return preg_match('#[0-9]#', $s_idcode);
}

function all_numeric($s_idcode) {
    return ('' . ($s_idcode * 1)) ? true : false;
}

function format_is_all_numeric($format) {
    return all_numeric(str_replace('#', '9', $format));
}
