<?php 
/**
* Auto generated event file. Changes will be lost.
* For more information contact  support@alenet.com
* @since        $Date: 2023-12-29 13:59:46 
*/

//Creating Contract Transaction
//STORE OPERATION TYPE FOR LATER

$oper_type = $record['PRES_OPERATION_TYPE'];
unset($record['PRES_OPERATION_TYPE']);
$record['BATCH_ID'] = $parameters['CUST_FILEID'];
$record['JE_SOURCE'] = 'PRSO';

$fiat = new Fiat();
$record['IDCODE'] = $fiat->fiat_build($record['COMP_CODE'], 
				$record['TRANSTBL_CODE'], 
				$record['CHART_FIELD01'], 
				$record['CHART_FIELD02'], 
				$record['TRANS_AMT'], 
				$record);
$record['PRES_OPERATION_TYPE'] = $oper_type;
unset($fiat, $oper_type);

// CREANDO TRANSACCION DE PREVISION

$sql = 'INSERT INTO FIDU_TRANS_DISTRIBUTIONS
	(TRANS_CODE,
	CHART_FIELD01,
	CHART_FIELD02,
	PARTICIPATION_AMT,
	CDATE,
	MDATE,
	CREATEDBY,
	MODIFIEDBY)
SELECT DISTINCT
	'. singleQuote($record['IDCODE']) .' TRANS_CODE,
	PRSO.CONTRACT_CODE CHART_FIELD01,
	ACCO.IDCODE CHART_FIELD02,
	PRSO.TRANS_AMT PARTICIPATION_AMT,
	PRSO.CDATE,
	PRSO.MDATE,
	PRSO.CREATEDBY,
	PRSO.MODIFIEDBY
FROM 
	FIDU_CONTRACTS FICO,
	FIDU_PARTICIPANTS FIPA,
	CRM_ACCOUNTS ACCO,
	PRSO_SAV_BENEFICIARIES PRSO, 
	FIDU_ITEMS FIAS,
	FIDU_BANK_ACCOUNTS FIBK,
	CRM_PRODUCTS PROD,
	PRSO_PLAN_PRMTRS_TBL PRPT
WHERE 
	FIAS.CONTRACT_CODE = PRSO.CONTRACT_CODE
	AND FICO.IDCODE = FIAS.CONTRACT_CODE
	AND FIAS.FIDU_BANKACT_CODE = FIBK.BANK_ACCOUNT_NO
	AND FIPA.CONTRACT_CODE = FICO.IDCODE
	AND FIPA.ACCOUNTCODE = ACCO.IDCODE
	AND ACCO.IDENTIFICATION =PRSO.IDENTIFICATION /* CONCAT(PRSO.LEGAL_TYPE,PRSO.IDENTIFICATION)*/
	AND PROD.IDCODE = FIBK.BANK_PROD_CODE
	AND PRSO.CUST_FILEID = '. singleQuote($parameters['CUST_FILEID']) .'
	AND PRSO.REC_STATUS = '. singleQuote('RUN') .'
	AND PRSO.PRES_OPERATION_TYPE = '. singleQuote($record['PRES_OPERATION_TYPE']) .'
	AND PRSO.PRES_OPERATION_TYPE IN ('. singleQuote('AP') .','. singleQuote('AM').','. singleQuote('IN'). ')
	AND PRPT.GL_PER_FIPA = 1
	AND PRPT.CONTRACT_CODE = PRSO.CONTRACT_CODE
	AND PRPT.CLX_EFFTDATE = (SELECT MAX(X.CLX_EFFTDATE)
			FROM PRSO_PLAN_PRMTRS_TBL X
			WHERE X.CONTRACT_CODE = PRPT.CONTRACT_CODE 
				AND X.CLX_EFFTDATE <= CURDATE())
	AND PRSO.TRANS_AMT > 0';

echo $sql;
ClxCommon::$db->executeQuery($sql);

 
if($record['PRES_OPERATION_TYPE']=='AP' || $record['PRES_OPERATION_TYPE']=='AM'  || $record['PRES_OPERATION_TYPE']=='IN') {
  $texto='Ajusting distribution for fiat.idcode: '.$record['IDCODE'].'<Br>';
  echo $texto;
  $a = new Fiat();
  $a->fiat_save_form($record);
}
