<?php

/**
 * System wide utilities
 * For more information contact  support@alenet.com
 *
 * @author       $Author: cramirez $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2018-12-29 00:00:08 +0000 (Sat, 29 Dec 2018) $
 * @version    	$Rev: 10429 $
 */
function ConnectToDatabase() {
    $type = capitalize(kDatabaseType) . 'Database';
    if (!class_exists($type)) {
        include_once kPathToWebSite . 'classes/' . $type . '.php';
        if (!class_exists($type)) {
		  echo 'Class ', $type, ' not found';
		  salir();
        }
    }
	IF(isset($GLOBALS['PIPE_PROCESS']) &&$GLOBALS['PIPE_PROCESS']==1 && kDatabaseType<>'oci' ){
		ClxCommon::$db = new $type(str_replace($GLOBALS["PIPE_PROCESSBD"][0],$GLOBALS["PIPE_PROCESSBD"][1],kDatabaseURL), kDatabaseUsername, kDatabasePassword, kDatabaseName);
			
	}
	else
  	  ClxCommon::$db = new $type(kDatabaseURL, kDatabaseUsername, kDatabasePassword, kDatabaseName);
	IF (ISSET($_GET["ADDRDEBUG_X_Y_01"])) { ECHO kDatabaseURL,",",kDatabaseUsername,",",kDatabasePassword," ";}
    ClxCommon::$db->connectToDatabase();
    ClxCommon::$db->selectDatabase();
    
	if (kDatabaseType !== 'oci') {
		ClxCommon::$db->executequery('set sql_mode="NO_ENGINE_SUBSTITUTION"');//ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,ERROR_FOR_DIVISION_BY_ZERO,
	##	ClxCommon::$db->executequery('set global sql_mode="NO_ENGINE_SUBSTITUTION"');
	##	ClxCommon::$db->executequery('set innodb_strict_mode = 0');
	}
	
    ClxCommon::$db->setAutocommit(false);
}
if (function_exists('register_shutdown_function') && function_exists('cierre_final') ){
	register_shutdown_function('cierre_final');
}
function cierre_final() {
$tta=fopen(kPathToWebSite."/".kPathToTemp."archivoFINAL.txt","a+");fwrite($tta,chr(13).chr(10)."4-hora:".date("h:i:s d/m/Y").chr(13).chr(10));
		FCLOSE($tta);
return;
	if (ClxCommon::$db->tableExists('CLX_DEFAULT_SQL_COMPANY')) {
		ClxCommon::$db->executequery('TRUNCATE TABLE CLX_DEFAULT_SQL_COMPANY');
		ClxCommon::$db->executequery('COMMIT');
		$tta=fopen(kPathToWebSite."/".kPathToTemp."archivoFINAL.txt","a+");fwrite($tta,chr(13).chr(10)."4-hora:".date("h:i:s d/m/Y").chr(13).chr(10));
		FCLOSE($tta);
	}
}

function PrepareConstants() {
    //Init additional options if required
}
function loadDbnOptions($kDatabase) {

    	/*if (UserRequest::getCookieField('dbn', FILTER_SANITIZE_NUMBER_INT) >= CLX_NUM_ZERO) {
        ClxCommon::$dbn = UserRequest::getCookieField('dbn', FILTER_SANITIZE_NUMBER_INT);
    }*/
    ClxCommon::$dbn = UserRequest::getCookieField('dbn', FILTER_DEFAULT);

    if (array_key_exists('dbn', UserRequest::$request) && intval(UserRequest::$request['dbn']) >= 0) {
        ClxCommon::$dbn = intval(UserRequest::$request['dbn']);
    }

    if (empty(ClxCommon::$dbn)) {
        ClxCommon::$dbn = 0;
    }

    if(!defined('kDatabaseNo')) define('kDatabaseNo', ClxCommon::$dbn);
    if(!defined('kDatabaseDisplay')) define('kDatabaseDisplay', $kDatabase[kDatabaseNo][CLX_NUM_ZERO]);
    if(!defined('kDatabaseType')) define('kDatabaseType', $kDatabase[kDatabaseNo][1]);
    if(!defined('kDatabaseURL')) define('kDatabaseURL', $kDatabase[kDatabaseNo][2]);
    if(!defined('kDatabaseName')) define('kDatabaseName', $kDatabase[kDatabaseNo][3]);
    if(!defined('kDatabaseUsername')) define('kDatabaseUsername', $kDatabase[kDatabaseNo][4]);
    if(!defined('kDatabasePassword')) define('kDatabasePassword', $kDatabase[kDatabaseNo][5]);
    if(!defined('kDatabasePermanent')) define('kDatabasePermanent', (empty($kDatabase[kDatabaseNo][CLX_NUM_SIX])) ? 0 : 1);
    if(!defined('kDatabaseCharset')) define('kDatabaseCharset', (empty($kDatabase[kDatabaseNo][7])) ? 0 : $kDatabase[kDatabaseNo][7]);
    ClxCommon::$cached['kDatabase'] = $kDatabase;
    if (!defined('kSpaceName')) {
        define('kSpaceName', kDatabaseURL . '.' . kDatabaseName);
    }
}

function initTools() {
    require_once kPathToWebSite . 'tools/sys_parameters.php';
    //Define if mobile
    if (!defined('kMobileClient')) {
        if (is_mobile()) {
		  define('kMobileClient', true);
        } else {
		  define('kMobileClient', false);
        }
    }
    if (!defined('kDefaultIsCron')) {
        define('kDefaultIsCron', CLX_NUM_ZERO);
    }
    if (!defined('CLX_WEBSERVICE_EXEC')) {
        ////webservice necesita trabajar con token de sesion antes de iniciarla.
        $session = new ClxSession();
    }
    if (!defined('kAppDev') || !kAppDev) {
        $BUGS = &getTool('BUGS');
		set_error_handler(array($BUGS, 'autoreport'));
        unset($session);
    }
}

/**
 * Used by cron engines
 */
function initToolsCron() {
    // Name of the default skin
    if (!defined('kDefaultIsCron')) {
        define('kDefaultIsCron', CLX_NUM_ONE);
    }

    require_once kPathToWebSite . 'tools/sys_parameters.php';
    //turn off menus and alerts for batch process
    define('clxDisplayNoMenus', CLX_NUM_ONE);
    define('clxDisplayNoAlerts', CLX_NUM_ONE);
    $BUGS = &getTool('BUGS');
    $BUGS->alertlevel = CLX_INIT_ZERO; // Alert the user
    $BUGS->savelevel = CLX_INIT_ZERO; // Save to the database
    $BUGS->dielevel = CLX_INIT_ZERO; // Die level
    set_error_handler(array($BUGS, 'autoreport'));
}

function getCurrentScript() {
    return UserRequest::$server['PHP_SELF'];
}

function CurrentSkin() {
    if (!defined('kMobileClient')) {
        if (is_mobile()) {
		  define('kMobileClient', true);
        } else {
		  define('kMobileClient', false);
        }
    }
    if (defined('kDefaultSkin')) {
        if (kMobileClient) {
		  $skn = kDefaultSkinMobile;
        } else {
		  $skn = kDefaultSkin;
        }
    } else {
        $skn = 'default';
    }
    if (isset(UserRequest::$cookies['skn'])) {
        $skn = UserRequest::$cookies['skn'];
    }
    if (isset(UserRequest::$post['skn'])) {
        $skn = UserRequest::$post['skn'];
    }
    if (isset(UserRequest::$get['skn'])) {
        $skn = UserRequest::$get['skn'];
    } //Added for eibs
    if (isset($_SESSION['skn'])) {
        $skn = $_SESSION['skn']; //Added for eibs
    }
    return $skn;
}

/**
 * Performs encription
 * @param type $string_value
 * @return type
 */
function clx_mcript($string_value) {
    return password_hash($string_value, PASSWORD_DEFAULT);
}

/**
 * Verify hash
 * @param type $input
 * @param type $hash
 */
function clx_mcript_verify($input, $hash) {
    return (password_verify($input, $hash) === true) ? true : false;
}

/**
 * Changes the language and skin options
 */
function changeLanguage() {
    if (isset(UserRequest::$request['lan'])) {
		$_SESSION['prefs']['LANGUAGE'] = clx_language_lower_upper(UserRequest::$request['lan']);
    }
    if (isset(UserRequest::$request['skn'])) {
        $_SESSION['skin'] = UserRequest::$request['skn'];
    }
}

function setIfmOpener() {

    $_SESSION['iframeMain'] = CLX_NUM_ONE;
    $PAGE_VARIABLES['PAGE_TITLE'] = dict('GEN_LBL_PAGETITLE');
    $PAGE_VARIABLES['MENUS'] = (defined('clxDisplayNoMenus')) ? '' : pageMenus();
    $PAGE_VARIABLES['CONTENTS'] = '';
    if (!empty(UserRequest::$server['SERVER_PORT_SECURE'])) {
        $PAGE_VARIABLES['REQ_URI'] = 'https://';
    } else {
        $PAGE_VARIABLES['REQ_URI'] = 'http://';
    }
    $PAGE_VARIABLES['REQ_URI'] .= UserRequest::$server['HTTP_HOST']/* . ':' . UserRequest::$server['SERVER_PORT'] */ . UserRequest::$server['REQUEST_URI'];
    return getSkinForm('ifmOpener.html', $PAGE_VARIABLES);
}

/**
 * Main function where logins are requested
 *
 */
function clxMain($template_name = 'master.html', $no_login = false, $attach_messages = true) {
	try {

        $prev_req = (!empty($_SESSION['PREV_REQ']))?$_SESSION['PREV_REQ']:'';
        $contents = '';
        $stime = microtime_float();
        $ACUS = &getTool('ACUS');
        $ACUS->login();
        if(!empty($prev_req)){
		  $_SESSION['PREV_REQ'] = $prev_req;
        }
		changeLanguage(); //Set Language
        $PAGE_VARIABLES = getVariables();
        UserRequest::getLookUpValues();

        if (!empty(UserRequest::$request['no_menu']) && !defined('clxDisplayNoMenus')) {
		  define('clxDisplayNoMenus', 1);
        }
        if (!empty(UserRequest::$request['no_alerts']) && !defined('clxDisplayNoAlerts')) {
		  define('clxDisplayNoAlerts', 1);
        }
        $action = UserRequest::$server['PHP_SELF'];
        $idlist = getIdlist();
        //pop up
		
		apc_cache_get_tables_queries();
		apc_cache_get_tables_names();
        if (array_key_exists('pop', UserRequest::$request)) {

		  $pop = UserRequest::$request['pop'];
		  for ($i = CLX_INIT_ZERO; $i < $pop; $i++) {
			 $info = popHistory();
			 if (array_key_exists('idlist', $info)) {
			     $idlist = toArray($info['idlist']);
			 }
		  }
		  foreach ($info as $key => $value) {
			 UserRequest::$request[$key] = $value;
		  }
        }
        
		$to = (array_key_exists(CLX_PROP_TO, UserRequest::$request)) ? UserRequest::$request[CLX_PROP_TO] : '';
		if ( isset($_SESSION["_dEBUG"]) ) { 
			$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");fwrite($tta,chr(13).chr(10)."4-hora:".date("h:i:s d/m/Y").chr(13).chr(10));
			fwrite($tta,chr(13).chr(10)."to: ".$to.chr(13).chr(10));$te=debug_backtrace();
			for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"]))fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}fclose($tta);
		}	
        if (!empty($_SESSION['PREV_REQ']) && ClxCommon::sessionHasUser()) {
		  $redirect_to = $_SESSION['PREV_REQ'];
		  unset($_SESSION['PREV_REQ']);
		  header('location: ' . $redirect_to);
		  salir(CLX_NUM_ZERO);
        } elseif (ClxCommon::sessionHasUser() && !empty($to)) {
		  $ac = (array_key_exists('ac', UserRequest::$request)) ? UserRequest::$request['ac'] : '';
		  //Save history from forms that is required to search lists
		
			
		  if (array_key_exists('main', UserRequest::$get) && UserRequest::$get['main'] === 'SETPRENTINF') {
			 setParentForm(UserRequest::$post);
			 salir(CLX_NUM_ZERO);
		  }
		  if (array_key_exists('main', UserRequest::$get) && UserRequest::$get['main'] === 'UNSETPRENTINF') {
			 unsetParentForm();
			 salir(CLX_NUM_ZERO);
		  }
		  //Clear search listing history if not list. Note that uset and set are no $to=edit
		  //that is why it must run latter
		  if ($to === 'FINN') {//run financial opciones
			 return financial_tools($ac);
		  }
		  //Ijamc 12-11-2015
		  //llamada desde util.js
		  //limpieza del pop.php la historia
		  //$request['ventanapop'] =nÃºmero de ventatana actual abierta
		  //			      que se esta cerrando (=parent.activeWindow)
			
			if ( isset($_SESSION["_dEBUG"]) ) {	$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");	fwrite($tta,chr(13).chr(10)."4-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,chr(13).chr(10)."to: ".$to.chr(13).chr(10));$te=debug_backtrace();			for ($t=0;$t<18;$t++) {	if (isset($te[$t]["file"]))fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}fclose($tta);			}	
		 
		  
		  
		  
		if ($to == 'POPCLEAR') {
			 $hkey = 'pop';
			 $ini = UserRequest::$request['ventanapop'] - CLX_NUM_ONE;
			 $max = (!isset($_SESSION['history']['pop']) ? 0 : count($_SESSION['history']['pop'])) - CLX_NUM_ONE;
			 for ($t = $max; $t >= $ini; $t--) {
			     array_splice($_SESSION['history']['pop'], CLX_NUM_MINUS_1, CLX_NUM_ONE);
			 }
		  } else {
			if (!empty($to)) {
				$tool = &getTool($to);
				//if (!empty($idlist)) {
					$contents = $tool->action($ac, $idlist);
					unset($tool);
				//}	
			}	
		  }
        } elseif (ClxCommon::sessionHasUser()) {
		  clearHistory();  //Clearing History on Index Page.
		  clearParentForm(); //clearing form history
		  $PAGE_VARIABLES['PAGE_TITLE'] = dict('GEN_LBL_PAGETITLE');
		  $UIPG = &getTool('UIPG');
		  $contents = $UIPG->action('DEF_PAGE', array());
        } elseif ($no_login === true) {
		  $variables = array();
		  $contents = '';
        } elseif (isset(UserRequest::$request['timeout'])) {
		  $PAGE_VARIABLES['PAGE_TITLE'] = dict('GEN_LBL_TIMEOUT');
		  $variables = array();
		  $variables['ACTION'] = $action;
		  $variables['USERNAME'] = '';
		  $variables['MSG'] = dict('GEN_LBL_SESSIONTIMEOUT');
		  $contents = getSkinForm('login.html', $variables);
        } elseif (isset(UserRequest::$post['username'])) {
		  $PAGE_VARIABLES['PAGE_TITLE'] = dict('GEN_ERR_USERNAME_INVALID');
		  $variables = array();
		  $variables['ACTION'] = $action;
		  $variables['USERNAME'] = UserRequest::$post['username'];
		  $variables['MSG'] = $ACUS->get_login_msg();
		  $contents = getSkinForm('login.html', $variables);
        } else {
		  $PAGE_VARIABLES['PAGE_TITLE'] = dict('GEN_LBL_PAGETITLE');
		  $variables = array();
		  $variables['ACTION'] = $action;
		  $variables['USERNAME'] = '';
		  $variables['MSG'] = $ACUS->get_login_msg();
		  //store next request login
		  if (!empty(UserRequest::$get)) {
			 $url = $action . '?';
			 $comma = '';
			 foreach (UserRequest::$get as $key => $val) {
			     $url .= $comma . $key . '=' . $val;
			     $comma = '&';
			 }
			 //Unset preffered should not be redirected
			 if (empty(UserRequest::$get['main']) || UserRequest::$get['main'] <> 'UNSETPRENTINF') {
			     $_SESSION['PREV_REQ'] = $url;
			 }
		  }

		  //Setting main opener
		  /* if (!empty(UserRequest::$get['ibslog']) && empty($_SESSION['iframeMain'])) {
		    return setIfmOpener();
		    } */


		  if (defined('kDefaultFrameLess') && kDefaultFrameLess) {
			 //Set Frameless
			 if (empty($_SESSION['frameless'])) {
			     $_SESSION['frameless'] = CLX_NUM_ONE;
			     $contents = '<script type="text/javascript" language="Javascript">' . CLX_CHAR_NL . 'var winprops=' . singleQuote(' toolbar=0,location=0,directories=0,status=1,menubar=0,scrollbars=1,resizable=1, width=screen.width, height=screen.height, screenX=0,screenY=0,left=0,top=') . CLX_CHAR_NL . 'newWind=window.open(window.location, ' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', winprops);' . CLX_CHAR_NL . 'newWind.resizeTo(screen.availWidth,screen.availHeight);' . CLX_CHAR_NL . '</script>';
			     $PAGE_VARIABLES['PAGE_TITLE'] = dict('GEN_LBL_PAGETITLE');
			     $PAGE_VARIABLES['MENUS'] = (defined('clxDisplayNoMenus')) ? '' : pageMenus();
			     $PAGE_VARIABLES['CONTENTS'] = $contents;
			     $contents .= getSkinForm('mainOpener.html', $PAGE_VARIABLES);
			     return $contents;
			 }
		  }
		  if ($template_name == CLX_TPL_POP)
			 $contents.= setJavaScriptTag('if (location!=parent.location) parent.location="index.php"');
		  else
			 $contents = getSkinForm('login.html', $variables);
        }

        if (UserResponse::getCustomHeaders()) {
		  UserResponse::sendHeaders();
        } else {//pre( $_SERVER['REQUEST_URI']);echo "eee";
		///pre(strpos($_SERVER['REQUEST_URI'],"/index.php"));
			IF ( ClxCommon::sessionHasUser() && strpos($_SERVER['REQUEST_URI'],"/index.php")>0 &&  $_SESSION["skin"] == "gff_Frame") {
				header("location:indexnew.php");
			}
		  //Adding alert messages
		  if ($attach_messages === true) {
			 $contents = displayMessage() . $contents;
		  }
		  //pdf json xml html
		  //setting encoding according requirement

		  $PAGE_VARIABLES['MENUS'] = (defined('clxDisplayNoMenus')) ? '' : pageMenus();
		  $PAGE_VARIABLES['CONTENTS'] = $contents;
		  $PAGE_VARIABLES['PAGETIME'] = rounder((microtime_float() - $stime), CLX_NUM_FOUR);
		  $PAGE_VARIABLES['PAGEPEAKSIZE'] = rounder((memory_get_peak_usage(false) / CLX_NUM_1024), CLX_NUM_TWO) . ' Kb';
		  $PAGE_VARIABLES['BREADCRUMBS'] = makeBreadCrumbs();

		  $contents = getSkinForm($template_name, $PAGE_VARIABLES);
        }
        return $contents;
    } catch (Exception $e) {
        //Exception
    }
}

function financial_tools($ac) {
    $return = '';
    require_once 'classes/Financial.php';
    switch ($ac) {
        case 'YTM':
		  $sdate = UserRequest::$get['sdate'];
		  $mdate = UserRequest::$get['mdate'];
		  $rate = UserRequest::$get['rt'] / CLX_NUM_HUNDRED;
		  $pr = UserRequest::$get['pr'];
		  if (UserRequest::$get['pr'] == CLX_NUM_HUNDRED) {
			 //Return rate if price is 100
			 return UserRequest::$get['rt'];
		  }
		  $frequency = UserRequest::$get['freq']; //compounding
		  $redemption = UserRequest::$get['rd'];
		  $basis = CLX_INIT_ZERO;
		  $return = clx_yield($sdate, $mdate, $rate, $pr, $redemption, $frequency, $basis) * CLX_NUM_HUNDRED;
		  break;
        case 'IRR':
		  $precision = CLX_NUM_TEN;
		  $sdate = strtotime(UserRequest::$get['sdate']);
		  $mdate = strtotime(UserRequest::$get['mdate']);
		  $rate = UserRequest::$get['rt'] / CLX_NUM_HUNDRED;
		  $pr = UserRequest::$get['pr'];
		  if (UserRequest::$get['pr'] == CLX_NUM_HUNDRED) {
			 //Return rate if price is 100
			 return UserRequest::$get['rt'];
		  }
		  $frequency = UserRequest::$get['freq']; //compounding
		  $redemption = UserRequest::$get['rd']; //Nominal
		  $price = round($redemption * $pr / CLX_NUM_HUNDRED, $precision);
		  $basis = CLX_INIT_ZERO;
		  $cupon = round(($redemption * $rate) / $frequency, $precision);
		  //Sumiendo 100 y precio determino el monto de rendimiento
		  $values = array(CLX_NUM_MINUS_1 * $price);
		  $guess = CLX_NUM_0_PT_1;
		  $allow_fraction = true;
		  $a = new Financial();
		  $no_cupons = floor($a->COUPNUM($sdate, $mdate, CLX_NUM_ONE, $basis, $allow_fraction) * $frequency);
		  //$no_cupons = floor(date_diff($mdate, $sdate)*$frequency//);
		  for ($i = CLX_NUM_ONE; $i <= $no_cupons; $i++) {
			 $values[] = $cupon;
		  }
		  $values[] = round(($redemption + $cupon), $precision);
		  $return = ($a->IRR($values, $guess) * $frequency) * CLX_NUM_HUNDRED;
		  break;
        default:
		  break;
    }
    return $return;
}

function &getTool($code, $die = true) {
    $return = null;
    if (array_key_exists($code, ClxCommon::$tools)) {
        $return = ClxCommon::$tools[$code];
    } else {
        if (loadTool($code)) {
		  $return = ClxCommon::$tools[$code];
        }
    }
    if (empty($return) && $die === true) {
        $BUGS = &getTool('BUGS');
        $BUGS->report(E_USER_WARNING, 'No tool with code ' . singleQuote($code) . ',' . UserRequest::$server['SCRIPT_NAME'], 'unknown line', UserRequest::$request, CLX_NUM_ZERO, 9, 'No tool with code ' . singleQuote($code), null);
    }
    return $return;
}

/**
 * Returns object from selection
 * @param type $type
 * @param type $code
 * @return type
 */
function salir($parametro = CLX_NUM_ZERO) {
    exit($parametro);
}

function getToolObject($type, $code) {
    $name = $type . $code;
    if (!array_key_exists($name, ClxCommon::$objects)) {
        $objs = &getTool('OBJS');
        ClxCommon::$objects[$name] = $objs->getObject_($type, $code);
        ClxCommon::$objects[$name];
    }
    return (!empty(ClxCommon::$objects[$name])) ? ClxCommon::$objects[$name] : null;
}
function apc_addFct($var,$inf,$par) {
//	echo "'aar'.kApcEnabled.'eraa'";
//	pre(get_defined_constants());
	if (kApcEnabled ) {
//		echo "'rrerr'";
		if (kApctype==5) {
			return memcache_add($GLOBALS['memcache'],$var.'_'.kDatabaseDisplay,$inf, false, $par);
		
		
		}
		else if (kApctype==4) {
	//		echo "'eee'";
			return zend_shm_cache_store($var.'_'.kDatabaseDisplay,$inf,$par*10000);
			
		}
		else if (kApctype==3) {//echo '-2-->';echo $var;
			if (!wincache_ucache_exists($var.'_'.kDatabaseDisplay)) {
				return @wincache_ucache_add($var.'_'.kDatabaseDisplay,$inf,$par);
			}
			else {
				return false;
			}
		}
		else if (kApctype==2) {
			return apcu_add($var.'_'.kDatabaseDisplay,$inf,$par);
		}
		else if (kApctype==1) {
			return apc_add($var.'_'.kDatabaseDisplay,$inf,$par);
		}
		
		
	}//ho('sss<br>');
}
function apc_deleteFct($var) {
	if (kApcEnabled ) {
		if (kApctype==5) {
			memcache_delete($GLOBALS['memcache'],$var.'_'.kDatabaseDisplay);
		
		}
		else 	if (kApctype==4)  {
			return zend_shm_cache_delete($var.'_'.kDatabaseDisplay);
		}
		else if (kApctype==3)  {
			return wincache_ucache_delete($var.'_'.kDatabaseDisplay);
		}
		else if (kApctype==2)  {
			return apcu_delete($var.'_'.kDatabaseDisplay);
		}
		if (kApctype==1) {
			return apc_delete($var.'_'.kDatabaseDisplay);
		}
		
	}
}
function apc_existsFct($var) {
	if (kApcEnabled ) {
		if (kApctype==5) {
		   $valor=memcache_get($GLOBALS['memcache'],$var.'_'.kDatabaseDisplay);
		   if ($valor)
				$GLOBALS['Apc_'.$var.'_'.kDatabaseDisplay]=$valor;
			return $valor; 
		}
		else if (kApctype==4) {
			
			return zend_shm_cache_exist($var.'_'.kDatabaseDisplay);
		}
		if (kApctype==3) {
			
			return wincache_ucache_exists($var.'_'.kDatabaseDisplay);
		}
		else if (kApctype==2) {
			return apcu_exists($var.'_'.kDatabaseDisplay);
		}
		else if (kApctype==1) {
			return apc_exits($var.'_'.kDatabaseDisplay);
		}
		
		
	}
}

function apc_fetchFct($var,&$inf) {//pre(kApctype);
	/*$te=debug_backtrace(); 
		$pos=$posx=0;
		echo "***********1****";
		for ($t=0;$t<12;$t++) {
			if (isset($te[$t]["file"])){
				if ($t==$posx)
					echo $pos."_".$te[$posx]["function"]."_util(pre)-hora:".date("h:i:s d/m/Y")."<br>";
				echo substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"]."<br>";
			}
		}
		echo "***********2****";*/
	if (kApcEnabled ) {

	
		if (ISSET($GLOBALS['ADDRDEBUGFETCH'])){
			$te=debug_backtrace();	
			echoLog('<nobr>'.str_repeat(' &nbsp;',50).  substr((isset($te[1]["file"])?$te[1]["file"]:'').str_repeat(" ",80),0,80).chr(9).(isset($te[1]["line"])?$te[1]["line"]:'').chr(9).$te[1]["function"] . ';</nobr><br>');
			echoLog('<nobr>'.str_repeat(' &nbsp;',50).  substr((isset($te[2]["file"])?$te[2]["file"]:'').str_repeat(" ",80),0,80).chr(9).(isset($te[2]["line"])?$te[2]["line"]:'').chr(9).$te[2]["function"] . ';<nobr><br>');
		}
	    if (kApctype==5) {
	       
			if (isset($GLOBALS['Apc_'.$var.'_'.kDatabaseDisplay])) {
		           $valor= $GLOBALS['Apc_'.$var.'_'.kDatabaseDisplay];
				   unset ($GLOBALS['Apc_'.$var.'_'.kDatabaseDisplay]);
				   $inf=  true;
				   return $valor;
			}		   
			else {
					$valor=memcache_get($GLOBALS['memcache'],$var.'_'.kDatabaseDisplay);
					$inf=  $valor!==false;
			       return $valor;
			}
		}
		else if (kApctype==4) {
			$inf=false;
			//if (zend_shm_cache_exists($var.'_'.kDatabaseDisplay)) {
				$value=zend_shm_cache_fetch($var.'_'.kDatabaseDisplay);
				$inf=  $value!==false;
				return $value; 
			//}
			//return false;
			
		}
		else if (kApctype==3) {//echo '-1-->';pre($var);pre(wincache_ucache_get($var)); 
			
			return wincache_ucache_get($var.'_'.kDatabaseDisplay,$inf);
		}
		else if (kApctype==2) {
			return apcu_fetch($var.'_'.kDatabaseDisplay,$inf);
		}
		else if (kApctype==1) {
			return apc_fetch($var.'_'.kDatabaseDisplay,$inf);
		}
		
		
	}
	
}
//sapc_clear_cacheFct();
function apc_clear_cacheFct() {
	if (kApcEnabled ) {
		if (kApctype==5){
			memcache_flush($GLOBALS['memcache']);
	
	    }
		else if (kApctype==4){
			/*$te=debug_backtrace(); 
			$pos=$posx=0;
			for ($t=0;$t<12;$t++) {
				if (isset($te[$t]["file"])){
					if ($t==$posx)
						echo $pos."_".$te[$posx]["function"]."_util(pre)-hora:".date("h:i:s d/m/Y")."<br>";
					echo substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"]."<br>";
				}
			}die;*/
		//	echo 'dddddddddddddddddddddddddddddddddd';
		   return zend_shm_cache_clear();
		}
		else if (kApctype==3){
		//	pre('######################## clear');
			return wincache_ucache_clear();
		}
		else if (kApctype==2) {
			return apcu_clear_cache();
		}
		if (kApctype==1) {
			return apc_clear_cache();
		}
		
	
	}
}                 //apc_clear_cacheFct();//die;
function apc_cache_get_tables_names() {

	$fetched =$fetched2= false;
    if (kApcTtl_10>0) $qt = apc_fetchFct(kSpaceName . '_tablenamecache_' , $fetched);
    $find='';
	if (empty($fetched)) {
		IF(isset($_SESSION ['user_record']['username']))
			if (kApcTtl_10>0) $qt = apc_fetchFct($find=kSpaceName . '_tablenamecache_'.$_SESSION ['user_record']['username'] , $fetched2);
		
	}
	if ($fetched===false && $fetched2===false) {
		$qt=array();
		$rs = ClxCommon::$db->executeQuery($sql='SELECT CONCAT(MODULECODE,CONCAT('.singlequote('_').',IDNAME))TABLENAME,IDCODE  FROM CLX_DB_TABLES');
		//pre($sql);
		/*while ($t = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			 $qt['t_'.$t['TABLENAME']]=$t['IDCODE'];
			 $qt['i_'.$t['IDCODE']]=$t['TABLENAME'];
		 
		}*/
		//ClxCommon::$db->freeResult( $rs );
		if (kApcTtl_10>0 && $fetched==false&&!empty($find)&&!empty($qt)) {
			apc_addFct($find,$qt,kApcTtl_10);
		}
	}
	$GLOBALS['apc_cache_get_tablesnames']=$qt;
}

function apc_cache_get_tables_queries() {
	$fetched =$fetched2= false;
    if (kApcTtl_10>0) $qt = apc_fetchFct(kSpaceName . '_querytable_' , $fetched);
    $find='';
	if (empty($fetched)) {
		IF(isset($_SESSION ['user_record']['username']))
			if (kApcTtl_10>0) $qt = apc_fetchFct($find=kSpaceName . '_querytable_'.$_SESSION ['user_record']['username'] , $fetched2);
		
	}
	if ($fetched===false && $fetched2===false) {
		$qt=array();
		if (kDatabaseType == 'oci') {
			$rs = ClxCommon::$db->executeQuery('SELECT LISTAGG(QUERYCODE,'.singlequote(',').') WITHIN GROUP(ORDER BY QUERYCODE)     QC,TABLECODE FROM CLX_DB_QUERY_TABLES DBQT GROUP BY TABLECODE');
		}else{
			$rs = ClxCommon::$db->executeQuery('SELECT GROUP_CONCAT(QUERYCODE) QC,TABLECODE FROM CLX_DB_QUERY_TABLES DBQT GROUP BY TABLECODE');
			
			
		}
		while ($t = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			 $qt[$t['TABLECODE']]=explode(',',$t['QC']);
		 
		}
		ClxCommon::$db->freeResult( $rs );
		if (kApcTtl_10>0 && $fetched==false&&!empty($find) &&!empty($qt)) {
			apc_addFct($find,$qt,kApcTtl_10);
		}
		
	}
	
		$GLOBALS['apc_cache_get_tables_queries']=$qt;
}
/**
 * Load tools
 * @param type $code
 * @return boolean
 */
function apc_clear_from_sql($sql){
	if (empty($sql)) {
		return;
	}
	if (!isset($GLOBALS['apc_cache_get_tablesnames'])) {
		apc_cache_get_tables_names();
	}
	preg_match_all('/((\bfrom\b)|\b(into)\b|\b(join)\b)\s*([\w\s\,]+)((((join)|(where)|(on)|(values)|(order)|(group))(((\())|(\s)|(\;)))|(;)|(\w{0}))/i',$sql,$matches);
	foreach($matches as $match){
		foreach($match as $vlt) {
			$tablex=explode(',',$nametablecode[$vlt]);
			foreach($tablex as $vl) {
				$vl2=explode(' ',$vl);
				apc_clear_xppaging_count_all_user($vl2);
			}
		}
	}
}
function apc_clear_xppaging_count_query($querycode){
	$findVar=kSpaceName . '_xpagging_count_'.$_SESSION ['user_record']['username'].'_!_'.$querycode;
	apc_deleteFct($findVar);

}
function apc_clear_xppaging_count_all_user($tablecode) {//ECHO "=======================1==<BR>";
	if (empty($tablecode)) {
		return;
	}
	if (!isset($GLOBALS['apc_cache_get_tables_queries'])) {
		apc_cache_get_tables_queries();
	}
	//pre($GLOBALS['apc_cache_get_tables_queries']);
	
	if (kApctype==1) {
			return apc_clear_cache($var);
	}
	else if (kApctype==4 or kApctype==5){
		$rs = ClxCommon::$db->executeQuery(			$sql='select username,querycode from clx_db_query_tables  JOIN CLX_AC_USERS ON 1=1 where tablecode='.singlequote($tablecode));
		while ($t = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			//PRE($t);
			for ($r=0;$r<255;$r++) {
		//	ECHO '<BR>',	
				$findVar=kSpaceName . '_xpagging_count_'.$t['USERNAME'].'_!_'.$t['QUERYCODE']. dechex($r);
				apc_deleteFct($findVar);
			}
		
		}
		
	}
	else  {
		if (isset($GLOBALS['apc_cache_get_tables_queries'][$tablecode])) {
			foreach ($GLOBALS['apc_cache_get_tables_queries'][$tablecode] as $querycode){
				$findkeyscache=preg_grep($tt='%^'.kSpaceName . '_xpagging_count_(.)+'.$querycode.'$%',array_column(apcu_cache_info()["cache_list"],'info'));
			//	pre($findkeyscache);
			//	pre(array_column(apcu_cache_info()["cache_list"],'info'));
			//	echo $tt,'<br>';
				foreach ($findkeyscache as $key=>$findVar) {
				///	echo 'sssssss'.$findVar.'sssssssss';
				//	echo "ppp ",apc_existsFct($findVar),' pppp2';
					apc_deleteFct($findVar);
				//	echo "ddd ",apc_existsFct($findVar),' dddd2';
				}
			}
		}
	}
	
	
}
function apc_clear_xppaging_count($tablecode) {//ECHO "=======================1==<BR>";
	if (empty($tablecode)) {
		return;
	}
	if (!isset($GLOBALS['apc_cache_get_tables_queries'])) {
		apc_cache_get_tables_queries();
	}
	//pre($GLOBALS['apc_cache_get_tables_queries']);
	foreach ($GLOBALS['apc_cache_get_tables_queries'][$tablecode] as $querycode){
		$findVar=kSpaceName . '_xpagging_count_'.$_SESSION ['user_record']['username'].'_!_'.$querycode;
		//echo 'aca2';
		apc_deleteFct($findVar);
	}
}

function apc_clear_querycode($querycode) {//ECHO "=======================1==<BR>";
	if (empty($querycode)) {
		return;
	}	
	if (kApcEnabled ) {//ECHO "=======================2==<BR>";
		if (kApctype==1) {
			//return apc_clear_cache($var);
		}
		else if (kApctype==2) {
			//echo "-----------------xx------------------<br>";
			//echo $rr="localhost:3306.clx56dev_xpagging_count_administrador_! SERV_REQUESTS SRRQ_!ae8e855952b09186882b5da6c7c1aa69";
			//echo '<br>',"xx:",apc_existsFct($rr),'<br>';
			//echo "------------------aa-----------------<br>";
			$find=kSpaceName.'_querycode_!_'.$querycode.'_!_';
			$sizefind=strlen($find);
			foreach (apcu_cache_info()["cache_list"] as $key=>$value) {
				//echo '=1=',$texto.'<br>';
				//if (substr($value['info'],0,26)=='localhost:3306.clx56dev_xp')
				//echo '=2=', substr($value['info'],0,$sizetexto),'<br><br>';
				if ($find== substr($value['info'],0,$sizefind)) {
				//	ECHO 'borrado'.$value['info'];
					apc_deleteFct($value['info']);
					continue;
				}
				
			}
			//return apcu_clear_cache($var);
		}
		else if (kApctype==3){
		//echo "-----------------xx------------------<br>";
			//echo $rr="localhost:3306.clx56dev_xpagging_count_administrador_! SERV_REQUESTS SRRQ_!ae8e855952b09186882b5da6c7c1aa69";
			//echo '<br>',"xx:",apc_existsFct($rr),'<br>';
			//echo "------------------aa-----------------<br>";
			$find=kSpaceName.'_querycode_!_'.$querycode.'_!_';
			$sizefind=strlen($find);
			foreach (wincache_ucache_info() ["ucache_entries"] as $key=>$value) {
				//echo '=1=',$texto.'<br>';
				//if (substr($value['info'],0,26)=='localhost:3306.clx56dev_xp')
				//echo '=2=', substr($value["key_name"] ,0,$sizetexto),'<br><br>';
				if ($find== substr($value["key_name"] ,0,$sizefind)) {
				//	ECHO 'borrado'.$value["key_name"] ;
					apc_deleteFct($value["key_name"] );
					continue;
				}
				
			}
			//return wincache_ucache_clear($var);
		}
		else if (kApctype==4 or kApctype==5){
			// no se como borrar y utilizar apc_clear_cache es muy lento borra el menu
			//apc_clear_cacheFct();
			apc_deleteFct(kSpaceName.'_querycode_!_'.$querycode.'_!_.XName_!_1');
		
			apc_deleteFct(kSpaceName.'_querycode_!_'.$querycode.'_!_.XName_!_2');
		}
	}
	//ECHO "=======================2==<BR>";
}

function loadTool($code) {
	require_once kPathToWebSite . 'tools/sys_parameters.php';
    $return = false;
    $fetched = false;
	if(kApcTtl_3>0)$toolrec = apc_fetchFct($findVar=kSpaceName . '_magr_' . $code, $fetched);
	  if (empty($fetched)) {
        $toolrec = ClxCommon::$db->getRecord('CLX_TOOLS', 'IDCODE=' . singleQuote($code));
        if (kApcTtl_3>0 && !empty($toolrec)) {
            apc_addFct($findVar, $toolrec, kApcTtl_3);
        }
	}
    if (!empty($toolrec)) {
        //Load tool parameters
		if (file_exists(kPathToWebSite . 'tools/' . $toolrec['CLASS'] . '.php')){
			require_once kPathToWebSite . 'tools/' . $toolrec['CLASS'] . '.php';
			sys_parameters::staticInitParameters($code);
			sys_parameters::staticInitParameters('UTIL');
			//Load class
			if (class_exists($toolrec['CLASS'])) {
				ClxCommon::$tools[$code] = new $toolrec['CLASS'];
				ClxCommon::$tools[$code]->init();
				$return = true;
			}
		}	
    }
    return $return;
}

/**
 *  Gets a new instance of the tool.
 */
function getNewTool($code, $die = true) {
    $tool = null;
    $toolrec = ClxCommon::$db->getRecord('CLX_TOOLS', 'IDCODE=' . singleQuote($code));
    if (!empty($toolrec)) {
        //Load tool parameters
        if (!class_exists($toolrec['CLASS'])) {
		  require kPathToWebSite . 'tools/' . $toolrec['CLASS'] . '.php';
		  sys_parameters::staticInitParameters($code);
			sys_parameters::staticInitParameters('UTIL');
        }
        //Load class
        $tool = new $toolrec['CLASS'];
        $tool->init();
    }
    if (empty($tool) && $die === true) {
        $BUGS = &getTool('BUGS');
        $BUGS->report(E_USER_WARNING, 'No tool with code ' . singleQuote($code), UserRequest::$server['SCRIPT_NAME'], 'unknown line', UserRequest::$request, CLX_NUM_ZERO, 'No tool with code ' . singleQuote($code));
    }
    return $tool;
}

/**
 * Calls service and returns service estatus
 */
function getService($service_code, &$parameters) {
    $SKSV = &getTool('SKSV');
    $s_response = $SKSV->execute2($service_code, $parameters);
    $a_response = array('response' => $s_response,
        'a_response' => $SKSV->get_last_operation_result());
    return $a_response;
}

/**
 * Runs process
 * @param string $schedule_code
 * @param array $parameters
 * @return mixed
 */
function runProcess($schedule_code, $parameters = array()) {
    //e cho CLX_CHAR_NL.''.CLX_CHAR_NL.'Ejecutando proceso:' . $schedule_code.CLX_CHAR_NL.CLX_CHAR_NL;
    if (!empty($parameters)) {
        $PRSP = getNewTool('PRSP');
        $PRSP->setScheduleParameters($schedule_code, $parameters);
        //e cho CLX_CHAR_NL.''.CLX_CHAR_NL.'Parametros:'.print_r($parameters, true).CLX_CHAR_NL.CLX_CHAR_NL;
    }
    $PRSC = getNewTool('PRSC');
    return $PRSC->cronRun($schedule_code);
}

/**
 * Store Notices on
 */
function addNotice($notice) {
    if (strlen($notice) > CLX_NUM_ZERO) {
        $_SESSION['notice'][] = $notice;
    }
}

/**
 * Init Notices array
 */
function initNotice() {
    if (empty($_SESSION['notice'])) {
        $_SESSION['notice'] = array();
    }
}

//See also include/interfase.php function getNotice()
// HISTORY FUNCTIONS
/**
 * Add an entry to history stack from history stack object
 * @param unknown_type $history_entry
 */
function pushHistoryRecord($history_entry) {
    $hkey = historyKey();
    $_SESSION['history'][$hkey][] = $history_entry;
}

function pushHistory($to, $ac, $idlist) {
    $entry[CLX_PROP_TO] = $to;
    $entry['ac'] = $ac;
    $entry['idlist'] = toString($idlist);
    $callingpage = peekHistory();
    if (!empty(UserRequest::$request['menuid'])) {
        $entry['menuid'] = UserRequest::$request['menuid'];
    } elseif (!empty($callingpage['menuid'])) {
        $entry['menuid'] = $callingpage['menuid'];
    } else {
        $entry['menuid'] = '';
    }
    // deprecado 7.4 magic quotes must be off, but incase of on then strip
    //$mquotes = get_magic_quotes_gpc();
    $qty = func_num_args();
    if ($qty > CLX_NUM_THREE) {
        for ($i = CLX_NUM_THREE; $i < $qty; $i+=CLX_NUM_TWO) {
		  $key = func_get_arg($i);
		  $value = func_get_arg($i + CLX_NUM_ONE);
		  if (/*$mquotes === true &&*/ is_array($value)) {
			 foreach ($value as $fkey => $fval) {
			     //may be \\' that is why double
			     $value[$fkey] = stripslashes(stripslashes($fval));
			 }
		  }
		  $entry[$key] = $value;
        }
    }
    $hkey = historyKey();
    if (!empty($_SESSION['history'][$hkey]) && $_SESSION['history'][$hkey] == $entry) {
        //do nothing means refresh
    } else {
        $lasthist = peekHistory(); //Preventing Refresh
        if (!empty($lasthist) && !isset($lasthist['li']))
		  $lasthist['li'] = '';
        if (!isset($entry['li']))
		  $entry['li'] = '';
        if (!empty($lasthist) && $lasthist[CLX_PROP_TO] == $entry[CLX_PROP_TO] &&
			 $lasthist['ac'] == $entry['ac'] && $lasthist['idlist'] == $entry['idlist'] && $lasthist['li'] == $entry['li']) {
		  $_SESSION['history'][$hkey][count($_SESSION['history'][$hkey]) - CLX_NUM_ONE] = $entry;
        } else {
		  $_SESSION['history'][$hkey][] = $entry;
        }
    }
}

function historyKey() {
    $key = 'key';
    if (strpos(UserRequest::$server['PHP_SELF'], 'pop.php') !== false || strpos(UserRequest::$server['PHP_SELF'], 'window.php') !== false) {
        $key = 'pop';
    } else {
        $key = 'main';
    }
    return $key;
}

function popHistory($hkey = '') {
    if ($hkey === '') {
        $hkey = historyKey();
    }
    if (!empty($_SESSION['history'][$hkey]) && is_array($_SESSION['history'][$hkey])) {
        $info = array_pop($_SESSION['history'][$hkey]);
        //Restoring history request parameters
        foreach ($info as $key => $value) {
		  UserRequest::$post[$key] = $value;
		  UserRequest::$request[$key] = $value;
        }
        UserRequest::$post[CLX_PROP_TO] = $info[CLX_PROP_TO];
        UserRequest::$post['ac'] = $info['ac'];
        UserRequest::$request[CLX_PROP_TO] = $info[CLX_PROP_TO];
        UserRequest::$request['ac'] = $info['ac'];
    } else {
        $info = array();
    }
    return $info;
}

function currentHistory() {
    $hkey = historyKey();
    return (array_key_exists($hkey, $_SESSION['history'])) ? $_SESSION['history'][$hkey] : array();
}

function clearHistory() {
    $hkey = historyKey();
    $_SESSION['history'][$hkey] = array();
}

/**
 * Return
 * @param unknown_type $hkey
 * @return multitype:
 */
function peekHistory($hkey = '') {
    if ($hkey === '') {
        $hkey = historyKey();
    }
    $qty = countHistory($hkey);
    if (array_key_exists($hkey, $_SESSION['history'])) {
        if (array_key_exists(($qty - CLX_NUM_ONE), $_SESSION['history'][$hkey])) {
		  $return = $_SESSION['history'][$hkey][$qty - CLX_NUM_ONE];
        } else {
		  $return = array();
        }
    } else {
        $return = array();
    }
    return $return;
}

function addHistory($key, $value) {
    $hkey = historyKey();
    $qty = countHistory();
    $_SESSION['history'][$hkey][$qty - CLX_NUM_ONE][$key] = $value;
}

function executeHistory($info) {
    //If no history may come from home.
    if (empty($info)) {
        header('location:' . kWebSite);
        salir();
    }
    $to = $info[CLX_PROP_TO];
    $ac = $info['ac'];
    UserRequest::$request['menuid'] = (!empty($info['menuid'])) ? $info['menuid'] : '';
    $idlist = toArray($info['idlist']);
    $tool = &getTool($to);
    $contents = $tool->action($ac, $idlist);
    return $contents;
}

/**
 * Counts history
 * @param unknown_type $hkey
 * @return number
 */
function countHistory($hkey = '') {
    if ($hkey === '') {
        $hkey = historyKey();
    }
    return (array_key_exists($hkey, $_SESSION['history'])) ? count($_SESSION['history'][$hkey]) : CLX_NUM_ZERO;
}

function http_tx_status($set_status = false) {
    $contenidoHTML = '';
    $status = true;
    if (array_key_exists('clxtx_id', UserRequest::$request) && array_key_exists('clxtx_id', $_SESSION) && $_SESSION['clxtx_id'] == UserRequest::$request['clxtx_id']) {
        //Request already set
        $status = false;
    } else {

    }
    if (array_key_exists('clxtx_id', $_SESSION)) {
        $contenidoHTML.='Sesion:' . $_SESSION['clxtx_id'] . CLX_CHAR_NL;
    }
    if (array_key_exists('clxtx_id', UserRequest::$request)) {
        $contenidoHTML.= 'Tx: ' . UserRequest::$request['clxtx_id'] . CLX_CHAR_NL;
    }
    if (empty($set_status)) {
        $contenidoHTML.= (($status) ? 'Si' : 'No') . '<br>' . CLX_CHAR_NL;
    }
    echo $contenidoHTML;
    return $status;
}

function http_set_tx($tx) {
    $_SESSION['clxtx_id'] = $tx;
}

function getCurrentLanguage() {
    if (ClxCommon::sessionHasUser()) {
		if (!isset($_SESSION ['prefs'] ['LANGUAGE']))
			$_SESSION ['prefs'] ['LANGUAGE']='es';
        if (!empty(clx_language_lower_upper($_SESSION ['prefs'] ['LANGUAGE']))) {
		  $lang = clx_language_lower_upper($_SESSION ['prefs'] ['LANGUAGE']);
        } else {
		  $lang = clx_language_lower_upper(kSystemLanguage);
        }
    } else {
        $lang = clx_language_lower_upper(kSystemLanguage);
    }
    return $lang;
}

function dict($entry, $create_fast_link = true, $returnedEntry=true) { //	ECHO ',EEEE,',$entry;
		$siglobals=false;
		$text = '';	
		//if(strpos($)) 
		/*if ($entry=='TOOL_DBIM_IMPORT_COMPLETE') {
			$tta=fopen(kPathToWebSite."/".kPathToTemp."archivoee.txt","a+");
			fwrite($tta,$entry.' sin '.chr(13).chr(10));
			for ($i = CLX_NUM_ONE; $i < func_num_args(); $i++) {
				fwrite($tta,$i. ' '.func_get_arg($i).chr(13).chr(10));
			}

			fclose($tta);
		}*/
		$clean_entry = uppercase(trim($entry));
		if (isset($GLOBALS['DICT_'.$clean_entry])&& !defined('clxInstallProcess')) {
			$siglobals=true;
			$text=$GLOBALS['DICT_'.$clean_entry];
		}
		else if (strlen($clean_entry) > CLX_NUM_ZERO && !defined('clxInstallProcess')) {
			$lang = getCurrentLanguage();
			$fetched = false;
			if (kApcTtl_9>0) $text = apc_fetchFct(kSpaceName . '.dict.' . $clean_entry . $lang, $fetched);
			//$fetched = false;
			if (empty($fetched) ) {
				$DICH = &getTool('DICH');
			
				$text = $DICH->entry($clean_entry, $lang, $create_fast_link);
				if ($returnedEntry == false and $text ==$clean_entry)
					$text="((nodata))";
				$GLOBALS['DICT_'.$clean_entry]=$text;
				if ( kApcTtl_9>0 && !empty($text)&& $clean_entry<>$entry ) {
					apc_addFct(kSpaceName . '.dict.' . $clean_entry . $lang, $text, kApcTtl_9);
				}
			}
		}
		
		for ($i = CLX_NUM_ONE; $i < 20; $i++) {
			if ($i<func_num_args()) {
				$text = str_replace('^' . $i, func_get_arg($i), $text);
			}
			else {
				$text = str_replace(' ^' . $i, '', $text);
				$text = str_replace('^' . $i, '', $text);
			}	
		}
		if ($siglobals==false) {
			if ( isset($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 )  {
			$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+"); 		$te=debug_backtrace();$posx=0;		fwrite($tta,chr(13).chr(10)."_".$te[$posx]["function"]."_util(dict)-hora:".date("h:i:s d/m/Y").chr(13).chr(10));		for ($t=0;$t<12;$t++) {	if (isset($te[$t]["file"])) 				fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}fwrite($tta,chr(13).chr(10)."Dictionary:".$entry. " => ".$text);fclose($tta);
		}
	}
	
	IF (ISSET($_SESSION['ADDRDEBUGDICT']) && $_SESSION['ADDRDEBUGDICT']==$_SERVER['REMOTE_ADDR']) {$te=debug_backtrace();$pos=0;$posx=0;	for ($t=0;$t<12;$t++) {	if (isset($te[$t]["file"])){if ($t==$posx)echo $pos."_".$te[$posx]["function"]."_util(pre)-hora:".date("h:i:s d/m/Y")."<br>";  echo substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"]."<br>";
	}}pre("Dictionary:".singlequote($entry). " => ".singlequote($text));}
    
	if ($text=="((nodata))")
		$text="";
	
    return $text;




}

/**
 * Clear Dictonary Entry to set to parent.
 */
function dict_parent_entry($entry) {
    $pos = strpos($entry, '-');
    if ($pos !== false) {
        $entry = substr($entry, CLX_NUM_ZERO, $pos);
    }
    return $entry;
}

/**
 * Returns diccionary entry encoded by latin 1
 * @param string $entry
 * @param bool $create_fast_link
 */
function dict_decoded($entry, $create_fast_link = true) {
    return decode_string(dict($entry, $create_fast_link));
}

/**
 * Returns sistem messages
 * @param unknown_type $entry
 */
function smsg($entry) {

    $text = '';
    if (trim($entry) === '')
        return $entry;
    if (!defined('clxInstallProcess')) {
        if (ClxCommon::sessionHasUser()) {
		  if (!empty(clx_language_lower_upper($_SESSION ['prefs'] ['LANGUAGE']))) {
			 $lang = clx_language_lower_upper($_SESSION ['prefs'] ['LANGUAGE']);
		  } else {
			 $lang = clx_language_lower_upper(kSystemLanguage);
		  }
        } else {
		  $lang = clx_language_lower_upper(kSystemLanguage);
        }
        $SMSG = &getTool('SMSG');
        $text = $SMSG->entry($entry, $lang);
        $qty = func_num_args();
        if ($qty > CLX_NUM_ONE) {

		  for ($i = CLX_NUM_ONE; $i < $qty; $i++) {
			 $t = func_get_arg($i);
			 if (is_array($t)) {
			     $j = 1;
			     foreach ($t as $v) {
			         $text = str_replace('^' . $j, $v, $text);
			         $j++;
			     }
			 } else {
			     $text = str_replace('^' . $i, $t, $text);
			 }
		  }
        }
    }
    //openWindow(title, url, w, h)
    $entry = '<a href="javascript:openWindow(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', ' . singleQuote('pop.php?to=SMSG&ac=DESCRIBE&idlist=' . $entry) . ', 400, 400,null,null,'.singlequote( str_replace('\\','/',__FILE__) .'_'. __LINE__ ).');">' . $entry . '</a>';
    $msg = $text . ' (' . $entry . ')';
	if ( isset($_SESSION["_dEBUG"])) { 
		$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");
		fwrite($tta,chr(13).chr(10)."SMS-hora:".date("h:i:s d/m/Y").chr(13).chr(10));
		fwrite($tta,chr(13).chr(10).$text.chr(13).chr(10));
		$te=debug_backtrace();

		for ($t=0;$t<18;$t++) {
		    if (isset($te[$t]["file"]))
			fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));


		}
		fwrite($tta,chr(13).chr(10));
		fclose($tta);
	}
	return $msg;
}

function smsg_no_description($entry) {
    $text = '';
    if (trim($entry) === '')
        return $entry;
    if (!defined('clxInstallProcess')) {
        if (ClxCommon::sessionHasUser()) {
		  if (!empty(clx_language_lower_upper($_SESSION ['prefs'] ['LANGUAGE']))) {
			 $lang = clx_language_lower_upper($_SESSION ['prefs'] ['LANGUAGE']);
		  } else {
			 $lang = clx_language_lower_upper(kSystemLanguage);
		  }
        } else {
		  $lang = clx_language_lower_upper(kSystemLanguage);
        }
        $SMSG = &getTool('SMSG');
        $text = $SMSG->entry($entry, $lang);
        $qty = func_num_args();
        if ($qty > CLX_NUM_ONE) {
		  for ($i = CLX_NUM_ONE; $i < $qty; $i++) {
			 $t = func_get_arg($i);
			 $text = str_replace('^' . $i, $t, $text);
		  }
        }
    }
    return $text;
}

/**
 * Runs system alerts from tools SYAL
 *
 * @param string $alertcode
 * @param array $parameters
 * @return boolean
 */
function sendAlert($alertcode, $parameters = array()) {
	include_once kPathToWebSite . 'includes/sys_constants.php';

    $SYAL = &getTool('SYAL');
    return $SYAL->runAlert($alertcode, $parameters);
}

function arrayToPop($name, $items, $default) {
    $pop = new htmlSelect($name);
    foreach ($items as $code => $item) {
        $pop->addItem($item, $code, ($code == $default));
    }
    return $pop;
}

// This two exists because I always get confused with the )(*&^%$# implode and explode!
function toArray($aString, $enclose_by = '') {
    $return = array();
    if ($enclose_by <> '') {
        $return = explode(',', str_replace($enclose_by, '', $aString));
    } else {
        $return = explode(',', $aString);
    }
    return $return;
}

function toString($aArray, $enclose_by = '') {
	// 2018-12-05 CR - Caso 1003486 - GB-Rep BATCH no arranca
	//$return = '';
    $return = $aArray; // Always has to return parameter $aArray value passed, whether it's a string or array
    if (is_array($aArray)) {
        if ($enclose_by <> '') {
		  $return = $enclose_by . implode($enclose_by . ',' . $enclose_by, $aArray) . $enclose_by;
        } else {
		  $return = implode(',', $aArray);
        }
    }
    return $return;
}

// This function is not used in this system.  It is here for sentimental value only ;)
function gotoLocation($url) {
    $js = '<script type="text/javascript" language="Javascript1.2">' . CLX_CHAR_NL . '<!--' . CLX_CHAR_NL . ' window.location = "' . $url . '";' . CLX_CHAR_NL . '//-->' . CLX_CHAR_NL . '</script>';
    echo $js;
}

// Users messages
/**
 * Add message to alert box
 * Types 'alert', 'note', 'warning'
 */
function addMessage($msg, $type = CLX_CLASS_ALERT) {
    if (empty($_SESSION['USMSG'])) {
        $_SESSION['USMSG'] = array();
    }
    if (is_array($msg)) {
        foreach ($msg as $v) {
		  $_SESSION['USMSG'][] = array('msg' => $v, 'type' => $type);
        }
    } else {
        $_SESSION['USMSG'][] = array('msg' => $msg, 'type' => $type);
    }
    if (defined('send_alert')) {
        $msgt = addMessageParseAlert($msg);
        ClxFreeReturn(alrt_send($msgt, 'now', $_SESSION['user_record']['username']));
    }
}

function addMessageParseAlert($msg) {
    $msgt = '';
    if (is_array($msg)) {
        foreach ($msg as $val) {
		  $msgt .='<li>' . $val . '</li>';
        }
    } else {
        $msgt = $msg;
    }
    return $msgt;
}

// End  function
function getLastMessage() {
    $total = count($_SESSION['USMSG']);
    if ($total > CLX_NUM_ZERO) {
        $return = $_SESSION['USMSG'][$total - CLX_NUM_ONE];
    } else {
        $return = '';
    }
    return $return;
}

// End  function
function clearMessage() {
    $_SESSION['USMSG'] = array();
}

// End  function
function displayMessage() {
    if (empty($_SESSION['USMSG'])) {
        $_SESSION['USMSG'] = array();
    }
    $contents = '';
    foreach ($_SESSION['USMSG'] as $value) {
        switch ($value['type']) {
		  case CLX_CLASS_ALERT:
			 $contents .=alert($value['msg']);
			 break;
		  case 'note':
			 $contents .=note($value['msg']);
			 break;
		  default:
			 $contents .=warning($value['msg']);
			 break;
        }
    }
    clearMessage();
    return $contents;
}

// End  function
/**
 * Returns uppercase string
 * @param type $string
 * @param type $encoding
 * @return type
 */
function clx_uppercase($string) {
    return uppercase($string);
}

function singleQuote($text) {
    return CLX_CHAR_SINGLE_QUOTE . $text . CLX_CHAR_SINGLE_QUOTE;
}

function singleQuoteWoSq($text, $replaceWith = NULL) {
    return CLX_CHAR_SINGLE_QUOTE . WoSQ(addslashes($text), $replaceWith) . CLX_CHAR_SINGLE_QUOTE;
}

function singleQuoteArray($array) {
    return CLX_CHAR_SINGLE_QUOTE . implode(CLX_CHAR_SINGLE_QUOTE . ',' . CLX_CHAR_SINGLE_QUOTE, $array) . CLX_CHAR_SINGLE_QUOTE;
}

function quote($text) {
    return CLX_CHAR_DOUBLE_QUOTE . $text . CLX_CHAR_DOUBLE_QUOTE;
}

function quoteWoSq($text, $replaceWith = NULL) {
    return CLX_CHAR_DOUBLE_QUOTE . WoSQ($text, $replaceWith) . CLX_CHAR_DOUBLE_QUOTE;
}

function WoSQ($text, $replaceWith = NULL) {
    if(is_null($replaceWith)) {
        $replaceWith = CLX_CHAR_BACKSLASH . CLX_CHAR_SINGLE_QUOTE;
    }
    $text = str_replace($replaceWith, CLX_CHAR_SINGLE_QUOTE, $text);
    $text = str_replace(CLX_CHAR_SINGLE_QUOTE, $replaceWith, $text);
    return $text;
}

function bkdquote($text) {
    return CLX_CHAR_BACKSLASH_DOUBLE . $text . CLX_CHAR_BACKSLASH_DOUBLE;
}

function mailto($email) {
    return '<a href="mailto:$email">' . $email . '</a>';
}

function gettags($tag, $contents) {
    $matches = array();
    $pattern = '|<' . $tag . '.*?>(.*?)</' . $tag . '>|si';
    preg_match_all($pattern, $contents, $matches);
    return $matches;
}

function uppercaseKeys($array) {
    $newarray = array();
    foreach ($array as $key => $value) {
        $newarray[uppercase($key)] = $value;
    }
    return $newarray;
}

function replace_ascii_chars($text) {
    $matches = array();
    preg_match_all('/\[(.*?)\]/', $text, $matches);

    foreach ($matches[CLX_NUM_ONE] as $v) {
        $text = str_replace('[' . $v . ']', chr($v), $text);
    }
    return $text;
}

function getTextBetween($text, $start_delim) {
    $return = '';
    $qty = func_num_args();
    if ($qty > CLX_NUM_TWO) {
        $end_delim = func_get_arg(CLX_NUM_TWO);
    } else {
        $end_delim = $start_delim;
    }
    $start = strpos($text, $start_delim);
    if ($start === false) {
        $return = '';
    } else {
        $end = strpos($text, $end_delim, $start);
        $return = substr($text, $start + CLX_NUM_ONE, $end - $start - CLX_NUM_ONE);
    }
    return $return;
}

/**
 * Builds formulas from field format
 * Example XXXAF05EXP_FIELDDT(AF05_FECHA,Ymd).txt will result in XXXAF05EXP_20160201.txt
 * @param type $value
 * @return type
 */
function clx_keywords_field($value) {
    if (is_array($value)) {
        foreach ($value as $key => $val) {
		  $value[$key] = clx_keywords_field($val);
        }
    } else {
        $matches = array();
        $pattern = '/FIELDDT\((.*)\)/';
        preg_match($pattern, $value, $matches);
        if (!empty($matches[CLX_NUM_ZERO])) {
		  if (strpos($matches[CLX_NUM_ONE], ',') !== false) {
			 $parts = explode(',', $matches[CLX_NUM_ONE]);

			 $matches[CLX_NUM_ONE] = trim($parts[1]); //field
			 $parts[1] = trim($parts[1]);
			 if (array_key_exists($parts[0], UserRequest::$request)) {
			     $matches[CLX_NUM_TWO] = UserRequest::$request[trim($parts[0])];
			     $date = xFormat::date(trim($matches[CLX_NUM_TWO]), trim($matches[CLX_NUM_ONE]));
			 }else{
			     $date = xFormat::getNow(trim($matches[CLX_NUM_ONE]));
			 }
			 $value = str_replace($matches[CLX_NUM_ZERO], $date, $value);
		  } else {
			 $date = xFormat::getNow(trim($matches[CLX_NUM_ONE]));
			 $value = str_replace($matches[CLX_NUM_ZERO], $date, $value);
		  }
        }
    }

    return $value;
}

/**
 * Formulas performed by keyword on clx
 * @params: mixed array record or string
 * @return: mixed values
 * @example: clx_keywords('!username') or clx_keywords(array('a'=>'!username'))
 */
function clx_keywords($value) {
    if (is_array($value)) {
        foreach ($value as $key => $val) {
		  $value[$key] = clx_keywords($val);
        }
    } else {
        $matches = array();
        $pattern = '/DATE\((.*)\)/';
        preg_match($pattern, $value, $matches);
        if (!empty($matches[CLX_NUM_ZERO])) {
		  $date = xFormat::getNow(trim($matches[CLX_NUM_ONE]));
		  $value = str_replace($matches[CLX_NUM_ZERO], $date, $value);
        }
        switch ($value) {
		  case '!currentdate':
			 $value = xFormat::getNow('Y-m-d');
			 break;
		  case '!currentdatetime':
			 $value = xFormat::getNow('Y-m-d H:i:s');
			 break;
		  case '!username':
			 $value = $_SESSION['user_record']['username'];
			 break;
		  default:
			 break;
        }
    }
    return $value;
}
function clx_change_especial_char_html($dato) {
	$conv = array(
	
			'&lt;'=>'<',
			'&gt;'=>'>',
			'&amp;'=>'&',
			'&quot;'=>'"',
			'&nbsp;'=>' ',
			'&apos;=>'=>'\'',
			'&ntilde;'=>'ñ',
			'&Ntilde;'=>'Ñ',
			'&aacute;'=>'á',
			'&eacute;'=>'é',
			'&iacute;'=>'í',
			'&oacute;'=>'ó',
			'&uacute;'=>'ú',
			'&Aacute;'=>'Á',
			'&Eacute;'=>'É',
			'&Iacute;'=>'Í',
			'&Oacute;'=>'Ó',
			'&Uacute;'=>'Ú',
			'&euro;'=>'€',
			'&iexcl;'=>'¡',
			'&iquest;'=>'¿',
			'&ordf;'=>'ª',
			'&ordm;'=>'º',
			'&Uuml;'=>'Ü',
			'&uuml;'=>'ü',
			'&divide;'=>'÷'

			);
	return strtr($dato, $conv);
	

}
function clx_change_acentos_char_html($dato) {
	$conv = array(
	
			'ñ'=>'n',
			'Ñ'=>'N',
			'á'=>'a',
			'é'=>'e',
			'í'=>'i',
			'ó'=>'o',
			'ú'=>'u',
			'Á'=>'A',
			'É'=>'E',
			'Í'=>'I',
			'Ó'=>'O',
			'Ú'=>'U',
			'Ã¡' => 'a',
			'Ã©' => 'e',
			'Ã*' => 'i',
			'Ã³' => 'o',
			'Ãº' => 'u',
			'Ã '=> 'A',
			'Ã‰' => 'E',
			'Ã ' => 'I',
			'Ã“' => 'O',
			'Ãš' => 'U',
			'Ã±' => 'n',
			'Ã‘' => 'N',
			'Âº' => 'º',
			'Âª' => 'ª',
			'Â¿' => '¿'			
			);
			$dato=strtr($dato, $conv);
		
	return strtr($dato, $conv);
	

}
/**
 * Replace clx keywords clx
 * @params: mixed array record or string
 * @return: mixed values
 */
function clx_keywords_simple($value,$queryscriteria=0) {
    if (is_array($value)) {
        foreach ($value as $key => $val) {
            $value[$key] = clx_keywords_simple($val,$queryscriteria);
        }
    } else {
		if ($queryscriteria==1) {  
			$value = str_replace('!CURDATE', xFormat::getNow('Y/m/d'), $value);
			$value = str_replace('!CURRENT_DATE', xFormat::getNow(('Y/m/d')), $value);
			 $value = str_replace('!CURRENT_DATETIME', xFormat::getNow('Y/m/d H:i:s'), $value);
        }
		else {
        $value = str_replace('!CURDATE', xFormat::getNow($_SESSION['prefs']['DATE_FORMAT']), $value);
			$value = str_replace('!CURRENT_DATE', xFormat::getNow($_SESSION['prefs']['DATE_FORMAT']), $value);
			$value = str_replace('!CURRENT_DATETIME', xFormat::getNow($_SESSION['prefs']['DATE_FORMAT'].' H:i:s'), $value);
        }
        $value = str_replace('!CURTIME', xFormat::getNow('H:i:s'), $value);
        $value = str_replace('!CURUSER', $_SESSION['user_record']['username'], $value);
        $value = str_replace('!CURRENT_DATE', xFormat::getNow($_SESSION['prefs']['DATE_FORMAT']), $value);
        $value = str_replace('!CURRENT_TIME', xFormat::getNow('H:i:s'), $value);
        $value = str_replace('!CURRENT_DATETIME', xFormat::getNow($_SESSION['prefs']['DATE_FORMAT'].' H:i:s'), $value);
        $value = str_replace('!CURRENT_USERNAME', $_SESSION['user_record']['username'], $value);
        $value = str_replace('!CURRENT_LANGUAGE', getCurrentLanguage(), $value);
    }
    return $value;
}

/**
 * Alias for php pack
 * @param type $format
 * @param type $data
 * @return type array
 */
function clx_unpack($format, $data) {
    return unpack(array('package' => $format, 'id' => $data));
    ;
}
function change_text_change_date($contents) {
	
	preg_match_all('/DATE_FORMAT\([0-9A-Za-z\!\/\_\-\,\:\s]+\)/', $contents, $matches, PREG_OFFSET_CAPTURE);	
	$reemplazos=array('dd'=>'d','yyyy'=>'Y','yy'=>'y',':m:'=>':i:',':m'=>':i','mm'=>'m');
	foreach ($matches as $key=>$values) {
		foreach ($values as $key2=>$values2) {
			if(strpos($values2[0],"!")>0)
				continue;

			$matches2=preg_split('/(DATE_FORMAT\()|(\,)|(\))/',$values2[0]);
	//		PRINT_r($matches2);
			if (isset($matches2[2])&&!empty($matches2[2]))
				$matches2[2]=strtr($matches2[2],$reemplazos);
			else
				$matches2[2]=$_SESSION['prefs']['DATE_FORMAT'];

			if (isset($matches2[3])&&!empty($matches2[3]))
				$matches2[3]=strtr($matches2[3],$reemplazos);
			else
				$matches2[3]=$_SESSION['prefs']['DATE_FORMAT'];
			$fecha1=convert_to_date(singlequote($matches2[1]),singlequote($matches2[2]));
		//echo $fecha1,"\n";
		//echo $matches2[3],"\n";
			$contents=str_replace($values2[0],xFormat::date($fecha1,$matches2[3]),$contents);
		}

	}
	return $contents;	
	
}
function getNow($format) {
    if (empty($format))
        $format = 'Y-m-d H:i:s';
    return date($format);
}

function clearDate($date) {
    $date = str_replace(',', '', $date);
    $date = str_replace('-', '', $date);
    $date = str_replace(';', '', $date);
    $date = str_replace(':', '', $date);
    $date = str_replace(' ', '', $date);
    $date = str_replace(CLX_CHAR_CR, '', $date);
    $date = str_replace(CLX_CHAR_NL, '', $date);
    $date = trim($date);
    return $date;
}

/**
 * Returns table information
 * @param $tablecode
 */
function tableRecord($tablecode) {
    ClxCommon::$cached['TABLES_CACHE'] = array();
    if (!empty(ClxCommon::$cached['TABLES_CACHE'][$tablecode])) {
        return ClxCommon::$cached['TABLES_CACHE'][$tablecode];
    }
    if (!array_key_exists('TABLES_CACHE', ClxCommon::$cached)) {
        ClxCommon::$cached['TABLES_CACHE'] = array();
    }
    $tablerec = ClxCommon::$db->getRecord('CLX_DB_TABLES', 'IDCODE=' . singleQuote($tablecode));
    ClxCommon::$cached['TABLES_CACHE'][$tablecode] = $tablerec;
    return ClxCommon::$cached['TABLES_CACHE'][$tablecode];
}

/**
 * Returns physical table name for application tablecode.
 * @params: tablecode
 */
function tableName($tablecode) {
    if (kApcEnabled) {
        $DBTB = &getTool('DBTB');
        $tablerec = $DBTB->getTable($tablecode);
        return $tablerec['MODULECODE'] . '_' . $tablerec['IDNAME'];
    } else {
        if (!empty(ClxCommon::$cached['TABLENAMES_CACHE'][$tablecode])) {
		  return ClxCommon::$cached['TABLENAMES_CACHE'][$tablecode];
        }
        if (!array_key_exists('TABLENAMES_CACHE', ClxCommon::$cached)) {
		  ClxCommon::$cached['TABLENAMES_CACHE'] = array();
        }
        if (!empty(ClxCommon::$cached['TABLES_CACHE'][$tablecode])) {
		  ClxCommon::$cached['TABLENAMES_CACHE'][$tablecode] = ClxCommon::$cached['TABLES_CACHE'][$tablecode]['MODULECODE'] . '_' . ClxCommon::$cached['TABLES_CACHE'][$tablecode]['IDNAME'];
        } else {
		  $tablerec = ClxCommon::$db->getFields('CLX_DB_TABLES', 'MODULECODE, IDNAME', 'IDCODE=' . singleQuote($tablecode));
		  ClxCommon::$cached['TABLENAMES_CACHE'][$tablecode] = $tablerec['MODULECODE'] . '_' . $tablerec['IDNAME'];
        }
        return ClxCommon::$cached['TABLENAMES_CACHE'][$tablecode];
    }
}

/**
 * Multiple Table Search
 * array tablecodes
 * object $object usually $this
 */
function multiTableName(&$object, $tablecodes) {
    if (!empty($tablecodes)) {
        if (kApcEnabled) {
		  $DBTB = &getTool('DBTB');
		  foreach ($tablecodes as $key => $tablecode) {
			 $tablerec = $DBTB->getTable($tablecode);
				if (is_array($tablerec)==true){
			 $code = lowercase($tablerec['IDCODE']) . 'name';
			 $object->$code = $tablerec['MODULECODE'] . '_' . $tablerec['IDNAME'];
		  }
			}
        } else {
		  $rs = ClxCommon::$db->executeQuery('SELECT IDCODE, MODULECODE, IDNAME FROM CLX_DB_TABLES WHERE IDCODE IN (' . singleQuote(implode("','", $tablecodes)) . ')');
		  while ($t = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE)) {
			 $code = lowercase($t['IDCODE']) . 'name';
			 $object->$code = $t['MODULECODE'] . '_' . $t['IDNAME'];
			 ClxCommon::$cached['TABLENAMES_CACHE'][$t['IDCODE']] = $t['MODULECODE'] . '_' . $t['IDNAME'];
		  }
		  ClxCommon::$db->freeResult( $rs );
        }
    }
}

/**
 * Search string for researved word and return boolean
 * @params: string $words
 */
function reservedWords($word) {
    $words = 'INCREMENT, ACCESS, AUDIT, CLIENTIX, ALENET, LEVEL, SIZE, VIEW, ROWID, CLUSTER';
    return strpos($words, $word, CLX_NUM_ZERO) !== false;
}

/**
 * Include Code Library.
 */
function includeCodeLib($libcode, $record = array(), $msg = array()) {
    $return = true;
    if (!empty($libcode)) {
        $lib = getToolObject('ACTN', 'CODE');
		if (method_exists($lib,"execute3"))
			$lib->execute3(array('EXTRA3' => $libcode, 'EXTRA2' => ''), $record, $msg);
    } else {
        $return = false;
    }
    return $return;
}

function existsCodeLib($libcode) {
    $lib = getToolObject('ACTN', 'CODE');
    return $lib->libExists($libcode);
}

/**
 * Show log
 */
function echolog($msg='', $echo = true) {
    if ($echo === true) {
        print (isset($msg) ? $msg : '') . CLX_CHAR_NL;
    } else {
        return $msg . CLX_CHAR_NL;
    }
}

/**
 * Return SQL adition for effective date
 */
function efftDate($tablecode, $criteria, $efftdate = '') {
    $return = '';
    if (!empty($criteria)) {
        $d = ($efftdate === '') ? xFormat::getNow() : $efftdate;
        $tablename = tableName($tablecode);
        $sql = 'SELECT MAX(EFFTDATE) FROM ' . $tablename . ' WHERE ' . $criteria . ' AND EFFTDATE <= ' . singleQuote($d);
        $date = ClxCommon::$db->getOne($sql);
        if (!empty($date)) {
		  $return = 'EFFTDATE = ' . singleQuote($date);
        }
    }
    return $return;
}

function getIdlist() {
	$debug=false;
	IF (ISSET($GLOBALS['ADDRDEBUGETIDLIST']) && (empty($_SERVER['REMOTE_ADDR']) || $GLOBALS['ADDRDEBUGGETIDLIST']==$_SERVER['REMOTE_ADDR'])) {$debug=true;}	
    $idlist = array();
	if ($debug==true) {
		pre('function getidlist');
		pre('post');
		pre($_POST);
		pre('request');
		pre($_REQUEST);
		pre('userrequest');
		pre(UserRequest::$request);
		pre('userpost');
		pre(UserRequest::$post);
		
	}		
    if (!empty(UserRequest::$request['idlist'])) {
        if (strlen(UserRequest::$request['idlist']) != CLX_NUM_ZERO) {
		  $idlist = toArray(UserRequest::$request['idlist']);
        } else {
		  $idlist = array();
        }
    } else {
        foreach (UserRequest::$request as $key => $value) {
		  if (substr($key, CLX_NUM_ZERO, CLX_NUM_NINE) === 'selector_') {
			 $idlist[] = substr($key, CLX_NUM_NINE);
		  }
        }
        $idlist = array_reverse($idlist);
    }
    return $idlist;
}

/**
 * Returns an string without ca
 * @param type $string
 * @param type $case_mode (0=no change, 1=uppercase, 2=lowercase, 3=Capitalize)
 * @param type $search_chars (Default cr and lr)
 * @param type $replace_char (Default space)
 */
function clearString($string, $case_mode = CLX_NUM_ZERO, $search_chars = array(CLX_CHAR_NL, CLX_CHAR_CR), $replace_char = ' ') {
    $string = str_replace($search_chars, $replace_char, $string);
    switch ($case_mode) {
        case CLX_NUM_ONE:
		  $string = uppercase($string);
		  break;
        case CLX_NUM_TWO:
		  $string = lowercase($string);
		  break;
        case CLX_NUM_THREE:
		  $string = capitalize($string);
		  break;
        default:
		  break;
    }
    return $string;
}

/**
 * Return string as uppercase
 * @param string $string
 */
function uppercase($string) {
	return strtoupper($string);
   // return \mb_convert_case($string, MB_CASE_UPPER, string_detect_encoding($string));
}

/**
 * Returs string as lowercase
 * @param string $string
 */
function lowercase($string) {
	return strtolower($string);
   // return \mb_convert_case($string, MB_CASE_LOWER, string_detect_encoding($string));
}

/**
 * Return string capitalized
 * @param string $string
 */
function capitalize($string) {
		return ucfirst($string);
//    return mb_convert_case($string, MB_CASE_TITLE, string_detect_encoding($string));
}
function capitalize_not_boolean_separetor($string) {
    $string=mb_convert_case($string, MB_CASE_TITLE, string_detect_encoding($string));

    return strtr($string,  array(' And ' => ' and ' , ' And(' => ' and(',  ')And(' => ')and('   , ')And ' => ')and ',
						   ' Or ' => ' or '   ,   ' Or(' => ' or(',  ')Or(' => ')or('     ,   ')Or ' => ')or ',
						   ' Y ' => ' y '     ,  ' Y(' => ' y('   ,  ')Y(' => ')y('       ,  ')Y ' => ')y '   ,
						   ' O '=> ' o '       ,    ' O('=> ' o('   ,  ')O('=> ')o('         ,   ')O '=> ')o ',
						   ' De '=> ' de '));

}

/**
 * Detects string encoding
 * @param $string
 * @param $from_charset
 * @param $strict
 */
function string_detect_encoding($string, $from_charset = 'UTF-8, ISO-8859-1, ISO-8859-15', $strict = true) {
    return mb_detect_encoding($string, $from_charset, $strict);
}

/**
 * Encode to UTF 8
 */
function string_encode($string) {
    return encode_string($string);
}

/**
 * Encodes into utf8 using encoding
 * @param string $string
 * @param string $to_chartset
 * @param string $from_charset
 * @param bool $strict
 */
function encode_string($string, $to_chartset = 'UTF-8', $from_charset = 'UTF-8, ISO-8859-1, ISO-8859-15', $strict = true) {
    return mb_convert_encoding($string, $to_chartset, string_detect_encoding($string, $from_charset, $strict));
}

/**
 * Decodes from character set.
 * @param string $string
 * @param string $to_charset
 * @param string $from_charset
 * @param bool $strict
 */
function decode_string($string, $to_charset = 'ISO-8859-1', $from_charset = 'UTF-8, ISO-8859-1, ISO-8859-15', $strict = true) {
    return mb_convert_encoding($string, $to_charset, mb_detect_encoding($string, $from_charset, $strict));
}

/**
 * Returns the default tree node for a user or current user if user not
 * provided.
 *
 * @param string $fieldname
 * @param string $username
 * @return string
 */
function getAccessTreeDefNode($fieldname, $username = '') {
    $look = getToolObject('DBFT', 'TLOK');
    return $look->getDefaultTreeByUser($fieldname, $username);
}

function getLookupValue($form_fieldname, $fieldname, &$record) {

    $DBFL = &getTool('DBFL');
    $look = getToolObject('DBFT', 'LOOK');

    if (!array_key_exists($form_fieldname, $record)) {
        $record[$form_fieldname] = '';
    }
    $fieldrecord = $DBFL->getField($fieldname);
    if (empty($fieldrecord)) {
        return;
    } else {
        $record = $look->getLookupValue($form_fieldname, $fieldrecord, $record);
        if (!empty($record[$form_fieldname]) && is_array($record[$form_fieldname])) {
		  $record[$form_fieldname] = $record[$form_fieldname][CLX_NUM_ZERO];
        } else {
		  $record[$form_fieldname] = array_key_exists($form_fieldname, $record) ? $record[$form_fieldname] : '';
        }
    }
    unset($record[$fieldname]);
}

/**
 * Round Number as a string
 */
function rounder($value, $precision) {
    if (!function_exists('bcadd')) {
        return (string) round((float) $value, $precision);
    }
    $sign = '';
    $value = trim((string) $value);
    if (strpos($value, '.') === false) {
        $value .='.' . str_repeat('0', $precision);
    }
    if (strpos($value, '-.') !== false) {
        $sign = '-';
        $value = str_replace('-.', '0.', $value);
    }
    if (strpos($value, '-') !== false) {
        $sign = '-';
        $value = str_replace('-', '', $value);
    }
    if (strpos($value, '.') === CLX_NUM_ZERO) {
        $value = '0' . $value;
    }
    $dp = strpos($value, '.');
    $ln = strlen($value);
    if ($ln >= ($dp + $precision + CLX_NUM_TWO)) {
        $nv = substr($value, CLX_NUM_ZERO, $dp + $precision + CLX_NUM_TWO);
        $ls = substr($value, strlen($nv) - CLX_NUM_ONE, CLX_NUM_ONE);
        if ($ls < CLX_NUM_FIVE) {
            $value = @bcadd($value, CLX_NUM_ZERO, $precision);
        } elseif ($ls >= CLX_NUM_FIVE) {
		  $value = bcadd(substr($value, CLX_NUM_ZERO, $dp + $precision + CLX_NUM_ONE), (CLX_NUM_ONE / bcpow(CLX_NUM_TEN, $precision)), $precision);
        }
    }
    if (($sign . $value) === '-0.' . str_repeat('0', $precision)) {
        $sign = '';
    }
    return $sign . $value;
}

function bcabs($value) {
    return ($value < CLX_NUM_ZERO) ? bcmul('-1', $value) : $value;
}

function my_number_format($value, $decimals = CLX_NUM_TWO) {
    return sprintf('%01.' . $decimals . 'f', $value);
}

/**
 * General interfase for mails from queue.
 *
 * @param string $from
 * @param string $to
 * @param string $msg
 * @param string $subject
 * @param boolean $html
 * @param string $cc
 * @param string $bcc
 * @param string $replay_to
 * @param array $attachments must include array with full path to file
 * @param string $maac_email_account email account to send message. this is the MAAC email defined in clientools->system->email accounts.
 */
function clx_mail_queue($from, $to, $msg, $subject, $html = true, $cc = '', $bcc = '', $replay_to = '', $attachments = array(), $msg_txt = '', $request_receipt = false, $encoding = 'ISO-8859-1', $debug = false, $maac_email_account = '') {
    $MAIL = &getTool('MAIL');
    $MAIL->setMessageQueue($from, $to, $msg, $subject, $html, $cc, $bcc, $replay_to, $attachments, $msg_txt, $request_receipt, $encoding, $debug, $maac_email_account);
}

/**
 * General interfase for mails.
 *
 * @param string $from
 * @param string $to
 * @param string $msg
 * @param string $subject
 * @param boolean $html
 * @param string $cc
 * @param string $bcc
 * @param string $replay_to
 * @param array $attachments must include array with full path to file
 * @return boolean
 */
function clx_mail($from, $to, $msg, $subject, $html = true, $cc = '', $bcc = '', $replay_to = '', $attachments = array(), $msg_txt = '', $request_receipt = false, $encoding = 'ISO-8859-1', $debug = false) {
    $a_response = clx_mail_wres($from, $to, $msg, $subject, $html, $cc, $bcc, $replay_to, $attachments, $msg_txt, $request_receipt, $encoding, $debug);
    return !($a_response['error']) ? true : false;
}

function clx_mail_wres($from, $to, $msg, $subject, $html = true, $cc = '', $bcc = '', $replay_to = '', $attachments = array(), $msg_txt = '', $request_receipt = false, $encoding = 'ISO-8859-1', $debug = false) {
    $status = true;
    $status_msg = '';
    $random_hash = clx_mcript(date('r', time()));
    if (CLX_NUM_ONE == CLX_NUM_ONE || kDefaultMailer === 'pear') {
        //Including pear libraries
        if (!class_exists('Mail_mime')) {
		  ini_set('include_path', kPathToWebSite . kPathToPear);
		  require_once'Mail.php';      // These two files are part of Pear,
		  require_once'Mail/mime.php'; // and are required for the Mail_Mime class
        }
        //Encode according to required type change if needed
        $msg = encode_string($msg, $encoding);
        $subject = encode_string($subject, $encoding);
        $msg_txt = encode_string($msg_txt, $encoding);
        $recipients = $to;
        // Build the headers...
        $headers = array('From' => $from,
		  'To' => $to,
		  'Reply-to' => $replay_to,
		  'Subject' => $subject,
		  'Organization' => kDefaultCompany,
		  'Date' => date('r'),
		  'Message-ID' => $random_hash,
		  'X-Mailer' => 'clx-mail ' . kSystemVersion,
		  'X-Accept-Language' => clx_language_lower_upper(kSystemLanguage),
		  'X-Spam-Status' => 'No, score=-1.5',
		  'X-Spam-Score' => '-14',
		  'X-Spam-Bar' => '-',
		  'X-Spam-Flag' => 'NO',
		  'User-Agent' => 'Clientix ' . kSystemVersion
        );
        //   - Case 1002383 - GB-Acentos en notificacion por venciminento de documentacion (compliance)
        $mime_params = null;
        if ($encoding === 'UTF-8') {
		  if ($html === true) {
			 $headers['Content-Type'] = 'text/html; charset=UTF-8';
			 $mime_params = array('text_encoding' => '7bit',
			     'text_charset' => 'UTF-8',
			     'html_charset' => 'UTF-8',
			     'head_charset' => 'UTF-8'
			 );
		  } else {
			 $headers['Content-Type'] = 'text/plain; charset=' . singleQuote('UTF-') . '';
			 $headers['Content-Transfer-Encoding'] = '8bit';
		  }
        }
        if ($cc <> '') {
		  $headers['Cc'] = $cc;
		  $recipients .=',' . $cc;
        }
        if ($bcc <> '') {
		  $headers['Bcc'] = $bcc;
		  $recipients .=',' . $bcc;
        }
        if ($request_receipt === true) {
		  $headers['Disposition-Notification-To'] = $from;
        }
        // create the mime instance
        $crlf = CLX_CHAR_CR . CLX_CHAR_NL;
        $mime = new Mail_mime($crlf);
        $mime->setTXTBody($msg_txt);
        if ($html === true) {
		  $mime->setHTMLBody($msg);
        } else {
		  $mime->setHTMLBody('');
        }
        //setting attachments if defined.
        foreach ($attachments as $key => $filename) {
		  if (file_exists($filename)) {
			 $filecontents = file_get_contents($filename);
			 $mymetype = file_get_mime($filename);
			 $mime->addAttachment($filecontents, $mymetype, file_get_name($filename), false);
			 unset($filecontents);
		  }
        }
        //   - Case 1002383 - GB-Acentos en notificacion por venciminento de documentacion (compliance) - show headers and Mime arrays in output response in debugging mode
        if (!empty($debug)) {
		  echoLog('ENCODING = ' . $encoding . '<BR>' . debug_dump(CLX_CLASS_HEADERS, $headers) . debug_dump('mime_params', $mime_params));
        }
        if (is_null($mime_params)) {
		  $body = $mime->get();
        } else {
		  $body = $mime->get($mime_params);
        }
        $hdrs = $mime->headers($headers);
        $px = array();
        $px['host'] = kDefaultSmtp;      // The server to connect. Default is localhost
        $px['port'] = kDefaultSmtpPort;      // The port to connect. Default is 25
        $px['persist'] = false; //- Indicates whether or not the SMTP connection should persist over multiple calls to the send() method.
        if (kDefaultSmtpReqAuth) {
		  $px['auth'] = true;     // Whether or not to use SMTP authentication. Default is false
		  $px['username'] = kDefaultSmtpUsername;  // The username to use for SMTP authentication.
		  $px['password'] = kDefaultSmtpPassword;  // The password to use for SMTP authentication.
        } else {
		  $px['auth'] = false;
        }
        //   - Case 1002383 - GB-Acentos en notificacion por venciminento de documentacion (compliance) - To be able use with 'etc/email_test.php'
        if (!empty($debug)) {
		  // Throws SMTP debuging information to output response
		  $px['debug'] = true;
        }
        $mail = Mail::factory('smtp', $px);
        $mail_send_result = $mail->send($recipients, $hdrs, $body);
        if (PEAR::isError($mail_send_result)) {
		  $status = false;
		  $status_msg = ($mail_send_result->getMessage());
        }
    } else {
        if ($msg_txt === '') {
		  //try to present txt only
		  $msg_txt = strip_tags(str_ireplace('<br>', CLX_CHAR_NL, $msg));
        }
        //PHP Mail Option
        $headers = '';
        // Additional headers
        $cr = CLX_CHAR_CR . CLX_CHAR_NL;
        $headers .= 'From: ' . $from . $cr;
        $headers .= 'Date:' . date('r') . $cr;
        $headers .= 'Message-ID: ' . $random_hash . $cr;
        $headers .= 'Organization: ' . kDefaultCompany . $cr;
        if ($request_receipt === true) {
		  $headers .= 'Disposition-Notification-To: ' . $from . CLX_CHAR_CR . CLX_CHAR_NL; //Confirmar entrega
        }
        $headers .= 'User-Agent: Clientix ' . kSystemVersion . $cr;
        if ($replay_to <> '') {
		  $headers .= 'Reply-To: ' . $replay_to . $cr;
        }
        if ($cc <> '') {
		  $headers .= 'Cc: ' . $cc . ' ' . $cr;
        }
        if ($bcc <> '') {
		  $headers .= 'Bcc: ' . $bcc . $cr;
        }
        $headers .= 'X-Spam-Status: No, score=-1.5' . $cr;
        $headers .= 'X-Spam-Score: -14' . $cr;
        $headers .= 'X-Spam-Bar: -' . $cr;
        $headers .= 'X-Spam-Flag: NO' . $cr;
        $headers .= 'MIME-Version: 1.0' . $cr;
        $boundary = clx_mcript(date('r', time()));
        $has_attachments = (!empty($attachments)) ? true : false;
        if ($has_attachments === true) {
		  $headers .= 'Content-Type: multipart/mixed;' . $cr;
        } else {
		  $headers .= 'Content-Type: multipart/alternative;' . $cr;
        }
        $headers .= ' boundary="' . $boundary . '"' . CLX_CHAR_CR;
        $message = '';
        if ($has_attachments === true) {
		  $message = 'This is a multi-part message in MIME format.' . $cr . $cr;
        }
        $message .= '--' . $boundary . $cr;
        if ($has_attachments === true) {
		  $message .= 'Content-Type: multipart/alternative; \r';
		  $message .= ' boundary="sub' . $boundary . '"' . $cr . $cr . $cr;
		  $message .= '--sub' . $boundary . $cr;
        }
        $message .= 'Content-Type: text/plain; charset=ISO-8859-1;' . CLX_CHAR_CR;
        $message .= 'Content-Transfer-Encoding: 8bit' . $cr . $cr;
        $message .= $msg_txt . $cr;
        if ($has_attachments === true) {
		  $message .= '--sub' . $boundary . $cr;
        } else {
		  $message .= '--' . $boundary . $cr;
        }
        if ($html === true) {
		  $message .= 'Content-Type: text/html; charset=ISO-8859-1; ' . CLX_CHAR_CR;
		  $message .= 'Content-Transfer-Encoding: quoted-printable' . $cr . $cr;
		  $message .= $msg . $cr . $cr;
        }
        if ($has_attachments === true) {
		  $message .= '--sub' . $boundary . '--' . $cr . $cr;
        }
        $message .= '--' . $boundary . $cr;
        if (!empty($attachments)) {
		  //setting attachments if defined.
		  $i = count($attachments);
		  foreach ($attachments as $key => $filename) {
			 if (file_exists($filename)) {
			     CLXFreeReturn(new clx_file($filename, 'r'));
			     $filecontents = chunk_split(base64_encode(file_get_contents($filename)));
			     $filemime = file_get_mime($filename);
			     $filename = file_get_name($filename);
			 } else {
			     $filecontents = '';
			     $filemime = 'application/octet-stream';
			     $filename = '';
			 }
			 $message .= 'Content-Type: ' . $filemime . ';' . CLX_CHAR_NL;
			 $message .= ' name="' . $filename . '" ' . CLX_CHAR_NL;
			 $message .= 'Content-Transfer-Encoding: base64' . CLX_CHAR_NL;
			 $message .= 'Content-Disposition: attachment' . $cr . $cr;
			 $message .= $filecontents . $cr;
			 $i--;
			 if ($i > CLX_NUM_ZERO)
			     $message .= '--' . $boundary . $cr;
		  }
        }
        $message .= '--' . $boundary . '--' . $cr;
        $result = mail($to, $subject, $message, $headers);
        if (empty($result)) {
		  $status = false;
		  $status_msg = '[CLX] Unknown error sending email';
        }
    }
    return array('error' => !($status) ? true : false, 'errormsg' => $status_msg);
}

/**
 * Returns mime type from filename. Relays on database mime type list
 *
 * @param String $filename
 * @return String
 */
function file_get_mime($filename) {
    $return = 'application/octet-stream';
    $fname = lowercase(file_get_name($filename));
    if (strpos($filename, '.') !== false) {
        $extarr = explode('.', $fname);
        $ext = $extarr[count($extarr) - CLX_NUM_ONE];
        if (defined('CLX_MIME_$ext')) {
		  $return = constant('CLX_MIME_' . $ext);
        } else {
		  $return = ClxCommon::$db->getField('CLX_SD_MIMETYPES', 'IDCODE', 'EXTENSION = ' . singleQuote($ext));
		  define('CLX_MIME_' . $ext, $return);
        }
    }
    return $return;
}

/**
 * Returns name of file from full filename
 *
 * @param String $filename
 * @return String
 */
function file_get_name($filename) {
    $delimiter = '';
    if (strpos($filename, '\\') !== false) {
        $delimiter = '\\';
    }
    if (strpos('/', $filename) !== false) {
        $delimiter = '/';
    }
    if ($delimiter <> '') {
        $temp = explode($delimiter, $filename);
        $fname = $temp[count($temp) - CLX_NUM_ONE];
    } else {
        $fname = $filename;
    }
    return $fname;
}

/**
 * Returns file path from full filename
 *
 * @param String $filename
 * @return String
 */
function file_get_path($filename) {
    $fname = file_get_name($filename);
    return str_replace($fname, '', $filename);
}

/**
 * Currency Formating
 * @description: Returns string formated as text
 * @param: (string) $value
 * @param: (int) $decimals = 2,
 * @param: (string) $dec_point = '.'
 * @param: (string) $thousands_sep = ','
 */
function no_format($value, $decimals = CLX_NUM_TWO, $dec_point = '.', $thousands_sep = '') {
    return (string) number_format((float) $value, $decimals, $dec_point, $thousands_sep);
}

/**
 * Currency Formating
 * @description: Returns string formated as text
 * @param: (string) $value
 * @param: (int) $decimals = 2,
 * @param: (string) $dec_point = '.'
 * @param: (string) $thousands_sep = ','
 */
function clx_format_currency($value, $decimals = CLX_NUM_TWO, $dec_point = '.', $thousands_sep = ',') {
    return ($value === '') ? '' : (string) number_format(floatval($value), intval($decimals), $dec_point, $thousands_sep);
}

/**
 * Returns number from textual value
 * @param (string) $value
 * @param (string) $language
 * @param (bool) $is_integer
 * @param (bool) $is_currency
 * @param (bool) $decimal_places
 * @return string
 */

function clx_format_textual($value, $language, $is_integer = false, $is_currency = true, $decimal_places = NULL, $currency='',$gender='m') {
    $tt = new TextualNumber();
	$language=clx_language_lower_upper($language);
    if (is_null($decimal_places))
        $decimal_places = ($is_integer ? CLX_NUM_ZERO : CLX_NUM_TWO);
    try {
        //$int, $lang='en', $major = 'pound', $minor = 'pence', $is_integer=false
	return (string) $tt->GetCurrency($value, $language, '', '', $is_integer, $is_currency, $decimal_places,$currency,$gender);
    } catch (Exception $e) {
        return (string) alert($e->getMessage() . ' Contact System Administrator / Contactar a administrador del sistema');
    }
}

/**
 * Return parameter value
 */
function companyParameter($parameter_name, $comp_code = null) {
    if ($comp_code == null || $comp_code === '') {
        $s_reponse = ClxCommon::$db->getField(tableName('PRMT'), 'PVALUE', 'IDNAME=' . singleQuote($parameter_name));
    } else {
        $s_reponse = ClxCommon::$db->getField(tableName('PRMT'), 'PVALUE', 'COMP_CODE=' . singleQuote($comp_code), 'IDNAME=' . singleQuote($parameter_name));
    }
    return $s_reponse;
}
/**
 * Devuelve el valor de un parametro general de nombre $paraName, y si no lo encuentra devuelve un valor por defecto especificado en $paraDefVal
 * @param string $paraName
 * @param string $paraDefVal
 * @param string $comp_code
 * @return type string
 */
function companyParameterDef($parameter_name, $paraDefVal, $comp_code = null, $must_have_comp = false) {
    $response = companyParameter($parameter_name, $comp_code);
    if((is_null($response) || trim($response) === CLX_CHAR_EMPTY_STRING) && !is_null($comp_code) && $comp_code !== CLX_CHAR_EMPTY_STRING && $must_have_comp === false) {
        // Si no encuentra el parametro para la la compa ia, lo busca sin ella, siempre que $must_have_comp sea falso
        $response = companyParameter($parameter_name);
    }
    if(is_null($response) || trim($response) == CLX_CHAR_EMPTY_STRING) {
        $response = $paraDefVal;
    }
    return $response;
}

/**
 * Parses an string into a decimal number
 *
 * @param string $value
 * @param int $decimals
 * @param string $dec_point
 * @param string $thousands_sep
 * @return decimal value
 */
function toNumber($value, $decimals = CLX_NUM_TWO, $dec_point = '.', $thousands_sep = ',') {
    $value = str_replace(' ', '', $value); //remove any space
    $value = str_replace('%', '', $value); //remove any % signs
    $value = str_replace('-' . $dec_point, '-0' . $dec_point, $value);
    $decpos = strpos($value, $dec_point);
    $length = strlen($value);
    if ($decpos === CLX_NUM_ZERO) {
        $decpos++;
        $length++;
        $value = '0' . $value;
    }
    if ($decpos === false) {
        $decimal = ''; //no decimals
        $integer = substr($value, CLX_NUM_ZERO, $length);
    } else {
        $integer = substr($value, CLX_NUM_ZERO, $decpos);
        $decimal = substr($value, $decpos + CLX_NUM_ONE, $length - $decpos);
    }
    $decimal = str_replace($dec_point, '', $decimal);
    $decimal = str_replace($thousands_sep, '', $decimal);
    $integer = str_replace($dec_point, '', $integer);
    $integer = str_replace($thousands_sep, '', $integer);
    if ($decpos !== false) {
        $return = $integer . '.' . $decimal;
    } else {
        $return = $integer;
    }
    return $return;
}

/**
 * Count total alerts
 */
function alrt_count() {
    if (!class_exists('alrt_alerts') && ClxCommon::$db->oneExistsRecords('CLX_CODELIB', 'IDCODE = ' . singleQuote('ALRT')) > CLX_NUM_ZERO) {
        ClxFreeReturn(includeCodeLib('ALRT'));
    }
    if (class_exists('alrt_alerts')) {
        $a = new alrt_alerts();
        if ($a->user_exists()) {
		  $qty = $a->alert_count();
            $url = 'javascript:openWindow(' . singleQuote(CLX_CHAR_EMPTY_STRING) . ', ' . singleQuote('pop.php?to=EDIT&ac=POPLIST&li=MYALRT') . ',701, 400,null,null,'.singlequote( str_replace('\\','/',__FILE__).'_'. __LINE__ ).')';
		  $return = dict('GEN_LBL_ALERT_QTY', $qty) . ' ' . getSkinIcon('message', $url, dict('GEN_LBL_ALERT')) . ' ';
        } else {
		  $return = '';
        }
    } else {
        $return = '';
    }
    return $return;
}

/**
 * Sends alert message to users or group
 * @param string $msg
 * @param string $delivery_date
 * @param string $username
 * @param string $groupcode
 * @return boolean
 */
function alrt_send($msg, $delivery_date = 'now', $username = '', $groupcode = '') {
    $return = false;
    if (!class_exists('alrt_alerts')) {
        ClxFreeReturn(includeCodeLib('ALRT'));
    }
    if (class_exists('alrt_alerts')) {
        $a = new alrt_alerts();
        if ($a->user_exists()) {
		  $a->broadcast($msg, $delivery_date, $groupcode, $username);
		  $return = true;
        } else {
		  $return = false;
        }
    }
    return $return;
}

/**
 * Debugging tool. Returns a ASCCI code dump of each string character
 */
function asccidump($s_cc) {
    $s_response = '';
    for ($i = CLX_INIT_ZERO; $i < strlen($s_cc); $i++) {
        $s_response .= ord(substr($s_cc, $i, CLX_NUM_ONE)) . ' ';
    }
    return $s_response;
}

// Function End
/**
 * Output de un array capturando la salida con el buffer del response para luego
 * devolverlo formateado de tal forma de poder verlo bien en el browser sin tener
 * que hacerle un view-source. OJO esto solo se puede hacer si no se ha enviado ni
 * una sola linea al response del browser
 */
function debug_dump($nomb_var, $ar_valores) {
    $s_response = '<br>' . $nomb_var . ':<br>';
    $s_response .= str_replace(' ', CLX_CHAR_HTML_NBSP, str_replace(CLX_CHAR_NL, '<br>', print_r($ar_valores, true)));
    $s_response .= '<br>';
    return $s_response;
}

// Function End
/**
 * Returns a fixed up lenght string
 */
function fija($s_str, $n_len, $sep = null, $charset = null) {
    //return substr($s_str . str_repeat(' ', $n_len), 0, $n_len);
//e cho 'kDefaultEncoding = ' . kDefaultEncoding . ' | mb_internal_encoding = ' . mb_internal_encoding();
    if (is_null($sep)) {
        $sep = ' ';
    }
    if (is_null($charset)) {
        $charset = kDefaultEncoding;
    }
    return mb_substr($s_str . str_repeat($sep, $n_len), CLX_NUM_ZERO, $n_len, $charset);
}

// Function End
/**
 * Returns an string with fixed lenght formating. if less characters
 * characters spacer will complete the string to have fixed size.
 * @param string $val
 * @param integer $length
 * @param bool $prefix
 * @param string $spacer
 * @param bool $truncate
 */
function stringAddSpacer($val, $length, $prefix = true, $spacer = CLX_NUM_ZERO, $truncate = false) {
    $actualsize = strlen($val);
    $sizedif = $length - $actualsize;
    if ($sizedif < CLX_NUM_ZERO) {
        if ($truncate === true) {
		  $val = substr($val, CLX_NUM_ZERO, $length); //will drop error maybe
        }
    } else {
        if ($prefix === true) {
		  $val = str_repeat($spacer, $sizedif) . $val;
        } else {
		  $val .= str_repeat($spacer, $sizedif);
        }
    }
    return $val;
}

/**
 * Returns &nbsp; if the string is empty
 */
function strblank($s_str, $s_sustitition = CLX_CHAR_HTML_NBSP) {
    if (trim($s_str) === '') {
        $s_str = $s_sustitition;
    }
    return $s_str;
}

function pre($value) {
    if ( isset($_SESSION["_dEBUG"]) && $_SESSION["_dEBUG"]==99 ) {$posx=0;$pos=1602;$tta=fopen(kPathToWebSite."/".kPathToTemp."archivo.txt","a+");$te=debug_backtrace(); for ($t=0;$t<12;$t++) {if (isset($te[$t]["file"])){if ($t==$posx)fwrite($tta,chr(13).chr(10).$pos."_".$te[$posx]["function"]."_util(pre)-hora:".date("h:i:s d/m/Y").chr(13).chr(10));fwrite($tta,substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"].chr(13).chr(10));}}fclose($tta);}
	IF (ISSET($GLOBALS['ADDRDEBUGPRE']) && $GLOBALS['ADDRDEBUGPRE']==$_SERVER['REMOTE_ADDR']) {	$pos=0;$te=debug_backtrace();$posx=0;	for ($t=0;$t<12;$t++) {	if (isset($te[$t]["file"])){			if ($t==$posx)echo $pos."_".$te[$posx]["function"]."_util(pre)-hora:".date("h:i:s d/m/Y")."<br>";			echo substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"]."<br>";
	}}}
	/*$te=debug_backtrace(); 
	$pos=$posx=0;
	for ($t=0;$t<12;$t++) {
		if (isset($te[$t]["file"])){
			if ($t==$posx)
				echo $pos."_".$te[$posx]["function"]."_util(pre)-hora:".date("h:i:s d/m/Y")."<br>";
			echo substr($te[$t]["file"].str_repeat(" ",80),0,80).chr(9).$te[$t]["line"].chr(9).$te[$t]["function"]."<br>";
		}
	}*/
    $html = '<pre>' . print_r($value, true) . '</pre>'; 
    echo $html;
}

function microtime_float($get_float = true) {
    $return = (float) CLX_NUM_ZERO;
    if ($get_float === true) {
        $return = (float) microtime(true);
    } else {
        list($usec, $sec) = explode(' ', microtime(false));
        $return = ((float) $usec + (float) $sec);
    }
    return $return;
}

function batch_id() {
    return str_replace('.', CLX_CHAR_EMPTY_STRING, time() . substr(microtime(), CLX_NUM_ZERO, rand(CLX_NUM_FIVE, CLX_NUM_12)));
}

/**
 *
 * @param string $pid
 * @return string
 */
function getPid() {
   // return (string) getmypid() . '.' . getmyinode();
   return getmypid().'.'.hexdec(uniqid());
}

/**
 * Verify running PID
 * @param string $pid_requested
 * @param array $sched_params
 * @return string
 */
function ver_running_pid($pid_requested, $sched_params = array()) {
    $program_name = (isset($sched_params['PROGRAM_NAME']) ? $sched_params['PROGRAM_NAME'] : null);
    $debug = (isset($sched_params['IS_DEBUG']) && $sched_params['IS_DEBUG'] === '1');
    $where_is_the_point = strpos($pid_requested, '.');
    if($where_is_the_point !== false)
        $pid_requested = substr($pid_requested, CLX_NUM_ZERO, $where_is_the_point);
    if(is_windows() === true) {
        // Windows
        if(is_null($program_name))
		  // By default, assumes PHP*.EXE, because normally we want to verify process builder batch process
		  $program_name = 'php(.*)\.exe';
        // Regular expression to find a EXE program in task list
        $exe_pattern_general = '~\.exe~i';
        // Regular expression to find specified PID and program in task list
        $exe_pattern = '~'.$program_name.'(.*)'.$pid_requested.'(.*)~i';
        // Get tasklist
        $task_list = array();
        exec("tasklist 2>NUL", $task_list);
        if(count($task_list) < CLX_NUM_ONE) {
		  // Windows task list cannot be populated, so it's impossible to check
		  $response = '';
		  return $response;
        }
        $response = '0';
        // Verify if PID and program name
        foreach ($task_list AS $task_line) {
		  if (preg_match($exe_pattern_general, $task_line, $out) && $debug === true)
			 echo $task_line . '<br>' . CLX_CHAR_NL;
		  if (preg_match($exe_pattern, $task_line, $out)) {
			 if($debug === true)
			     echo '<h1>Windows - PID '.$pid_requested.' Detected: '.$out[0].'</h1>'; print_r($out); echo '<br/><br/>'.CLX_CHAR_NL;
			 $response = '1';
		  }
        }
    } elseif(is_linux() === true) {
        // Linux
        $response = '0';
        if(file_exists('/proc/{'.$pid_requested.'}')) {
		  if($debug === true)
			 echo '<h1>Linux - PID '.$pid_requested.' Detected</h1>'.CLX_CHAR_NL;
		  $response = '1';
        }
    } else {
        // O.S. is not windows nor linux, so it's impossible to check
        $response = '';
    }
    return $response;
}

/**
 * Adds Parent form to session
 * @param unknown_type $record
 */
function setParentForm($record) {
    if (!isset($_SESSION['parentfm'])) {
        $_SESSION['parentfm'] = array();
    }
    unset($record['confirm'], $record['parentfm'], $record['obj_uid'], $record['startat'], $record['nofr']);
    array_push($_SESSION['parentfm'], $record);
}

/**
 * Adds Parent form to session
 * @param unknown_type $record
 */
function unsetParentForm() {
    ClxFreeReturn(popHistory('pop'));
    if (!empty($_SESSION['parentfm'])) {
        array_pop($_SESSION['parentfm']);
    }
    echo 'unsetParentForm:done'; //returning output
}

/**
 * Initialices parent form history
 */
function clearParentForm() {
    $_SESSION['parentfm'] = array();
}

/**
 * Returns values for search listing criteria see ui_listing
 * @return unknown|multitype:
 */
function parentFormDecode() {
    $return = array();
    if (!empty($_SESSION['parentfm'])) {
        $return = $_SESSION['parentfm'][(count($_SESSION['parentfm']) - CLX_NUM_ONE)];
    }
	foreach ($return as $key=>$value) {
		for($k=1;$k<6;$k++) {
			if (!isset($return[$key.$k]))
				$return[$key.$k]=$value;
			if (!isset($return[$key.'_'.$k]))
				$return[$key.'_'.$k]=$value;
		}
		if (strpos($key,'_CODE')>0 AND !isset($return[str_replace('_CODE','_IDCODE',$key)])) {
			$return[str_replace('_CODE','_IDCODE',$key)]=$value;
			for($k=1;$k<6;$k++) {
				$return[str_replace('_CODE','_IDCODE',$key).$k]=$value;
				$return[str_replace('_CODE','_IDCODE',$key).'_'.$k]=$value;
			}	
		}	
		if (strpos($key,'_IDCODE')>0 AND !isset($return[str_replace('_IDCODE','_CODE',$key)])){
			$return[str_replace('_IDCODE','_CODE',$key)]=$value;
			for($k=1;$k<6;$k++) {
				$return[str_replace('_IDCODE','_CODE',$key).$k]=$value;
				$return[str_replace('_IDCODE','_CODE',$key).'_'.$k]=$value;
			}	
		
		}	
		
	}	
    return $return;
}

function os_detector() {
    if (!empty(UserRequest::$server['SERVER_SOFTWARE']) && (strpos(UserRequest::$server['SERVER_SOFTWARE'], 'Microsoft') !== false || stripos(UserRequest::$server['SERVER_SOFTWARE'], 'WIN32') )) {
        $s_response = 'windows';
    } elseif (array_key_exists('windir', UserRequest::$server) or array_key_exists('WINDIR', UserRequest::$server)) {
        $s_response = 'windows';
    } else {
        $s_response = 'unix';
    }
    return $s_response;
}

function is_linux() {
    return os_detector() === 'unix';
}

function is_windows() {
    return os_detector() === 'windows';
}

function emptytocero(&$value) {
    if (empty($value)) {
        $value = (float) CLX_NUM_ZERO;
    }
}
function sendXmlHeader() {
    UserResponse::setCustomHeaders(true);
    UserResponse::setContentDisposition('inline');
    UserResponse::setFilename('file.xml');
    UserResponse::setContentType('text/xml; charset=utf-8');
}

/**
 * Send download headers
 *
 * @param string $contents
 * @param string $filename
 * @param string $file_ext
 */


function sendDownloadFile($filename, $file_ext, $contentType = 'application/octet-stream') {
	//if ($file_ext!='xls' && $file_ext!='xlsx')
	if (ob_get_contents())
		ob_clean();
	UserResponse::setContentType($contentType);
    UserResponse::setContentDisposition('attachment');
    UserResponse::setFilename($filename . '.' . $file_ext);
    UserResponse::setKeepAlive('On');
    UserResponse::setPragma('no-cache');
    UserResponse::setExpires('0');
}
function sendAnyFile($filename='report',$file_ext='',$contentType='',$pragma='',$size='',$description='',$transferEncoding='') {
    UserResponse::setContentType($contentType);
    UserResponse::setFilename($filename . '.' . $file_ext);
    UserResponse::setSize($size);
    UserResponse::setDescription($description);
    UserResponse::setPragma($pragma);
    UserResponse::setTransferEncoding($transferEncoding);
    UserResponse::setContentDisposition('attachment');

    header('Content-type: ' . $contentType);
    header('Content-Disposition: attachment; filename=' . $filename.".".$file_ext);
    /*header('Keep-Alive: ' . $val3);
    header('Cache-control: ' . $val4);*/
    header('Pragma: ' . $pragma);
    //header('Expires: ' . $val6);
    header('Content-Length: ' . $size);
    header('Content-Description: ' . $description);
    header('Content-Transfer-Encoding: ' . $transferEncoding);


}


/**
 * Returns true if client is mobile browser otherwise false
 *
 * @return boolean
 */
function is_mobile() {
    if (!array_key_exists('HTTP_ACCEPT', UserRequest::$server)) {
        return false;
    }
    if (preg_match('/(up.browser|up.link|mmp|symbian|smartphone|midp|wap|phone)/i', lowercase(UserRequest::$server['HTTP_USER_AGENT']))) {
        return true;
    }
    if ((strpos(lowercase(UserRequest::$server['HTTP_ACCEPT']), 'application/vnd.wap.xhtml+xml') > CLX_NUM_ZERO) || ((isset(UserRequest::$server['HTTP_X_WAP_PROFILE']) or isset(UserRequest::$server['HTTP_PROFILE'])))) {
        return true;
    }
    $mobile_ua = lowercase(substr(UserRequest::$server['HTTP_USER_AGENT'], CLX_NUM_ZERO, CLX_NUM_FOUR));
    $mobile_agents = array('w3c ', 'acs-', 'alav', 'alca', 'amoi', 'audi', 'avan', 'benq', 'bird', 'blac', 'blaz', 'brew', 'cell', 'cldc', 'cmd-', 'dang', 'doco', 'eric', 'hipt', 'inno', 'ipaq', 'java', 'jigs', 'kddi', 'keji', 'leno', 'lg-c', 'lg-d', 'lg-g', 'lge-', 'maui', 'maxo', 'midp', 'mits', 'mmef', 'mobi', 'mot-', 'moto', 'mwbp', 'nec-', 'newt', 'noki', 'oper', 'palm', 'pana', 'pant', 'phil', 'play', 'port', 'prox', 'qwap', 'sage', 'sams', 'sany', 'sch-', 'sec-', 'send', 'seri', 'sgh-', 'shar', 'sie-', 'siem', 'smal', 'smar', 'sony', 'sph-', 'symb', 't-mo', 'teli', 'tim-', 'tosh', 'tsm-', 'upg1', 'upsi', 'vk-v', 'voda', 'wap-', 'wapa', 'wapi', 'wapp', 'wapr', 'webc', 'winw', 'winw', 'xda', 'xda-');
    if (in_array($mobile_ua, $mobile_agents)) {
        return true;
    }
    if (array_key_exists('ALL_HTTP', UserRequest::$server) && strpos(lowercase(UserRequest::$server['ALL_HTTP']), 'OperaMini') > CLX_NUM_ZERO) {
        return true;
    }
    return false;
}

/**
 * Get Browser Information
 * @return array unknown
 */
function getBrowser() {
    $u_agent = UserRequest::$server['HTTP_USER_AGENT'];
    $bname = 'Unknown';
    $platform = 'Unknown';
    $version = '';
    //First get the platform?
    if (preg_match('/linux/i', $u_agent)) {
        $platform = 'linux';
    } elseif (preg_match('/macintosh|mac os x/i', $u_agent)) {
        $platform = 'mac';
    } elseif (preg_match('/windows|win32/i', $u_agent)) {
        $platform = 'windows';
    }
    // Next get the name of the useragent yes seperately and for good reason
    if (preg_match('/MSIE/i', $u_agent) && !preg_match('/Opera/i', $u_agent)) {
        $bname = 'Internet Explorer';
        $ub = 'MSIE';
    } elseif (preg_match('/Firefox/i', $u_agent)) {
        $bname = 'Mozilla Firefox';
        $ub = 'Firefox';
    } elseif (preg_match('/Chrome/i', $u_agent)) {
        $bname = 'Google Chrome';
        $ub = 'Chrome';
    } elseif (preg_match('/Safari/i', $u_agent)) {
        $bname = 'Apple Safari';
        $ub = 'Safari';
    } elseif (preg_match('/Opera/i', $u_agent)) {
        $bname = 'Opera';
        $ub = 'Opera';
    } elseif (preg_match('/Netscape/i', $u_agent)) {
        $bname = 'Netscape';
        $ub = 'Netscape';
    } elseif (preg_match('/Mozilla/i', $u_agent)) {
        $bname = 'Mozilla';
        $ub = 'Mozilla';
    } else {
        $bname = 'Other';
        $ub = 'Other';
    }
    // finally get the correct version number
    $known = array('Version', $ub, 'other');
    $pattern = '#(?<browser>' . join('|', $known) .
		  ')[/ ]+(?<version>[0-9.|a-zA-Z.]*)#';
    if (!preg_match_all($pattern, $u_agent, $matches)) {
        // we have no matching number just continue
    }
    // see how many we have
    $i = count($matches['browser']);
    if ($i != CLX_NUM_ONE) {
        //we will have two since we are not using 'other' argument yet
        //see if version is before or after the name
        if (strripos($u_agent, 'Version') < strripos($u_agent, $ub)) {
		  $version = $matches['version'][CLX_NUM_ZERO];
        } else {
		  $version = $matches['version'][CLX_NUM_ONE];
        }
    } else {
        $version = $matches['version'][CLX_NUM_ZERO];
    }
    // check if we have a number
    if ($version == null || $version === '') {
        $version = '?';
    }
    return array('userAgent' => $u_agent, 'name' => $bname, 'version' => $version, 'platform' => $platform,
        'pattern' => $pattern
    );
}

/**
 * Finds IRR with the Newton Raphson method
 * IIR is rate at wich Net Present Value NPV = 0.
 * Important cash flow $cf array must have a first element less to 0 and
 * all cash
 * @param array $cf
 * 	cash flow lists in order
 * @param int $precision
 * 	Number of decimals to consider
 * @param $guess_rate = 0.1
 * 	Guest interest rate to use as an starting point
 * .
 * @return number
 */
function clx_irr($cf, $precision = CLX_NUM_8, $guess_rate = CLX_NUM_0_PT_1) {
    //If not cash flow just return
    if (empty($cf)) {
        return NAN;
    }
    //Test for first element. Should be less than 0 since it is the first
    //element
    if ($cf[CLX_NUM_ZERO] >= CLX_NUM_ZERO) {
        return NAN;
    }
    $max_iterations = CLX_NUM_THOUSAND;
    $new_guess_rate = CLX_INIT_ZERO;
    $npv = CLX_INIT_ZERO;
    $npvd = CLX_INIT_ZERO;
    for ($i = CLX_INIT_ZERO; $i < $max_iterations; $i++) {
        //Calculando npv
        $npv = clx_npv($cf, $guess_rate, false, false);
        //calculando derivada de nvp
        $npvd = clx_npv($cf, $guess_rate, false, true);
        if ($npvd == CLX_NUM_ZERO) {
		  //false one or more elements must be greater than 0
		  return NAN;
        }
        $new_guess_rate = $guess_rate - ($npv / $npvd);
        $rate_dif = round(($new_guess_rate - $guess_rate), $precision);
        $guess_rate = $new_guess_rate;
        if ($rate_dif == CLX_NUM_0_PT_00000) {
		  //just break it is cero
		  break;
        }
    }
    return round($guess_rate, $precision);
}

/**
 * Returns yields for investment
 * Dates are of from YYYY-MM-DD, price and rate must be expressed in pct 98.9%
 * @param string $settlement
 * @param string $maturity
 * @param number $rate
 * @param number $price
 * @param number $redemption
 * @param int $frequency
 * @param int $basis
 * @return Ambigous <null, string, number>
 */
function clx_yield($settlement, $maturity, $rate, $price, $redemption = CLX_NUM_HUNDRED, $frequency = CLX_NUM_ONE, $basis = null) {
    $freq = $frequency;
    if ($freq == CLX_NUM_12 || $freq == CLX_NUM_FOUR || $freq == CLX_NUM_THREE || $freq == CLX_NUM_SIX) {
        $freq = CLX_NUM_TWO;
    }
    require_once 'classes/Financial.php';
    $a = new Financial();
    $yield = $a->CLX_YIELD(strtotime($settlement), strtotime($maturity), $rate, $price, $redemption, $freq, $basis);
    if ($frequency == CLX_NUM_12 || $frequency == CLX_NUM_FOUR || $frequency == CLX_NUM_THREE || $frequency == CLX_NUM_SIX) {
        $yield = $a->EQUIVALENT_RT($yield, $freq, $frequency);
    }
    $yield = round($yield, 10);
    if ($yield == -0)
        $yield = 0;
    return $yield;
}

/**
 * Calculates the Net Present Value (NPV) of an investment
 * @param array $cf
 * 	Cash Flow
 * @param double $rate
 * 	Interest rate
 * @param boolean $rate_as_pct = false.
 * 	If true will assume interests in base 100
 * @param boolean $xnpv = false;
 * 	Returns the derivative of an investment
 * @return number
 */
function clx_npv($cf, $rate, $rate_as_pct = false, $xnpv = false) {
    $npv = CLX_INIT_ZERO;
    if (!empty($rate_as_pct))
        $rate = $rate / CLX_NUM_HUNDRED;
    if (empty($xnpv)) { //Calculating derivative
        $total = count($cf);
        for ($i = CLX_INIT_ZERO; $i < $total; $i++) {
		  $npv += $cf[$i] * pow((CLX_NUM_ONE + $rate), (CLX_NUM_MINUS_1 * $i));
        }
    } else {
        $total = count($cf);
        for ($i = CLX_INIT_ZERO; $i < $total; $i++) {
		  $npv += (CLX_NUM_MINUS_1 * $i) * $cf[$i] * pow((CLX_NUM_ONE + $rate), (CLX_NUM_MINUS_1 * ($i + CLX_NUM_ONE)));
        }
    }
    return $npv;
}

/**
 * Returns true if isin code is valid
 * @param string $isin
 * @return boolean
 */
function clx_isin($isin) {
    $status = false;
    //Status is false and isin is from panama just return true;
    //Ejemplo PAL634445NA9 es Incorrecto debe ser PAL634445NA4 segun
    //mismo problema para nicaragua NIMHCP0B0056
    // programa pero no hay forma de cotejar para garantizar el calculo
    //del digito verificador. El standard no aplica.
    //Igual se calira
    if (substr($isin, CLX_NUM_ZERO, CLX_NUM_TWO) === 'PA' || substr($isin, CLX_NUM_ZERO, CLX_NUM_TWO) === 'NI') {//Invalid isin panama no se encuentra validacion
        return true;
    }
    if (strlen(trim($isin)) <= CLX_NUM_12) {
        $cle = substr($isin, - CLX_NUM_ONE);
        $isinLeft = substr($isin, CLX_NUM_ZERO, strlen($isin) - CLX_NUM_ONE);
        $letter2number = array('A' => CLX_NUM_TEN, 'B' => CLX_NUM_11, 'C' => CLX_NUM_12, 'D' => CLX_NUM_13, 'E' => CLX_NUM_14, 'F' => CLX_NUM_15, 'G' => CLX_NUM_16, 'H' => CLX_NUM_17, 'I' => CLX_NUM_18, 'J' => CLX_NUM_19, 'K' => CLX_NUM_20, 'L' => CLX_NUM_21, 'M' => CLX_NUM_22, 'N' => CLX_NUM_23, 'O' => CLX_NUM_24, 'P' => CLX_NUM_25, 'Q' => CLX_NUM_26, 'R' => CLX_NUM_27, 'S' => CLX_NUM_28, 'T' => CLX_NUM_29, 'U' => CLX_NUM_30, 'V' => CLX_NUM_31, 'W' => CLX_NUM_32, 'X' => CLX_NUM_33, 'Y' => CLX_NUM_34, 'Z' => CLX_NUM_35);
        $isinConvertion = strtr($isinLeft, $letter2number);
        $sum = '';
        $sumFinal = CLX_INIT_ZERO;
        $offset = (strlen($isinConvertion) + CLX_NUM_ONE) % CLX_NUM_TWO;
        $isinConvertionLen = strlen($isinConvertion);
        for ($i = CLX_INIT_ZERO; $i < $isinConvertionLen; ++$i) {
		  $sum .= ((($i + $offset) % CLX_NUM_TWO) ? CLX_NUM_ONE : CLX_NUM_TWO) * $isinConvertion [$i];
        }
        $sumLen = strlen($sum);
        for ($i = CLX_INIT_ZERO; $i < $sumLen; ++$i) {
		  $sumFinal += $sum [$i];
        }
        if ($sumFinal % CLX_NUM_TEN) {
		  $cleVerif = ((int) ($sumFinal / CLX_NUM_TEN) + CLX_NUM_ONE) * CLX_NUM_TEN - $sumFinal;
        } else {
		  $cleVerif = CLX_INIT_ZERO;
        }
        if ($cle == $cleVerif) {
		  return true;
        } else {
		  $status = false;
        }
    }
    return $status;
}

/**
 * Verify cusip digit
 * @param string $cusip
 * @return boolean
 */
function isCusip($cusip) {
    $bool = true;
    return $bool;
}

/**
 * Detects if token is found on string. by default return boolean or integer otherwise.
 * if return is not boolean then position or -1 is returned if not found.
 * @param type $haystack
 * @param type $needle
 * @param type $offset
 * @param type $encoding
 * @param type $return_boolean
 * @return type
 */
function instr($haystack, $needle, $offset = CLX_NUM_ZERO, $encoding = false, $return_boolean = true) {
    if ($encoding === false) {
        $encoding = mb_internal_encoding();
    }
    $return = false;
    $pos = mb_strpos($haystack, $needle, $offset, $encoding);
    if (is_int($pos) && $pos >= CLX_NUM_ZERO) {
        $return = true;
    } else {
        $return = false;
    }
    if ($return_boolean === false) {
        $return = ($return === false) ? CLX_NUM_MINUS_1 : $pos;
    }
    return $return;
}

/**
 * Sets output to the user and wait for solution
 * @param type $contents
 * @param type $timetolast
 * @param type $template_name
 * @param type $has_menu
 */
function sendLongProcessWait($contents, $timetolast = CLX_NUM_MINUS_1, $template_name = 'master.html', $has_menu = false) {
    $stime = microtime_float();
    UserResponse::setIgnoreUserAbort(true);
    if ($timetolast == CLX_NUM_MINUS_1)
        $timetolast = (CLX_NUM_60 * CLX_NUM_60 * CLX_NUM_60); //set to 1 hour
    UserResponse::setRunTimeLimit($timetolast);
    ob_start();
    $PAGE_VARIABLES = getVariables();
    $PAGE_VARIABLES['MENUS'] = (!$has_menu) ? '' : pageMenus();
    $PAGE_VARIABLES['CONTENTS'] = $contents;
    $PAGE_VARIABLES['PAGETIME'] = rounder((microtime_float() - $stime), CLX_NUM_FOUR);
    $PAGE_VARIABLES['PAGEPEAKSIZE'] = rounder((memory_get_peak_usage(false) / CLX_NUM_1024), CLX_NUM_TWO) . ' Kb';
    echo getSkinForm($template_name, $PAGE_VARIABLES);
    $size = ob_get_length();
    // send headers to tell the browser to close the connection
    header('Content-Length: ' . $size);
    header('Connection: close');
    // flush all output
    ob_end_flush();
    ob_flush();
    flush();
}

/**
 * Update File if exists
 * @param type $filename
 * @param type $filecontent
 */
function saveAndUpdatePhpCodeEvents($filename, $filecontent) {
    $file = kPathToWebSite . kPathToCodeEvents . $filename . '.php';
    if (file_exists($file)) {
        unlink($file);
    }
    return savePhpCodeEvents($filename, $filecontent);
}

/**
 * Builds events phisical library
 */
function savePhpCodeEvents($filename, $filecontent) {
    $file = kPathToWebSite . kPathToCodeEvents . $filename . '.php';
    if (!file_exists($file)) {
        $code = '<?php ' . CLX_CHAR_NL . '/**' . CLX_CHAR_NL . '* Auto generated event file. Changes will be lost.' . CLX_CHAR_NL . '* For more information contact  support@alenet.com' . CLX_CHAR_NL . '* @since        $Date: ' . getNow('Y-m-d H:i:s') . ' ' . CLX_CHAR_NL . '*/' . CLX_CHAR_NL . CLX_CHAR_NL . str_replace(array('<?PHP', '<?php', ''), '?>', stripslashes($filecontent));
        $f = new clx_file($file, 'w');
        $f->open();
        $f->write($code);
        $f->close();
    }
    return $file;
}

function ClxFreeReturn($valor) {
    if (isset($valor)) {
        unset($valor);
    }
}

/**
 * Parses special chars
 * @param string $string
 * @param int $flags
 * @return string
 */
function clx_html_spchrs_decode($string) {
    return html_entity_decode(htmlspecialchars_decode($string, ENT_QUOTES));
}

/**
 * Reports error
 * @param type $errno
 * @param type $errmsg
 * @param type $filename
 * @param type $linenumber
 * @param type $context
 */
function report_error($errno, $errmsg, $filename, $linenumber, $context) {
    $BUGS = &getTool('BUGS');
    $BUGS->autoreport($errno, $errmsg, $filename, $linenumber, $context);
}

/**
 * Code Generator Requires 3 Parameters:
 * Format: a = Small Caps alphanumeric a-z without ñ,
 * String: Initial code Value Ex: As015 on format Aa###
 * $format='AAa#'; $string='ZZb5'; $increment=1;
 * $string=getIdcode($format, $string, $increment);
 * Increment: Integer Value of Increment;
 * @param type $format
 * @param type $string
 * @param type $increment
 * @return boolean
 */
function getIdcode($format, $string, $increment) {
    //Place Format Validation
    //Extracting Parts
    preg_match_all('/./', $string, $strReg);
    $strReg = $strReg[CLX_NUM_ZERO];
    $strCount = count($strReg);
    $strReg = array_reverse($strReg);
    //Format Parts
    preg_match_all('/./', $format, $forReg);
    $forReg = $forReg[CLX_NUM_ZERO];
    $forReg = array_reverse($forReg);
    $strRes = $strReg;
    $store = CLX_INIT_ZERO;
    for ($i = CLX_INIT_ZERO; $i < $strCount; $i++) {
        $val = ord(trim($strReg[$i]));
        $newVal = $val + ((empty($store)) ? $increment : $store);
        $store = CLX_INIT_ZERO;
        switch ($forReg[$i]) {
		  case 'A':
			 while ($newVal > CLX_NUM_90) {
			     $instance = $newVal - CLX_NUM_90;
			     $newVal = $instance + CLX_NUM_64;
			     $store++;
			 }
			 $val = $newVal;
			 break;
		  case 'a':
			 while ($newVal > CLX_NUM_122) {
			     $instance = $newVal - CLX_NUM_122;
			     $newVal = $instance + CLX_NUM_96;
			     $store++;
			 }
			 $val = $newVal;
			 break;
		  case '#':
			 while ($newVal > CLX_NUM_57) {
			     $instance = $newVal - CLX_NUM_57;
			     $newVal = $instance + CLX_NUM_47;
			     $store++;
			 }
			 $val = $newVal;
			 break;
		  default:
			 break;
        }
        $strRes[$i] = chr($val);
        if ($store == CLX_NUM_ZERO) {
		  break;
        } elseif ($store != CLX_NUM_ZERO && $i == $strCount - CLX_NUM_ONE) {
		  return '';
        }
    }

    return implode('', array_reverse($strRes));
}

/**
 * empty() function with clientix specific needs
 * @param type $value
 * @return boolean
 */
function clx_is_empty($value) {
    if (is_null($value)) {
        return true;
    }
    if (is_string($value)) {
        return (trim($value) === '' || trim($value) === 'null' ? true : false);
    }
    return (empty($value) ? true : false);
}

/**
 * Test array item for emptyness
 * @param type $key
 * @param type $array
 * @return type
 */
function clx_is_empty_array_item($key, $array) {
      return (is_array($array) && array_key_exists($key, $array) && !clx_is_empty($array[$key]))?false:true;
}

function beautiful_sql($sql,$separatornew='<br>', $sangria=" &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",$view=true) {

//    $sangria=" &nbsp;";
	$sql=str_replace("','||",'/*##concat1##*/',$sql);
	$sql=str_replace("',' ||",'/*##concat1##*/',$sql);
	$sql=str_replace("||','",'/*##concat2##*/',$sql);
	$sql=str_replace("|| ','",'/*##concat2##*/',$sql);

	$sql=str_ireplace("',' on",'/*##conmaon##*/',$sql);
	$sql=str_ireplace("','  on",'/*##conmaon##*/',$sql);
    $separator=chr(13).chr(10);

    $sql=str_replace(chr(10),'&|&#',str_replace(chr(13),'&|&#',$sql));

    $sql=str_replace(chr(9),' ',$sql);

    $tex=array("GROUP_CONCAT","LISTAGG","LEFT JOIN","RIGHT JOIN","JOIN"," ON","CREATE","SELECT","WHERE","ORDER","FROM","INSERT INTO","HAVING", "DELETE","GROUP BY","UPDATE","SET","CASE","END","WHEN");

    $sql=str_replace('()','p#181p',$sql);

    $tex2=array("(",")");

    FOR ($r=0;$r<count($tex);$r++) {

	$sql=str_ireplace($tex[$r].' ',chr(10).' '.$tex[$r].' '.chr(10),$sql);

    }

    FOR ($r=0;$r<count($tex2);$r++) {

	$sql=str_ireplace($tex2[$r],chr(10).' '.$tex2[$r].' '.chr(10),$sql);

    }

    FOR ($r=0;$r<count($tex2);$r++) {

	$sql=str_ireplace(",",",".chr(10),$sql);

    }

    $sql=str_ireplace(" AND ",chr(10).' AND ',str_ireplace(" OR ",chr(10).' OR ',$sql));

    $part=explode(chr(10),$sql);

    $sql='';

    $iden=0;

    FOR ($r=0;$r<count($part);$r++) {

		if (in_array(trim($part[$r]), $tex) or uppercase(trim($part[$r]))=='ON') {

			$sql.=$separator.str_repeat($sangria,$iden)." ".trim($part[$r]).$separator;

		}

		else if (trim($part[$r])=='(') {

			$iden+=3;

			$sql.=$separator.str_repeat($sangria,$iden)." ( ".$separator;

		   $iden+=1;

		}

		else if (trim($part[$r])==')') {

	    if ($iden>0)
			$iden-=1;

			$sql.=$separator.str_repeat($sangria,$iden)." ) ".$separator;

			$iden-=3;

		}

	else if (SUBSTR(trim($part[$r]),0,3)=='AND') {

			$sql.= $separator.str_repeat($sangria,$iden+1)." ".trim($part[$r]);

		}

		else if (SUBSTR(trim($part[$r]),0,2)=='OR') {

			$sql.=$separator.str_repeat($sangria,$iden+1)." ".trim($part[$r]);

		}



		else if (Strlen(trim($part[$r]))>0) {
			//cambio que quita el warning dentro $iden vacio
			if (empty($iden) || $iden<0)
				$iden=0;
			
			if (!isset($sangria))
				$sangria=' ';
			$sql.= $separator.str_repeat($sangria,$iden+1)." ".trim($part[$r]). $separator;
		}	

    }



    $sql=str_ireplace($separator.$separator, $separator,$sql);

    $sql=str_replace("&nbsp;"," ",$sql);

    $text=array("GROUP","INSTR","LISTAGG","SUM","MIN","MAX","NOW","COUNT","IFNULL","DATE_FORMAT","CONCAT");





    /*for($tt=0;$tt<count($text);$tt++) {

	for($tr=21;$tr>1;$tr--) {

	    $sql=str_ireplace($text[$tt]."<br>".str_repeat($sangria,$tr)." (",$text[$tt]."(",$sql);

	    $sql=str_ireplace($text[$tt]."<br>".str_repeat($sangria,$tr)."(",$text[$tt]."(",$sql);

	    $sql=str_ireplace($text[$tt]."<br> ".str_repeat($sangria,$tr)." (",$text[$tt]." (",$sql);

	    $sql=str_ireplace($text[$tt]."<br> ".str_repeat($sangria,$tr)."(",$text[$tt]."(",$sql);

	    $sql=str_ireplace($text[$tt]." <br>".str_repeat($sangria,$tr)." (",$text[$tt]." (",$sql);

	    $sql=str_ireplace($text[$tt]." <br>".str_repeat($sangria,$tr)."(",$text[$tt]."(",$sql);

	    $sql=str_ireplace($text[$tt]." <br> ".str_repeat($sangria,$tr)." (",$text[$tt]." (",$sql);

	    $sql=str_ireplace($text[$tt]." <br> ".str_repeat($sangria,$tr)."(",$text[$tt]."(",$sql);



	}



    }*/

    $sql=str_replace('p#181p','()',$sql);

    $sql=str_replace($separator,$separatornew,$sql);

    

    if ( $separatornew=='<br>')

        $sql= str_replace("<br>","<br>".chr(10),$sql);

    

  //  $sql=preg_replace('/\s+\(+\s+\*+\s+\)/','(*)',$sql);
	$pala=array("GROUP","INSTR","LISTAGG","SUM","IF","CONCAT","COUNT","AVG","MIN","MAX","INT","VARCHAR","DECIMAL","KEY","TRIM");
	$separatorx=str_replace('<','\<',str_replace('>','\>',$separatornew));
	
//	$sql= '    MAX <br>  <br> (';
//	$patron ='/MAX[\s]{0,1200}'.$separatorx.'[\s]{0,1200}'.$separatorx.'[\s]{0,1200}\(/i';
	//echo $patron,chr(10);
//	$sql=preg_replace($patron, 'rrr1'."(", $sql);
	$sql=preg_replace('/(\&\|\&\#)+/i', ' ', $sql);
	
	for ($t=0;$t<count($pala);$t++) {
		$patron ='/'.$pala[$t].'[\s]{0,1200}'.$separatorx.'[\s]{0,1200}'.$separatorx.'[\s]{0,1200}\(/i';
//		echo $patron,chr(10);
		$sql=preg_replace($patron, $pala[$t]."(", $sql);
		$patron ='/'.$pala[$t].'[\s]{0,1200}'.$separatorx.'[\s]{0,1200}\(/i';
//		echo $patron,chr(10);
		$sql=preg_replace($patron, $pala[$t]."(", $sql);
	}
	
	$sql=str_replace('/*##concat1##*/',"','||",$sql);
	$sql=str_replace('/*##concat2##*/',"||','",$sql);
	$sql=str_ireplace('/*##conmaon##*/',"',' on",$sql);

    if ($view)

        echo $sql;

    else {

        return $sql;

    }

    //echo  str_replace(chr(10)." &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",chr(10),$sql);

}
function parsing_array_input($field_name,$record) {
	if (!isset($record[$field_name]) || ( empty($record[$field_name])&& substr(trim($record[$field_name]),0,1)!=='0' )) {
		if (($pos=strpos($field_name,"["))>0) {
			$field_name_tex=substr($field_name,0,$pos);
			
			if (!empty($record[$field_name_tex])&& !empty($record[$field_name_tex][$apos=preg_replace('/(\[)|(\])/','',substr($field_name,$pos))]))
				$field_name_val=$record[$field_name_tex][$apos=preg_replace('/(\[)|(\])/','',substr($field_name,$pos))];
			else
				$field_name_val='';
		}
		else {
			$field_name_tex=$field_name;
			$field_name_val='';
		}	
	}
	else {
		$field_name_tex=$field_name;
		$field_name_val=$record[$field_name];
	}
	return array($field_name_tex,$field_name_val);
}
/*$format="2-format:0001_01_01_HH_MM_SS(____#__#__#H_i_s)";
preg_match("/\((.*?)\)/i",trim($format),$formatx);
$format=trim($formatx[1]);
echo $format,chr(10);		
echo convert_to_date('07:12:20',$format);
*/
function convert_to_date($date,$format) {
		$yeshour=false;
		if (trim($format)=='____#__#__#H_i_s') {
			$format=substr($format,11);
			$yeshour=true;
		}
		$return='';
		$sitimes=-1;
		if ($date<10 or ($sitimes=strpos($date, " "))>7) {//echo "aqyi";
			if ($sitimes>7) {
				$horas=substr($date,$sitimes);
				$date=substr($date,0,$sitimes-1);
			}
			$datex=preg_split("/[\/.,;?!#-]/" ,$date);
		//	pre($datex);
			foreach($datex as &$value){
				if (strlen($value)==1)
					$value="0".$value;
			}
			$date=implode("-",$datex);
			if ($sitimes>7) {
				$date.=$horas;
			}
		}	
		$month=$day=$year=$minute=$hour=$second='';
		for($t=0;$t<strlen($format);$t++)
			switch ($format[$t]) {
				case 'm':
					$month=substr($date,0,2);
					$date=substr($date,2);
					break;
				case 'd':
					$day=substr($date,0,2);
					$date=substr($date,2);
					break;
				case 'y':
					$year=substr($date,0,2);
					if ($year>70)
						$year+=1900;
					else
						$year+=2000;
					$date=substr($date,2);
					break;
				case 'Y':
					$year=substr($date,0,4);
					$date=substr($date,4);
					break;
				case 'i':
					$minute=substr($date,0,2);
					if (substr($minute,-1,1)==":")
						$minute=substr($date,0,1);
					$date=substr($date,strlen($minute));
					break;
				case 'h':
					$hour=substr($date,0,2);
					$date=substr($date,2);
					break;
				case 'H':
					$hour=substr($date,0,2);
					if (substr($hour,-1,1)==":")
						$hour=substr($date,0,1);
					$date=substr($date,strlen($hour));
					break;
				case 's':
					$second=substr($date,0,2);
					if (substr($second,-1,1)==":")
						$second=substr($date,0,1);
					$date=substr($date,strlen($second));
					break;
				case 'M':
					$months=array('ENE'=>'01','FEB'=>'02','MAR'=>'03','ABR'=>'04','MAY'=>'05','JUN'=>'06','JUL'=>'07','AGO'=>'08','SEP'=>'09','OCT'=>'10','NOV'=>'11','DIC'=>'12','JAN'=>'01','APR'=>'04','AUG'=>'08','DEC'=>'12');
					$month=$months[uppercase(substr($date,0,3))];
					$date=substr($date,3);
					break;
				default:
					$date=substr($date,1);
					break;
						
			}
			
			$yeshour=false;
			if (!empty($hour)) {
			##	if ($hour=="00") {
			##		$hour="24";
			##	}
				$return.=' '.$hour;
				$yeshour=true;
			}
			$yesminute=false;			
			if (!empty($minute)) {
				$return.= (($yeshour)?':' :'00:').$minute;
				$yesminute=true;
			}	
			if (!empty($second)) {
				$return.= (($yeshour)?':' :'00:').(($yesminute)? (($yeshour)?'':':') :'00:').$second;
			}
			if ($yeshour) {
				$return="0001-01-01".$return;
			}
			else if (trim($format)!='____#__#__#H_i_s') {
				$return=$year.'-'.$month.'-'.$day;
			}	
			if ($return=='--')
				$return='';
			return $return;
}

function dateX($format) {
	 new DateTime();
     return $date->format($format);
	

}
	
function AppDownloadFile($filespec_orig, $final_filename = null, $p_method = 'zip', $p_add_date = false) {
	if(class_exists('ZipArchive') && $p_method === 'zip') {
		if(is_null($final_filename)) {
			$zip_filename = basename($filespec_orig) . ($p_add_date === true ? '_'.xFormat::getNow('Y-m-d_H-i') : '') . '.zip';
		} else {
			$zip_filename = $final_filename.'.zip';
		}
		$zip_filename = kPathToWebSite . kPathToTemp . $zip_filename;
		$zip = new ZipArchive();
		if ($zip->open($zip_filename, ZipArchive::CREATE)!==TRUE) {
			exit('Cannot open zip file "'.$zip_filename.'" [TAADF-100]'.CLX_CHAR_NL);
		}
		$canonical_filespec = realpath($filespec_orig); // Elimina la combinacion de / y \ en el path, que impide agregar el archivo al .zip
		if($canonical_filespec === FALSE) {
			exit('Invalid source file name "'.$filespec_orig.'"... [TAADF-200]'.CLX_CHAR_NL);			
		}
		if(!file_exists($canonical_filespec)) {
			exit('File "'.$canonical_filespec.'" doesn\'t exist [TAADF-300]'.CLX_CHAR_NL);			
		}
		if($zip->addFile($canonical_filespec, basename($canonical_filespec)) !== TRUE) {
			exit('Cannot add "'.$canonical_filespec.'" to "'.$zip_filename.'" [TAADF-400]'.CLX_CHAR_NL);			
		}
		$zip->close();
		header('Content-Type: application/zip');
		header('Content-Disposition: attachment; filename="'.basename($zip_filename).'"');
		header('Content-Length: '.filesize($zip_filename) );
		readfile($zip_filename);
	} else {
		if(is_null($final_filename)) {
			$final_filename = $filespec_orig;
		}
		header('Content-Type: application/text');
		header('Content-Disposition: attachment; filename="'.basename($final_filename).'"');
		header('Content-Length: '.filesize($filespec_orig) );
		readfile($filespec_orig);
	}
	exit();
}
function clx_language_lower_upper($texto) {
	return lowercase(substr($texto,0,2)).uppercase(substr($texto,2));
	
	
}
//metodo especial llamada en el file_fixed_record con funciones internas de php con $GLOBALS record_size
function rpad_allfile($texto){ 		
	return str_pad(str_replace(chr(13).chr(10),'', $texto[0]),$GLOBALS['size_record'],' ',STR_PAD_RIGHT).chr(13).chr(10);
}
/*function replace_comillas_comas($cadena) {
	$repetir=(int)(substr_count($cadena, '"',0)/2+2);
	$cadena=chr(13).chr(10).$cadena;
/*	ec ho $repetir;
	ec ho $cadena;
		 preg_match(
			'/^([\_\|\+\=\*\&\^\%\$\#\@\!\{\}\:\;\'\<\>\?\/\~\[\]\(\)\t\n\r\,\s\.\-\/0-9a-zA-Z]+)/',
			
			$cadena,$match);
		//	'/^([áéíóúñÁÉÍÓÚÑ\|\+\=\*\&\^\%\$\#\@\!\{\}\:\;\'\<\>\?\/\~\[\]\(\)\t\n\r\,\s\.\-\/0-9a-zA-Z]+)"([áéíóúñÁÉÍÓÚÑ\|\+\=\*\&\^\%\$\#\@\!\{\}\:\;\'\<\>\?\/\~\[\]\(\)\t\n\r\,\s\.\-\/0-9a-zA-Z]+)"(,|\r)/',
			
	pr e($match);
d ie;	* /
	for ($t=0;$t<$repetir;$t++) {
		//ec ho substr($cadena,0,1000);
	/*	preg_match(
			'/^([áéíóúñÁÉÍÓÚÑ\_\|\+\=\*\&\^\%\$\#\@\!\{\}\:\;\'\<\>\?\/\~\[\]\(\)\t\n\r\,\s\.\-\/0-9a-zA-Z]+)"([áéíóúñÁÉÍÓÚÑ\_\|\+\=\*\&\^\%\$\#\@\!\{\}\:\;\'\<\>\?\/\~\[\]\(\)\t\n\r\,\s\.\-\/0-9a-zA-Z]+)"(,|\r)/',
			
		//	'/^([áéíóúñÁÉÍÓÚÑ\_\|\+\=\*\&\^\%\$\#\@\!\{\}\:\;\'\<\>\?\/\~\[\]\(\)\t\n\r\,\s\.\-\/0-9a-zA-Z]+)/',
			
			$cadena,
			$match);
			pre($match);
		
		die;	* /

		 $cadena=preg_replace_callback(
			'/^([áéíóúñÁÉÍÓÚÑ\_\|\¦\+\=\*\&\^\%\$\#\@\!\{\}\:\;\'\*\<\>\?\/\~\[\]\(\)\t\n\r\,\s\.\-\/0-9a-zA-Z]+)"([áéíóúñÁÉÍÓÚÑ\_\|\¦\+\=\*\&\^\%\$\#\@\!\{\}\:\;\'\*\<\>\?\/\~\[\]\(\)\t\n\r\,\s\.\-\/0-9a-zA-Z]+)"(,|\r)/',
			'cambiocomas',
			$cadena);
	}
	
	return substr(str_replace('<comas>',',',str_replace(',','{|}',$cadena)),2);
}
function cambiocomas($coincidencias) {
	
	$palab= $coincidencias[1].str_replace(',','<comas>',$coincidencias[2]).$coincidencias[3];

	return $palab;
}*/

function toupperfields($structure) {
	if (isset($structure['fields'])) {
		
		$fields=$structure['fields'];
		foreach ($fields as $keyfield=>$fieldInformation){
			if($keyfield<>uppercase($keyfield)){
				$structure['fields'][uppercase($keyfield)]= $structure['fields'][$keyfield];
				unset($structure['fields'][$keyfield]);
			}	
		}
	}
	return $structure;
}
function replace_comillas_comas(&$cadena) {
	$repetir=(int)(substr_count(substr($cadena,0,10000), '"',0)/2+1);
	
	$cadena=chr(10).$cadena;
	
for ($t=0;$t<$repetir;$t++) {
		//$cadena=preg_replace('/(\n)(.*?)"(.*?)"(,|\n)/', '$1$2'.str_replace(',','<comas>','$3').'$4', $cadena);

		$cadena=preg_replace_callback('/(\n)(.*?)"(.*?)"(,|\n)/',
		function ($matches) {//pr int_r($matches); e cho chr(10);d ie;
			return   $matches[1].$matches[2].str_replace(',','<comas>',$matches[3]).$matches[4];
		}	
			, $cadena
			
			);

		 /*$cadena=preg_replace_callback(
			'/^([áéíóúñÁÉÍÓÚÑ\_\|\¦\+\=\*\&\^\%\$\#\@\!\{\}\:\;\'\*\<\>\?\/\~\[\]\(\)\t\n\r\,\s\.\-\/0-9a-zA-Z]+)"([áéíóúñÁÉÍÓÚÑ\_\|\¦\+\=\*\&\^\%\$\#\@\!\{\}\:\;\'\*\<\>\?\/\~\[\]\(\)\t\n\r\,\s\.\-\/0-9a-zA-Z]+)"(,|\r)/',
			'cambiocomas',
			$cadena);*/
	}
	//ec ho substr(str_replace('<comas>',',',str_replace(',','{|}',$cadena)),2);
	$cadena= substr(str_replace('<comas>',',',str_replace(',','{|}',$cadena)),1);
	
}
function cambiocomillascomas($file,$retorno=false){
	
		$ft=fopen($file,'r');
		$data=fread($ft,filesize($file));
		fclose($ft);
	//	e cho "cambiox ",$file;
	//	e cho "cambio ", strlen($data),"<br>";
	//	e cho 'qca:'. filesize($file);
	//	e cho "<br>";
	//	restore_error_handler();
	//	$data=iconv("UTF-8", "WINDOWS-1252",$data);
	//	ec ho strlen($data);
	//	ec ho 'qca2:';
		$data=preg_replace('/"([\+\-0-9]+),([0-9]+)"/', "$1.$2", $data);
		$data=str_replace('""', '<comillas>', $data);
//		e cho "cambio2 ", strlen($data),"<br>";
		replace_comillas_comas($data);
		
		$data=str_replace('""', '<comillas>', $data);
//		ec ho "cambio3 ", strlen($data),"<br>";
		if($retorno) {
			return $data;
		}
		else {
	//	e cho "aca";
				
			$ft=fopen($file,'w+');
			fwrite($ft,$data);
			fclose($ft);
			clearstatcache();
		}
		
}		
function cambiocomillascomas_simple($file,$retorno=false){
		if (ISSET($GLOBALS['ADDRDEBUGVERINFORMARTION'])) {
			echo '<BR>'.$file,"<br>";
			echo "existe:",file_exists($file),"<br>";
			echo "tam:",filesize($file),"<br>";
			echo "es leible:",is_readable($file),"<br>";
			echo "permisos:",fileperms ($file),"<br>";
		}
		$data='';
		if (file_exists($file)) {
			$ft=fopen($file,'r');
			$data=fread($ft,filesize($file));
			fclose($ft);
		}
		
		
		$data=str_replace('""', '<comillas>', $data);
		$data=str_replace('"', '', $data);
		$data=str_replace('<comillas>', '"', $data);
		$data= str_replace('{finl}',chr(13).chr(10),str_replace(chr(10),' ',str_replace(chr(13).chr(10),'{finl}',$data)));

		if($retorno) {
			return $data;
		}
		else {
			
				
			$ft=fopen($file,'w+');
			fwrite($ft,$data);
			fclose($ft);
			clearstatcache();
		}
		
}
function validateDate($date, $format = 'Y-m-d'){
	$d = @DateTime::createFromFormat($format, $date);
    return $d && $d->format($format) === $date;
}		
function changepermisionfiledefault() {
	if (date('i')%5==1) {
		if(uppercase(PHP_OS)=='LINUX' && empty($_SERVER["REMOTE_ADDR"] ) &&  uppercase(posix_getpwuid(posix_geteuid())['name'])=='ROOT'){
					//pre(PRPR_USER_DEFAULT_LINUX_FILE);
			$userdefaultlinux=ClxCommon::$db->getOne('select SYPRVALUE from clx_sys_parameters WHERE SYPRKEY='.singlequote('USER_DEFAULT_LINUX_FILE'));

			dirchangepemission($ruta=str_replace('\\\\','/',kPathToWebSite),$userdefaultlinux);
			
		}	
	}
}
	
function dirchangepemission($folder,$userdefaultlinux) { 
    echo "->",$folder,"<BR>";
	$textvalida=',php,PHP,.JS.js,txt,TXT,xls,XLS,lsx,LSX,csv,CSV,css,CSS;htm;HTM;tml;TML,ava;AVA';
    $handle = opendir($folder); 
	$r=1;
	while (false !== $f = readdir($handle)) { 
		if ($f != '.' && $f != '..'        ) {
			if ($folder=="/")
				$filePath="/$f";
			else	
				$filePath = "$folder/$f"; 
			// Remove prefix from file path before add to zip. 
			if (is_dir($filePath)) {
				if ($f=='.svn')
					continue;
			}
			else if ( !stripos($textvalida ,substr($f,-3))>0 ) {
				continue;
			}	 
			$localPath =$dirname.substr($filePath, $exclusiveLength); 
		
			if (is_file($filePath)) {  
				if (file_exists($filePath)) {
					$useractualfile=posix_getpwuid(fileowner($filePath))['name'];
					if($userdefaultlinux!=$useractualfile){
						chown($filePath, $userdefaultlinux);				
					}
				}	
			}
			elseif (is_dir($filePath) and $filePath<>"/" ) { 
				dirchangepemission($filePath,$userdefaultlinux); 
			} 
		}
	}
	closedir($handle); 
}
function generateHosc($comp_code='', $qty = CLX_365_DAYS) {
	
	$lastdate = ClxCommon::$db->getOne('SELECT TO_CHAR(MAX(EFFTDATE),'.singlequote('YYYY-mm-dd').') FROM BASE_HOLIDAY_SCHEDULE WHERE COMP_CODE = ' . singleQuote($comp_code));
        if ($lastdate === '') {
		  $lastdate = date('Y-01-01');
        }
		$country = ClxCommon::$db->getOne('SELECT COUNTRY FROM BASE_COMPANIES WHERE IDCODE = ' . singleQuote($comp_code));
        $timex=strtotime('2000/01/01');
		$timex2x=$timex2=strtotime($lastdate);
		$dia=0;
		for ($k=0;$k<8;$k++) {
			$dia=round((($timex2-$timex)/86400),PHP_ROUND_HALF_UP )%7;
			if ($dia==0) {
				if ($timex2==$timex2x) {
					$timex3=$timex2+86400;
					$dia=1;
				}	
				else
					$timex3=$timex2;
				
				break;
			}	
			else if($dia==1) {
				if ($timex2==$timex2x){
					$timex3=$timex2+86400*6;
					$dia=0;
				}	
				else
					$timex3=$timex2;
				
				;
				break;
			}
			$timex2+=86400;
				
		}
		$fin=strtotime(date('Y').'-12-31')+86400;
		
		$contara=0;
		while ($timex3<$fin) {
			if ($dia==0) {	
				$lastdate=date('Y-m-d',$timex3);
				$record = array('COMP_CODE' => $comp_code,
								'COUNTRY' =>$country,
								'IDNAME' => date('l Y-m-d', $timex3), 
								'EFFTDATE' => $lastdate, 
								);
				if (++$contara>60) {
					break;
				}	
				//ClxCommon::$db->executequery('DELETE FROM BASE_HOLIDAY_SCHEDULE WHERE TO_CHAR(EFFTDATE,'.singlequote('yyyy-mm-dd').')='.singlequote($lastdate));
				
				$timex4=$timex3+86400;
				$returnID = ClxCommon::$db->createRecord('BASE_HOLIDAY_SCHEDULE', $record, false);
			}	
			else {
			   $timex4=$timex3;
			   $timex3-=86400;
			   $dia=0;
			}   
			if($timex4<$fin) {
				$lastdate2=date('Y-m-d',$timex4);
				$record = array('COMP_CODE' => $comp_code,
							'COUNTRY' =>$country,
							'IDNAME' => date('l Y-m-d', $timex4), 
							'EFFTDATE' => $lastdate2, 
							);
				//pre($record);
				//ClxCommon::$db->executequery('DELETE FROM BASE_HOLIDAY_SCHEDULE WHERE TO_CHAR(EFFTDATE,'.singlequote('yyyy-mm-dd').')='.singlequote($lastdate2));
				$returnID = ClxCommon::$db->createRecord('BASE_HOLIDAY_SCHEDULE', $record, false);
			
				
			}
			
			$timex3+=86400*7;
        }
        
}
function getcompanydefault($username) {//pre(get_defined_constants(true));
	if (ClxCommon::$db->tableExists('CLX_DEFAULT_SQL_COMPANY')==true) {

		if ($NOEXISTE=ClxCommon::$db->getOne(($XX='SELECT COUNT(1) FROM CLX_DEFAULT_COMPANY_VIEW WHERE USERNAME='.singlequote($username)))==0) {
			$sql='INSERT INTO CLX_DEFAULT_COMPANY_VIEW (COMP_CODE,USERNAME,SESSION_ID) ' . 
				'SELECT PREFVALUE,'.singlequote($username).','.singlequote(session_id()).' FROM CLX_US_PREFERENCES WHERE PREFKEY='.singlequote('UIFF_COMP_CODE').' AND PREFVALUE IS NOT NULL AND USERNAME='.singlequote($username);		
			//pre($sql);
			ClxCommon::$db->executequery($sql);
		}
		else {
			$sql='UPDATE CLX_DEFAULT_COMPANY_VIEW SET SESSION_ID = ' . singlequote(session_id()).' WHERE USERNAME='.singlequote($username);		
			ClxCommon::$db->executequery($sql);
			//pre($sql);
			
		}
		ClxCommon::$db->executequery('TRUNCATE TABLE CLX_DEFAULT_SQL_COMPANY');
		if ($x=ClxCommon::$db->getone('select count(1) from CLX_DEFAULT_SQL_COMPANY')<1) {
			IF ($NOEXISTE==TRUE ) {//ECHO 'ACA3';
				$sql='INSERT INTO CLX_DEFAULT_SQL_COMPANY (COMP_CODE,SESSION_ID) ' . 
					'SELECT PREFVALUE,'.singlequote(session_id()).' FROM CLX_US_PREFERENCES WHERE PREFKEY='.singlequote('UIFF_COMP_CODE').' AND PREFVALUE IS NOT NULL AND USERNAME='.singlequote($username);		
					ClxCommon::$db->executequery($sql);
				//pre($sql);
			
			}
			else {//ECHO 'ACA4';
					$sql='INSERT INTO CLX_DEFAULT_SQL_COMPANY (COMP_CODE,SESSION_ID) ' . 
						'SELECT COMP_CODE,'.singlequote(session_id()).' FROM CLX_DEFAULT_COMPANY_VIEW WHERE USERNAME='.singlequote($username);		
				
				ClxCommon::$db->freeResult( ClxCommon::$db->executequery($sql));
			//pre($sql);
			
			}
		}
		else {
				$sql='UPDATE CLX_DEFAULT_SQL_COMPANY SET COMP_CODE = ( ' . 
				'SELECT PREFVALUE,'.singlequote(session_id()).' FROM CLX_US_PREFERENCES WHERE PREFKEY='.singlequote('UIFF_COMP_CODE').' AND PREFVALUE IS NOT NULL AND USERNAME='.singlequote($username).')';		
				ClxCommon::$db->freeResult( ClxCommon::$db->executequery($sql));
			
		}
	}
	else {	
		/*IF(strpos(uppercase(UserRequest::$server['SCRIPT_NAME']),'WINDOW.PHP')===false && !defined('CLX_WEBSERVICE_EXEC'))
				echo "<!--no found-->";*/
	}
}
function getlistbycode($codelist) {

	$sqlz = 'SELECT DISTINCT IDCODE,IDNAME,SEQNUM FROM CLX_DB_LIST_ITEMS R WHERE LISTCODE='.singlequote($codelist).' AND INACTIVE=0 ORDER BY SEQNUM';
	$rxx = ClxCommon::$db->executeQuery($sqlz);
	$list=array();
	while ($rx = ClxCommon::$db->getNextRecord($rxx, ASSOCIATIVE)) {
		$list[$rx['IDCODE']] = $rx['IDNAME'];
	}
	ClxCommon::$db->freeResult( $rxx );
	return $list;
}
 

function GXTcolorgraphics () {
	return array( 
		'group_reds'=>    '#F08080,#FA8072,#E9967A,#FFA07A,#DC143C,#FF0000,#B22222,#8B0000',
		'group_pinks'=>   '#FFC0CB,#FFB6C1,#FF69B4,#FF1493,#C71585,#DB7093',
		'group_oranges'=> '#FFA07A,#FF7F50,#FF6347,#FF4500,#FF8C00,#FFA500',
		'group_yellows'=> '#FFD700,#FFFF00,#FFFFE0,#FFFACD,#FAFAD2,#FFEFD5,#FFE4B5,#FFDAB9,#EEE8AA,#F0E68C,#BDB76B',
		'group_grays'=>   '#DCDCDC,#D3D3D3,#C0C0C0,#A9A9A9,#808080,#696969,#778899,#708090,#2F4F4F,#000000',
		'group_greens'=>  '#ADFF2F,#7FFF00,#7CFC00,#00FF00,#32CD32,#98FB98,#90EE90,#00FA9A,#00FF7F,#3CB371,#2E8B57,#228B22,#008000,#006400,#9ACD32,#6B8E23,#808000,#556B2F,#66CDAA,#8FBC8F,#20B2AA,#008B8B,#008080',
		'group_purpples'=>'#E6E6FA,#D8BFD8,#DDA0DD,#EE82EE,#DA70D6,#FF00FF,#FF00FF,#BA55D3,#9370DB,#9966CC,#8A2BE2,#9400D3,#9932CC,#8B008B,#800080,#4B0082,#6A5ACD,#7B68EE,#483D8B',
		'group_browns'=>  '#FFF8DC,#FFEBCD,#FFE4C4,#FFDEAD,#F5DEB3,#DEB887,#D2B48C,#BC8F8F,#F4A460,#DAA520,#B8860B,#CD853F,#D2691E,#8B4513,#A0522D,#A52A2A,#800000',
		'group_blues'=>   '#00FFFF,#00FFFF,#E0FFFF,#AFEEEE,#7FFFD4,#40E0D0,#48D1CC,#00CED1,#5F9EA0,#4682B4,#B0C4DE,#B0E0E6,#ADD8E6,#87CEEB,#87CEFA,#00BFFF,#1E90FF,#6495ED,#7B68EE,#4169E1,#0000FF,#0000CD,#00008B,#000080,#191970',
		'group_whites'=>  '#FFFFFF,#FFFAFA,#F0FFF0,#F5FFFA,#F0FFFF,#F0F8FF,#F8F8FF,#F5F5F5,#FFF5EE,#F5F5DC,#FDF5E6,#FFFAF0,#FFFFF0,#FAEBD7,#FAF0E6,#FFF0F5,#FFE4E1',
		'group_mixed1'=>  '#90EE90,#FA8072,#DB7093,#FFA500,#778899,#8B0000,#C0C0C0,#F0F8FF,#FFF5EE,#DAA520,#FDF5E6,#FFFAF0,#006400,#FAEBD7,#800080,#FFF0F5,#FFE4E1',
		'group_mixed2'=>  '#F6BD0F,#8BBA00,#A66EDD,#AFD8F8,#F984A1,#778899,#A9A9A9,#FF9933,#F6BD0F,#8BBA00,#A66EDD,#AFD8F8,#F984A1,#CCCC00,#999999,#FF0000,#006F00,#0099FF',
		'group_mixed3'=>  '#7C7CB4,#FF9933,#F6BD0F,#8BBA00,#A66EDD,#AFD8F8,#F984A1,#CCCC00,#999999,#FF0000,#006F00,#0099FF,#FF66CC,#669966,#9900FF,#99FFCC,#CCCCFF,#669900,#1941A5'
        


	);
}
function windowsmodal($title='',$url='',$fondoinvisible=1) {
		$contents =	sprintf("<link href='%s' rel='stylesheet' type='text/css'>", kPathToSkins . $_SESSION["skin"] . "/style-modal.css").
		
		$contents .=(($fondoinvisible==1)?'<div class="moverlay">':'');
		$contents .='<div class="mmodal">
						<div class="mmodal-button far fa-window-close">
						</div>
						<div class="mmodal-content-title">
								<div id="title-mmodal"></title></div>
						</div> 
						<div class="mmodal-content">
							<div class="content" id="content-mmodal"></div>
						</div>
				</div>';
			$contents .=(($fondoinvisible==1)?'</div>':'');
			$contents .=setJavaScriptTag(kPathToSkins . $_SESSION['skin'] . '/modal.js', true).
		'<script>$moverlay.classList.add("active");
		$mmodal.style.animation = "mmodalIn 1s forwards";</script>';
		if ($title=='')
			$title='&nbsp;';
		$title='<h2>'.str_replace('"','',str_replace("'",'',$title)).'</h2>';
		$jscode = '$("#title-mmodal").html("'.$title.'");';
		$contents .= setJavaScriptTag($jscode, false);
	
		$jscode = '$("#content-mmodal").html(\'<br><iframe src="'.$url.'" width="100%" height="300%" seamless=1 scrolling="auto" frameborder=0></iframe>\')';
		$contents .= setJavaScriptTag($jscode, false);
	
					
		return $contents;
}

function sortsize($a,$b){
    return strlen($b)-strlen($a);
}
function sortarraysize($array) {
	return usort($array,'sortsize');
	
}
function strip_tags2($content) {
	return  str_replace('<b></b>','',str_replace('<!---->','',$content));
	
}