var dbqf_editform_msg1 = 'You must first select an item.';
var dbqf_editform_msg2 = 'You must first select the item to reorder.';
function updateForm() {
    var form = $('#theForm')[0];
    var qty = form.elements['DBQF_selected'].options.length;
    var index = form.elements['DBQF_selected'].selectedIndex;
    form.elements['delete_btn'].disabled = !(index != -1);
    form.elements['moveup_btn'].disabled = !((qty > 1) && (index != -1));
    form.elements['movedown_btn'].disabled = !((qty > 1) && (index != -1));
    if (index == -1) {
        form.elements['sort'].disabled = true;
        form.elements['visible'].disabled = true;
        form.elements['FILTER'].disabled = true;
        form.elements['grouped'].disabled = true;
        form.elements['expression'].disabled = true;
        form.elements['field_format'].disabled = true;
        form.elements['currency_field'].disabled = true;
    } else {
        form.elements['sort'].disabled = false;
        form.elements['visible'].disabled = false;
        form.elements['FILTER'].disabled = false;
        form.elements['grouped'].disabled = false;
        form.elements['expression'].disabled = false;
        form.elements['field_format'].disabled = false;
        form.elements['currency_field'].disabled = false;
        var infotext = form.elements['DBQF_selected'][index].value;

        var info = infotext.split('||');
        form.elements['sort'].selectedIndex = info[2];
        form.elements['visible'].selectedIndex = info[3];
        form.elements['FILTER'].selectedIndex = info[4];
        form.elements['grouped'].selectedIndex = info[5];
        form.elements['expression'].value = info[6];
        form.elements['field_format'].value = info[7];
        /*if(info[8]==''){
         form.elements['currency_field'].selectedIndex = 0;
         }else{*/

        form.elements['currency_field'].value = info[8];
        //}

    }
}


function setOptions() {

    var form = $('#theForm')[0];
    var index = form.elements['DBQF_selected'].selectedIndex;
    var infotext = form.elements['DBQF_selected'][index].value;
    var info = infotext.split('||');
    info[2] = form.elements['sort'].selectedIndex;
    info[3] = form.elements['visible'].selectedIndex;
    info[4] = form.elements['FILTER'].selectedIndex;
    info[5] = form.elements['grouped'].selectedIndex;
    info[6] = form.elements['expression'].value;
    info[7] = form.elements['field_format'].value;
    info[8] = form.elements['currency_field'].value;
    form.elements['DBQF_selected'][index].value = info[0] + '||' + info[1] + '||' + info[2] + '||' + info[3] + '||' + info[4] + '||' + info[5] + '||' + info[6] + '||' + info[7] + '||' + info[8];
}


function updateFields() {
    var form = $('#theForm')[0];
    var t = form.elements['DBQF_tables'].selectedIndex;

    clearpop(form.elements['DBQF_fields']);

    var qty = fields[t].length;
    for (var i = 0; i < qty; i++) {
        additem(form.elements['DBQF_fields'], fields[t][i]);
    }
    form.elements['DBQF_fields'].selectedIndex = 0;
    updateForm();
}

function updatedFields() {

    var form = $('#theForm')[0];
    var t = form.elements['DBQF_tables'].selectedIndex;

    clearpop(form.elements['DBQF_dfields']);

    var qty = dfields[t].length;
    for (var i = 0; i < qty; i++) {
        additem(form.elements['DBQF_dfields'], dfields[t][i] + '_WRK');
    }
    form.elements['DBQF_dfields'].selectedIndex = 0;
    updateForm();
}


function clearpop(pop) {
    var i = 0;
    var o = pop.options;
    for (var i = o.length; i >= 0; --i) {
        o[i] = null;
    }
    pop.disabled = true;
}

function additem(pop, info) {
    var list = pop.options;
    var nIdx;

    if (list.length < 0) { //IE for Mac 4.5 sets length to -1 if list is empty
        nIdx = 0;
    }
    else {
        nIdx = list.length;
    }
    var values = info.split('||');
    list[nIdx] = new Option(values[1], values[0] + '.' + values[1]);
    pop.disabled = false;
}

function moveItem(bDir, fromList) {

    var form = $('#theForm')[0];
    fromList = form.elements[fromList];
    var el = fromList.options;
    var idx = el.selectedIndex;
    if (idx == -1) {
        alert(dbqf_editform_msg2);
    }
    else {
        var nxidx = idx - bDir;
        if (nxidx < 0) {
            nxidx = el.length - 1;
        }
        if (nxidx >= el.length) {
            nxidx = 0;
        }
        var oldVal = el[idx].value;
        var oldText = el[idx].text;
        var newVal = el[nxidx].value;
        var newText = el[nxidx].text;
        el[idx] = new Option(newText, newVal);
        el[nxidx] = new Option(oldText, oldVal);
        el.selectedIndex = nxidx;

    }

}

function selectItem(fromList, toList) {
    var form = $('#theForm')[0];
    fromList = form.elements[fromList];
    toList = form.elements[toList];
    var picked = []; //Selected Items

    for (var j = 0; j < fromList.options.length; j++) {
        if (fromList.options[j].selected === true && picked[j] !== true) {
            //var index = fromList.selectedIndex;
            var index = j;//fromList.selectedIndex;
            if (index == -1) {
                alert(dbqf_editform_msg1);
            } else {
                var option = fromList[index];
                var i = toList.length;

                //toList[i] = new Option(option['value'], option['value']+ '.0.1.0');
                toList[i] = new Option(option['value'], option['value'].replace('.', '||') + '||0||1||0||0||||0||.');
                toList.selectedIndex = i;
            }
            picked[j] = true;
            updateForm();
            //End Original
        }

    }
}

function deleteItem(fromList) {
    var form = $('#theForm')[0];
    fromList = form.elements[fromList];
    var length = fromList.options.length;
    for (var j = length - 1; j >= 0; j--) {
        if (fromList.options[j].selected === true) {
            /*
             var index = fromList.selectedIndex;
             fromList[index] = null;
             */
            fromList[j] = null;
            updateForm();
        }
    }
}

function processForm() {
    var form = $('#theForm')[0];
    var selected = form.elements['DBQF_selected'].options;
    var qty = selected.length;
    var fields = '';
    var delim = '';

    for (var i = 0; i < qty; i++) {
        fields += delim + selected[i].value;
        //delim = ',';
        delim = '-END-';
    }
    form.elements['selected'].value = fields;
    return true;
}

