$.fn.focusNextInputField = function () {
    return this.each(function () {
        var fields = $(this).parents('form:eq(0),body').find(':input').not('[type=hidden]');
        var index = fields.index(this);
        if (index > -1 && (index + 1) < fields.length) {
            fields.eq(index + 1).focus();
        }
        return false;
    });
};
function prevDef(event) {
    if (event.preventDefault()) {
        event.preventDefault();
    } else {
        new Event(event).preventDefault();
    }
}
function setFieldReadOnly() {
    $(this).focus(function (event) {
        if ($(this).attr("class") == "readonly") {
            prevDef(event);
            $(this).focusNextInputField();
        }
    });
    $(this).click(function (event) {
        if ($(this).attr("class") == "readonly") {
            prevDef(event);
            $(this).focusNextInputField();
        }
    });
    $(this).dblclick(function (event) {
        if ($(this).attr("class") == "readonly") {
            alert("Not allowed");
            $(this).focusNextInputField();
        }
    });
    $(this).mousedown(function (event) {
        if ($(this).attr("class") == "readonly") {
            $(this).focusNextInputField();
            prevDef(event);
        }
    });
}
function setFieldReadLoad() {
    $('select[class="readonly"]').each(setFieldReadOnly);
}
$(document).ready(function () {
    setFieldReadLoad();

    var fm = $("#theForm input[name=fm]");
    var it = $("#theForm input[name=it]");
    if(fm.val() == 'GLREP_CONS' && it.val() == 'GLREP_CONS'){
        /*$("#theForm input[name=RTBL_REP_DET_LEVEL]").click(function(){
            if($("#theForm input[name=RTBL_REP_DET_LEVEL]:checked").val()=='1'){
                $('#RTBL_FI_TYPE_CONSOLIDATED').val('');
                $('#LBL_RTBL_FI_TYPE_CONSOLIDATED').hide();
                $('#FLD_RTBL_FI_TYPE_CONSOLIDATED').hide();
            }else{
                $('#LBL_RTBL_FI_TYPE_CONSOLIDATED').show();
                $('#FLD_RTBL_FI_TYPE_CONSOLIDATED').show();
            }
        });*/

        $('#RTBL_EMISSION_TYPE').change(function(){
            if($(this).val() == 'FD'){
                $("#theForm input[name=RTBL_REP_DET_LEVEL]").filter('[value=0]').prop('checked', true);
                $("#theForm input[name=RTBL_REP_DET_LEVEL]").attr("disabled",true);
            }else{
                $("#theForm input[name=RTBL_REP_DET_LEVEL]").attr("disabled",false);
            }
        });

        $("form").submit(function (e) {
            if($("#theForm input[name=RTBL_CHART_FIELD01_prim]").val() != ''){
                $('#RTBL_EMISSION_TYPE').val('AG');
                $('#RTBL_REP_DET_LEVEL').val(0);
                $('#RTBL_FI_TYPE_CONSOLIDATED').val('');
            }

            /*if($("#theForm input[name=RTBL_REP_DET_LEVEL]:checked").val()=='1' && $("#theForm input[name=RTBL_CHART_FIELD01_prim]").val() == ''){
                $('#RTBL_EMISSION_TYPE').val('AG');
            }*/

            if($('#RTBL_EMISSION_TYPE').val() == 'FD')
                $('#RTBL_PROCESS_BATCH').val(1);
                //$('#RTBL_REP_DET_LEVEL').val(0);
            //e.preventDefault();
        });
    }
});