<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('anog') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'anog.php';

class anog_msword extends anog {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'ADOC';
        $this->name = 'Microsoft Word';
        $this->type = 'ANOG';
        $this->version = '0.1.0.1';
        $this->description = 'Output Generator Form Format: Microsoft Word';
        $this->editPanel = array('entries' => array(
			 array('label' => 'GEN_LBL_MSWORDFILE',
			     'fields' => array(
			         array('name' => 'mswordfile', 'type' => 'file'))
			 )
		  )
        );
    }

}
