<?php

if (!class_exists('plot') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'plot.php';

/**
 * Funnel Plot Object
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version    	$Rev: 9615 $
 */
class plot_fc2funnel extends plot {

    var $operators;

    /**
     * CONSTRUCTOR
     */
    function __construct() {
        $this->code = 'PLFE';
        $this->name = 'Single Series - Funnel';
        $this->type = 'PLOT';
        $this->version = '1.0.0.1';
        $this->description = 'The Clientix - Funnel Chart';
        $this->plotfile = 'FI2_Funnel.swf';
        $this->has_range = false;
        $this->serie_types = array('VAL' => dict('GEN_LABEL_VALUE'), 'CAT' => dict('GEN_LABEL_CATEGORY'), 'XAXI' => dict('GEN_LABEL_XAXIS'), 'YAXI' => dict('GEN_LABEL_YAXIS'));
    }

    /**
     * The following procedures are intented to be used by the Database
     * Administrator to interface with the user when creating new fields in the database.
     */
    function panel($msg, $plotrecord, &$form) {
        $table = new htmlTable(CLX_WIDTH_TWO);
        $table->setProps(array(CLX_PROP_CLASS => CLX_CLASS_FORM));
        $div = new htmlDiv($this->code, 'visibility:hidden; display:none', $table->source());
        return CLX_CHAR_NL . CLX_CHAR_NL . $div->source() . CLX_CHAR_NL . CLX_CHAR_NL;
    }

}
