<?php
/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
class util extends clx_object {

    var $haspanel;
    var $panelform;

    function __construct() {
	$this->code = 'UTIL';
	$this->name = 'Generic Utility';
	$this->type = '----';
	$this->version = '0.2.1.0';
	$this->description = 'This is a generic utility';
	$this->haspanel = false;
    }

    function panel($msg) {
	$form = new clx_form($this->code, $this->panelform);
	$form->setArgument(CLX_PROP_TO, $this->type);
	$form->setArgument('ut', $this->code);
	return $form->editForm('PANEL', array(), UserRequest::$post, $msg);
    }

    function checkPanel(&$msg) {

	$form = new clx_form($this->code, $this->panelform);
	$result = $form->checkForm1(UserRequest::$post['ac'], UserRequest::$post, $msg);
	unset($result);
	return (count($msg) == CLX_NUM_ZERO) ? true : false;
    }

    function execute_() {
	return CLX_CHAR_EMPTY_STRING;
    }

}
