<?php

/**
 * General Report Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: imrsnik $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-30 14:14:32 +0000 (Wed, 30 Sep 2015) $
 * @version        $Rev: 7065 $
 * @package		Clientix.Classes.Report
 * @abstract		Abstract Class
 */
class clx_report_object {

    private $object_type;
    var $disable_borders = false;
    private $ln_post = CLX_INIT_ZERO;

    function __construct() {
        $this->setObjectType('OBJ');
    }

    function getType() {
        return $this->object_type;
    }

    function setObjectType($type) {
        $this->object_type = $type;
    }

    function setLnPost($num) {
        $this->ln_post = $num;
    }

    function getLnPost() {
        return $this->ln_post;
    }

    //FORMATING
    function sourceHtml() {
//        $contents = 'No General Format Defined';
        return;
    }

    function sourceText() {
 //       $contents = 'No General Format Defined';
        return;
    }

    function sourcePdf(&$pdf) {
	ClxFreeReturn($pdf);
        return 'No General Format Defined';
    }

    function sourceMsExcel(&$ws, &$wb) {
	ClxFreeReturn($ws);
	ClxFreeReturn($wb);
        return 'No General Format Defined';
    }

}
