<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-22 14:34:58 -0400 (Tue, 22 Sep 2015) $
 * @version        $Rev: 6953 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
if (!function_exists('setCreationData')) {

    function setCreationData(&$record) {

        $obj = getToolObject('ACTN', 'RARD');
        $obj->setRecordInformation('CREATE', true, true, false, '', $record);
        return $record;
    }

    function setModificationData(&$record) {//Updating MDate
        $obj = getToolObject('ACTN', 'RARD');
        $obj->setRecordInformation('MODIFY', true, true, false, '', $record);
        return $record;
    }

    function setCreationIdCode(&$record, $tablecode) {//Creating new IDCode
        $obj = getToolObject('ACTN', 'RARD');
        $obj->setRecordInformation('MODIFY', false, false, true, $tablecode, $record);
        return $record;
    }

    /**
     * Init idcode on form
     *
     * @param string $tablecode
     * @param array $record
     */
    function init_idcode($tablecode, &$record) {
        if (UserRequest::$request['ac'] === 'DUPLICATE') {
            $record[$tablecode . '_IDCODE'] = 'AUTO';
        }
    }

     /**
     * Returns Integer sequence for a table
     * 'Params: table record, table code, idcodefieldname Key to search last seqnum, sequence fieldname
     */
    function nextSeqNumber(&$record, $tablecode, $idcodefieldname, $seqfieldname) {
        if (array_key_exists($idcodefieldname, $record)) {
            $record[$seqfieldname] = ClxCommon::$db->getOne(' SELECT MAX(' . $seqfieldname . ')+1 FROM ' . tableName($tablecode) . ' WHERE ' . $idcodefieldname . ' = ' . singleQuote($record[$idcodefieldname]));
            if (empty($record[$seqfieldname]))
                $record[$seqfieldname] = CLX_NUM_ONE;
        }
        return $record;
    }

}