<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: fsantana $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version        $Rev: 6814 $
 *
 * CHANGE LOG
 * 2009/09/02 Included svn prop
 */
class Aagi {

    /**
     * Constructor
     * @param array [$procParameters]
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('FIAS', 'FIAE', 'PROD', 'PRAT', 'GLAC', 'AAGI', 'AAGR'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->je_source = '';
    }

    /**
     * Initialice fiat form - Executed on init event
     *
     * @param unknown_type $record
     */
    function init_form(&$record) {
        $calling_page = peekHistory();
        if (!empty($calling_page['parentrecord']['AAGR_CLX_EFFTDATE'])) {
            $record['AAGI_EFFTDATE'] = $calling_page['parentrecord']['AAGR_CLX_EFFTDATE'];
        }
        $record['AAGI_AGREEMNT_CLASS'] = $calling_page['parentrecord']['AAGR_AGREEMNT_CLASS'];
        $record['AAGI_SEQNUM'] = ClxCommon::$db->getOne('SELECT MAX(SEQNUM)+1 SEQNUM FROM ' . $this->aaginame . ' WHERE AGREEMENT_CODE = ' . singleQuote($calling_page['parentrecord']['AAGR_IDCODE']) . ' AND EFFTDATE = ' . singleQuote($record['AAGI_EFFTDATE']));
        if (empty($record['AAGI_SEQNUM']))
            $record['AAGI_SEQNUM'] = CLX_NUM_ONE;
    }

    /**
     * Initialice fiat form - Executed on init event
     *
     * @param unknown_type $record
     */
    function load_form(&$record) {
        $record['AAGI_AGREEMNT_CLASS'] = ClxCommon::$db->getField($this->aagrname, 'AGREEMNT_CLASS', 'IDCODE = ' . singleQuote($record['AAGI_AGREEMENT_CODE']) . ' AND CLX_EFFTDATE = ' . singleQuote($record['AAGI_EFFTDATE']));
    }

}
