<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-10-20 09:43:11 -0400 (Fri, 20 Oct 2017) $
 * @version        $Rev: 9591 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Proj {

    /**
     * Constructor
     * @param array [$procParameters]
     */
    function __construct($procParameters = array()) {
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->je_source = '';
    }

    /**
     * Initialice fiat form - Executed on init event
     *
     * @param unknown_type $record
     */
    function init_form(&$record) {
        $parent = peekHistory();
        if (UserRequest::$request['ac'] === 'CREATE' && empty(UserRequest::$post['confirm']) && !empty($parent['parentrecord'])) {
            $parent = $parent['parentrecord'];
            $record['PROJ_COMP_CODE'] = $parent['FICO_COMP_CODE'];
        }
    }
    
    function init_form_bdln_form(&$record) {
        if (UserRequest::$request['ac'] === 'DUPLICATE' && empty(UserRequest::$post['confirm'])) {
            $record["BDLN_IDCODE"] = "AUTO";
            $record["BDLN_CLX_AUTH_STATUS"] = "PEND";
        }
    }

}
