<?php 
/**
* Auto generated event file. Changes will be lost.
* For more information contact  support@alenet.com
* @since        $Date: 2023-11-08 09:54:17 
*/

define('EOL',(PHP_SAPI == 'cli') ? PHP_EOL : '<br />');
	$callStartTime = microtime(true);

	require_once(kPathToWebSite . kPathToPear .'PHPExcel/Classes/PHPExcel.php');
	require_once(kPathToWebSite . kPathToPear .'PHPExcel/Classes/PHPExcel/Reader/Excel2007.php');


$sql = 'SELECT TB.MODULECODE, TBIN.TABLECODE, TB.IDNAME, INCO.FIELDNAME
FROM CLX_DB_TABLES TB, CLX_DB_TABLEINDEXES TBIN, CLX_DB_INDEX_COLUMNS INCO
WHERE TBIN.TABLECODE=TB.IDCODE
AND TBIN.TYPE = '. singleQuote('UNI') .'
AND INCO.INDEX_CODE=TBIN.IDCODE
AND INCO.FIELDNAME IN (SELECT DBFD.FIELDNAME FROM CLX_DB_FIELDS DBFD
	WHERE DBFD.FIELDNAME=INCO.FIELDNAME AND DBFD.FIELDTYPE='. singleQuote('LOOK')  . ' AND DBFD.FIELD_EXTRA1='.singleQuote('ACCO')  .' AND DBFD.FIELD_EXTRA2='.singleQuote('IDCODE').' )
ORDER BY 1, 2, 3';
$result = ClxCommon::$db->executeQuery($sql);
$found=0;
while ($row = ClxCommon::$db->getNextRecord($result, ASSOCIATIVE)){
	if($row['TABLECODE']=='JEBL' || $row['TABLECODE']=='DDUP')
		continue;

	$sql_index = 'SELECT INDICE.IDCODE, COUNT(*) FROM CLX_DB_TABLEINDEXES INDICE, CLX_DB_INDEX_COLUMNS COLUMNA WHERE INDICE.IDCODE=COLUMNA.INDEX_CODE AND INDICE.TABLECODE='.singleQuote($row['TABLECODE']).' AND INDICE.TYPE = '.singleQuote('UNI').' GROUP BY INDICE.IDCODE HAVING COUNT(*) > 1';
	$index = ClxCommon::$db->executeQuery($sql_index);
	if($index){
		while ($row_index = ClxCommon::$db->getNextRecord($index, ASSOCIATIVE)){
			$sqlIndexColumns = 'SELECT FIELDNAME FROM CLX_DB_INDEX_COLUMNS WHERE INDEX_CODE = '.singleQuote($row_index['IDCODE']);
			$resp_columns = ClxCommon::$db->executeQuery($sqlIndexColumns);
			$sql_ddup = 'SELECT ';
			$string_column = '';
			$table_title = array();
			while ($row_column = ClxCommon::$db->getNextRecord($resp_columns, ASSOCIATIVE)){
				if($row_column['FIELDNAME'] != 'ACCOUNTCODE' && $row_column['FIELDNAME'] != 'CHART_FIELD02' && $row_column['FIELDNAME'] != 'ACGR_PART'){
					$string_column.= $row['TABLECODE'].'.'.$row_column['FIELDNAME'].',';
					$table_title[] = $row_column['FIELDNAME'];
				}
			}
			$table_title[] = 'NEW_IDCODE';
			$table_title[] = 'COUNT(*)';
			$sql_ddup = $sql_ddup.$string_column.' DDUP.NEW_IDCODE, COUNT(*) FROM '.$row['MODULECODE'].'_'.$row['IDNAME'].' '.$row['TABLECODE'].' INNER JOIN CRM_ACCODUPS_TMP DDUP ON DDUP.OLD_IDCODE='.$row['TABLECODE'].'.'.$row['FIELDNAME'].' GROUP BY '.$string_column.' DDUP.NEW_IDCODE HAVING COUNT(*) > 1';
			pre($row['TABLECODE']);
			pre($sql_ddup);
			$result_ddup = ClxCommon::$db->executeQuery($sql_ddup);
			if(ClxCommon::$db->numRows($result_ddup)==0)
				continue;
			else{
				if(empty($i)){
					$i=0;
					$objPHPExcel = new PHPExcel();
					$styleArray = array(
						'font' => array(
						'bold' => true
						)
					);
				}
				if($i!=0)
					$objPHPExcel->createSheet();
				$objPHPExcel->setActiveSheetIndex($i);
				$objPHPExcel->getActiveSheet()->setTitle($row['TABLECODE']);
				$i++;
			}

			if($result_ddup){

				$letters = range('A', 'Z');
				foreach($table_title as $k => $v){
					$objPHPExcel->getActiveSheet()->setCellValue($letters[$k].'1', $v);
				}
				$sheet = $objPHPExcel->getActiveSheet();
				$sheet->getStyle('A1:AC1')->applyFromArray($styleArray);

				$numFields = ClxCommon::$db->numFields($result_ddup);
				$line = 2;
				while ($row_ddup = ClxCommon::$db->getNextRecord($result_ddup, ASSOCIATIVE)){
					foreach($table_title as $k => $v){
						$objPHPExcel->getActiveSheet()->setCellValue($letters[$k].$line, $row_ddup[$v]);
					}
					$line++;
				}
			}else{
				$found++;
			}
		}
	}
echo '<hr>';
}
if($found>0){
	$objPHPExcel->setActiveSheetIndex(0);
	$objPHPExcel->getActiveSheet()->setCellValue('A1',"No se encontraron registros");
}




$callEndTime = microtime(true);
$callTime = $callEndTime - $callStartTime;


$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
#$objWriter->save(str_replace('.php', '.xlsx', __FILE__));
$objWriter->save(str_replace(__FILE__,kPathToWebSite .'temp/TABLES_INDEXES_DDUP.xlsx',__FILE__));
echo 'Call time to write Workbook was ' , sprintf('%.4f',$callTime) , " seconds" , EOL;
// Echo memory usage
echo date('H:i:s') , ' Current memory usage: ' , (memory_get_usage(true) / 1024 / 1024) , " MB" , EOL;
// Echo memory peak usage
echo date('H:i:s') , " Peak memory usage: " , (memory_get_peak_usage(true) / 1024 / 1024) , " MB" , EOL;
echo '<a href="temp/TABLES_INDEXES_DDUP.xlsx">Descargar Excel</a>';