<?php

//	CONSTANTS.PHP
//	System Wide Constants.  Or in windows, 'the ini file'
//	Date:
// System Version
define('kSystemVersion', '5.0.0.0');
// System Language
define('kSystemLanguage', 'en');
define('kSystemLoginLanguage', 'en');
//-- DATABASE PARAMETERS
// List all Databases to by used. Database types:  mysql(<V4.1) | mysqli(V4.1+) | mssql | oci(oracle V7+)
// Database URL or Oracle TNS name, usualy is 'localhost', if Apache/IIS is running in the
// same machine as the MySQL Server.
// If not, is an ip address or url., The user name and password to access the Database Server
$kDatabase = array();
$kDatabase[] = array('System Alias', 'mysql', 'localhost', 'dbname', 'dbuser', 'dbpass');
$kDatabase[] = array('System Alias 2', 'mysql', 'localhost', 'dbname 2', 'dbuser 2', 'dbpass 2');
//Mysql Version, current version 5+
//For mysql prior to 50 set 41, 40 etc
define('kMysqlVersion', '5.0');
//-- DIRECTORY PARAMETERS
// The absolute path to the system.  If you are on a Windows system
// this path will be something like: 'c:/Inetpub/wwwroot/clientix/'.
// On a Unix/Linux system it will be something like: '/user/docs/http/'
define('kPathToWebSite', UserRequest::$server['DOCUMENT_ROOT'] . '/.../');
// Directory name.' WHERE the tools are stored...
//(make sure it ends with '/', usualy 'tools/')
define('kPathToTools', 'tools/');
// Directory name.' WHERE the objects are stored...
// (make sure it ends with '/', usualy 'objects/')
define('kPathToObjects', 'objects/');
// Directory to save uploaded files
// (make sure it ends with '/', usualy 'data/files/')
define('kPathToData', 'data/files/');
// Directory to save uploaded code
// (make sure it ends with '/', usualy 'data/code/')
define('kPathToCode', 'data/code/');
// Directory to save uploaded templates
// (make sure it ends with '/', usualy 'data/code/')
define('kPathToTemplates', 'data/templates/');
// Directory to save packages
//(make sure it ends with '/', usualy 'packages/')
define('kPathToPackages', 'packages/');
// Directory to save skins
//(make sure it ends with '/', usualy 'skins/')
define('kPathToSkins', 'skins/');
// Directory to save export fiels
// (this directory should exist, make sure it ends with '/', usualy 'temp/')
define('kPathToExport', 'export/');
// Directory to save temporal files
// (this directory should exist, make sure it ends with '/', usualy 'temp/')
define('kPathToTemp', 'temp/');
// Directory to save temporal files
// (this directory should exist, make sure it ends with '/', usualy 'temp/')
define('kPathToPear', 'PEAR/');
// Directory to save temporal files
// (this directory should exist, make sure it ends with '/', usualy 'temp/')
define('kPathToSendmail', '/usr/lib/sendmail');
// PDF Forms direct acces to the pictures.
define('kDirectPathToArchive', UserRequest::$server['DOCUMENT_ROOT'] . '/data/archive/');
// The name of the web site.
define('kWebSite', 'http://' . UserRequest::$server['HTTP_HOST'] . '/.../');
//-- MAIL PARAMETERS
//Default Email Account
define('kDefaultEmail', 'support@alenet.com');
//Default SMTP Server. Default outgoing mail server
define('kDefaultSmtp', 'localhost');
//Default SMTP Server port. Default outgoing mail server port
define('kDefaultSmtpPort', '25');
//Default mailer. Options (mail, pear). If smtp requires authentication user pear
define('kDefaultMailer', 'mail');
//Default SMTP Requires autentication. Set true if requires autentication.
//Default Mailer must be pear
define('kDefaultSmtpReqAuth', false);
//Default SMTP username. If authentication required, set username for smtp
define('kDefaultSmtpUsername', '');
//Defautl SMTP password.  If authentication required, set username for smtp
define('kDefaultSmtpPassword', '');
//-- OTHER PARAMETERS
//Math Functions Precision (Number of decimal Places)
define('kDefaultPrecision', CLX_NUM_23);
// Name of the default skin
define('kDefaultSkin', 'default');
// Set true to Remove Back Button From Browser
define('kDefaultFrameLess', false);
// Name of the company
define('kDefaultCompany', 'Alenet, Inc.');
// Cookie name to store the last menu opened by the user.
// (Usualy 'Clientix_MenuBar_option')
define('kSideBarCookieName', 'clientix_MenuBar_option');
//Session Timeout in minutes, set to 0 for no end.
define('kSessionTimeout', '30');
//Script execution time limit in seconds, set to 0 for no end. Default = 90
define('kTimeLimit', '90');
//Multi Session, set to true to allow same user to open more than
//one session at the Same time or falsto restrict only one session per user
define('kSessionMultiple', true);
//Defines how many logins are allowed to user before locking it.
//Set to 0 to disable user login attemps locking
define('kSessionLoginAttempts', CLX_NUM_ZERO);
// Logs onto e-IBS from CLX interface: 0=no, 1=yes
define('kSessionIbsLogin', CLX_NUM_ZERO);
//Defines a date for system to expire locking the application
//Set to -1 to override or expiration date yyyy-mm-dd format
define('kSystemExpireDate', '-1');
//This sets the maximum amount of memory in bytes that a script is allowed to allocate.
//This helps prevent scripts for eating up all available memory on a server. Sample: 8M or -1 to no limit
define('kAppMemoryLimit', '20M');
//This defines the maximum file size for uploads. Sample: 8M
define('kAppMaxUploadSize', '4M');
//This defines the maximum post method size allowed for the application. Sample: 8M
define('kAppMaxPostSize', '20M');
//Define Application TypeZone see http://us3.php.net/manual/en/timezones.php
define('kDefaultTimeZone', 'America/New_York');
//PHP Error parameters
define('kPhpDisplayErrors', false);
define('kPhpLogErrors', false);
define('kPhpErrorLog', 'error_log.txt');
// PHP Command Line Interpreter
define('kPhpCLI', '/usr/bin/php');
//Develoment Platform
define('kAppDev', false);
//Ibs demostration site, user and password sent by url on login
//Should be 0 always on production enviroments
define('kDemoIbs', CLX_NUM_ZERO);
