<?php
/**
 * RM_utilities
 * For more information contact  support@alenet.com
 *
 * @author       $Author: mchirino $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2020-08-20 17:46:00 -0500 (Thu, 20 Oct 2020) $
 * @version    	$Rev: 00001 $
 */
 
class RM_utilities {
    
	function verificacion_factores($comp_code,$risk_model,$pre) {
		$debug=0;$limitdebug='';
		IF ($debug) {
			$SI1=$SI2=$SI3=$SI4=$SI5=$SI7=$si14=$si15=$si16=$si20=$si21=$si22=$si23=1;
			$si41=$si20=$si23=$si24=$si13=$si11=$si8=$si19=$si9=$si10=$si26=$si27=1;
			$limitdebug=' LIMIT 120 ';
		}
		$s_idcode_list = toString(getIdlist());

		$modelo= $risk_model;
		$FECHA = date('Y-m-d');
		$DEL ='';
		
		//////PARAMETROS/////
		$sq1="SELECT PARAMETER_VALUE FROM `CLX_PR_SCHED_PRMTS` WHERE SCHEDULECODE = 'CLRM01' AND FIELDNAME = 'SDATE'";
		$FECHA_INI = ClxCommon::$db->getOne($sq1);
		$sq2="SELECT PARAMETER_VALUE FROM `CLX_PR_SCHED_PRMTS` WHERE SCHEDULECODE = 'CLRM01' AND FIELDNAME = 'EDATE'";
		$FECHA_FIN = ClxCommon::$db->getOne($sq2);
		$sq3="SELECT PARAMETER_VALUE FROM `CLX_PR_SCHED_PRMTS` WHERE SCHEDULECODE = 'CLRM01' AND FIELDNAME = 'COMP_CODE'";
		$COMP_CODE = ClxCommon::$db->getOne($sq3);
		$sq4="SELECT PVALUE FROM `BASE_PARAMETERS` WHERE IDNAME = 'SB1_FI_QTY_FIPA2'";
		$BEF1 = ClxCommon::$db->getOne($sq4);
		$sq5="SELECT PVALUE FROM `BASE_PARAMETERS` WHERE IDNAME = 'SB1_FI_QTY_FIPA3'";
		$BEF2 = ClxCommon::$db->getOne($sq5);
		$sq13="SELECT PVALUE FROM `BASE_PARAMETERS` WHERE IDNAME = 'SB1_REP_LEG_TYPES_1'";
		$ASO1 = ClxCommon::$db->getOne($sq13);
		$sq14="SELECT PVALUE FROM `BASE_PARAMETERS` WHERE IDNAME = 'SB1_REP_LEG_TYPES_2'";
		$ASO2 = ClxCommon::$db->getOne($sq14);
		$ASOC = $ASO1.','.$ASO2;
		$sq12 ="SELECT SCOREGT_HIGH FROM CLRM_SCORING_CFG RMSC WHERE RISK_MODEL = '".$modelo."'";
		$ALTO = ClxCommon::$db->getOne($sq12);
		$MEDIO = $ALTO - '0.10';
		$USER = $_SESSION['user_record']['username'];		

		if ($pre === 'FICO'){
	//CONTRATO
			$sqlc = 'SELECT DISTINCT FICO.IDCODE FICO_IDCODE 
					FROM FIDU_CONTRACTS FICO 
					WHERE FICO.ID = '.singleQuote($s_idcode_list).$limitdebug;
			$r = ClxCommon::$db->getOneRecord($sqlc);
																			if ($debug==1){echo ("LINE:". __LINE__ ." select sqlc CONTRATO");PRE(beautiful_sql($sqlc,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
	//BORRO RESULTADO DE FACTOR POR PERSONA O CLIENTE  DEL CONTRATO PARA LA FECHA Y EL MODELO
			$sql0 ='DELETE FROM CLRM_ACCOCRIT_VAL WHERE CLX_EFFTDATE= '.singleQuote($FECHA).'  AND RISK_MODEL ='.singleQuote($modelo).' AND CONTRACT_CODE = '.singleQuote($r['FICO_IDCODE']);
			$rs0 = ClxCommon::$db->executeQuery($sql0);
																			if ($debug==1){echo ("LINE:". __LINE__ ." select sql0 BORRO RESULTADO DE FACTOR POR PERSONA O CLIENTE  DEL CONTRATO PARA LA FECHA Y EL MODELO");PRE(beautiful_sql($sql0,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
	//BORRO EL RIESGO POR PRODUCTO DEL CONTRATO PARA LA FECHA Y EL MODELOO
			$sql6 ='DELETE FROM CLRM_ACCOPROD_RISKEVAL WHERE CLX_EFFTDATE= '.singleQuote($FECHA).'  AND RISK_MODEL ='.singleQuote($modelo).' AND CONTRACT_CODE = '.singleQuote($r['FICO_IDCODE']);
			$rs6 = ClxCommon::$db->executeQuery($sql6);
			$DEL = ' AND CONTRACT_CODE = '.singleQuote($r['FICO_IDCODE']);
																			if ($debug==1){	echo ("LINE:". __LINE__ ." select sql6 BORRO EL RIESGO POR PRODUCTO DEL CONTRATO PARA LA FECHA Y EL MODELO");PRE(beautiful_sql($sql6,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
	//CONTRATO CON SUS PARTICIPANTES;
			$sql = 'SELECT DISTINCT FIPA.ACCOUNTCODE ACCO_IDCODE, FIPA.CONTRACT_CODE FICO_IDCODE, ACCO.ISINDIVIDUAL, ACCO.PEP_CLASS, GROUP_CONCAT(CLX_DBLI_ITEM_LABEL("KYVC",KYVC.CRITICAL_VAR,'.singlequote($_SESSION ["prefs"] ["LANGUAGE"]).')SEPARATOR "|")  AS VAR_CRITICA
					FROM FIDU_PARTICIPANTS FIPA , FIDU_CONTRACTS FICO, CRM_ACCOUNTS ACCO
					LEFT JOIN KYC_CRITICAL_RISK_VAR KYVC ON ACCO.IDCODE = KYVC.ACCOUNTCODE	AND STATUS = "A"
					WHERE FIPA.ACCOUNTCODE = ACCO.IDCODE
						AND FIPA.CONTRACT_CODE = FICO.IDCODE
						AND FIPA.PARTICIPANT_TYPE IN ('.$BEF1.')
						AND FICO.ID = '.$s_idcode_list.'
						GROUP BY FIPA.ACCOUNTCODE'.$limitdebug;
			$rS1 = ClxCommon::$db->executeQuery($sql);
																			if ($debug==1){echo ("LINE:". __LINE__ ." select sql CONTRATO");PRE(beautiful_sql($sql,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
			
			$rs36 = 0;
			$FIPA_PEP ='0';
			$FIPA_PEP_ASOC ='0';
			$FIPA_PEP_OTR ='0';
			$FIPA_VAR_CRIT ='0';
			$FIPA_VAR_CRIT_ASOC ='0';
			$pde = '';
			$VC = $VC2 = '';
			while (($r = ClxCommon::$db->getNextRecord($rS1, ASSOCIATIVE))) {
				//echo $r['ACCO_IDCODE'];
			
	// BORRO EL RIESGO POR CLIENTE DEL CONTRATO PARA LA FECHA Y EL MODELO
				$sql4 ='DELETE FROM CLRM_ACCO_RISKEVAL WHERE CLX_EFFTDATE= '.singleQuote($FECHA).'  AND RISK_MODEL ='.singleQuote($modelo).' AND ACCOUNTCODE ='.singleQuote($r['ACCO_IDCODE']);
				$rs4 = ClxCommon::$db->executeQuery($sql4);
																			if ($debug==1 &&$SI1==1){echo ("LINE:". __LINE__ ." select sql4 BORRO EL RIESGO POR CLIENTE DEL CONTRATO PARA LA FECHA Y EL MODELO");PRE(beautiful_sql($sql4,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$SI1=0;}
				//VERIFICO SI EL PARTICIPANTE ES PEP o TIENE VARIABLES CRITICAS
				if ($r['PEP_CLASS'] <> 0 ){ 
					$FIPA_PEP ='1';
				}
				if ($r['VAR_CRITICA'] <> '' ){ 
					$FIPA_VAR_CRIT ='1';
					if(strlen($r['VAR_CRITICA']) > strlen($VC)){
						$VC = $r['VAR_CRITICA'];
					}
					
				}
				//VERIFICO SI ALGUNO DE LOS RELACIONADOS DEL PARTICIPANTE ES PEP
				$sql35='SELECT DISTINCT
							PARENT_IDCODE,
							ACCO.PEP_CLASS,
							GROUP_CONCAT(CLX_DBLI_ITEM_LABEL("KYVC",KYVC.CRITICAL_VAR,'.singlequote($_SESSION ["prefs"] ["LANGUAGE"]).')SEPARATOR "|")  AS VAR_CRITICA
						FROM
							CRM_ACCOUNTS ACCO,
							CRM_REL_ACCOUNTS DYAC
							LEFT JOIN KYC_CRITICAL_RISK_VAR KYVC
							ON DYAC.CHILD_IDCODE = KYVC.ACCOUNTCODE
							AND STATUS = "A"
						WHERE ACCO.IDCODE = DYAC.CHILD_IDCODE
							AND DYAC.RELATIONSHIP IN('.$ASOC.')
							AND  PARENT_IDCODE = '.singleQuote($r['ACCO_IDCODE']).'
						GROUP BY PARENT_IDCODE'.$limitdebug;
						//echo $sql35;
				$rS35 = ClxCommon::$db->executeQuery($sql35);
				while (($r35 = ClxCommon::$db->getNextRecord($rS35, ASSOCIATIVE))) {
					if ($r35['PEP_CLASS'] == '1' or  $r35['PEP_CLASS'] == '2' or  $r35['PEP_CLASS'] == '3'){
						$FIPA_PEP_ASOC ='1';
					}
					if ($r35['VAR_CRITICA'] <> '' ){
						$FIPA_VAR_CRIT_ASOC ='1';
					if(strlen($r35['VAR_CRITICA']) > strlen($VC2)){
						$VC2 = $r35['VAR_CRITICA'];
					}
					}
				}
																			if ($debug==1 &&$SI2==1){echo ("LINE:". __LINE__ ." SELECT sql35 IN CICLO WHILE SIN NOMBRE");PRE(beautiful_sql($sql35,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$SI2=0;}
			}
			//VERIFICO SI OTRO PARTICIPANTE DEL CONTRATO ES PEP 
			$sql36="SELECT DISTINCT FICO.IDCODE
					FROM FIDU_CONTRACTS FICO, CRM_ACCOUNTS ACCO, FIDU_PARTICIPANTS FIPA 
					WHERE FICO.IDCODE = FIPA.CONTRACT_CODE
						AND FIPA.ACCOUNTCODE = ACCO.IDCODE
						AND FICO.ID = ".$s_idcode_list."
						AND ACCO.PEP_CLASS IN ('1','2','3')
						AND FIPA.PARTICIPANT_TYPE IN (".$BEF2.")".$limitdebug;
			$rs36 = ClxCommon::$db->getOneRecord($sql36);
																			if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sql36");PRE(beautiful_sql($sql36,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
	
			if ($rs36){
				$FIPA_PEP_OTR ='1';
			}
			
			if($FIPA_PEP == '1' or $FIPA_PEP_ASOC == '1' or $FIPA_PEP_OTR == '1' or $FIPA_VAR_CRIT == '1' or $FIPA_VAR_CRIT_ASOC == '1'){
				$pde = $pde2 = '';
				$rs12 = ClxCommon::$db->executeQuery($sql);
			if($FIPA_PEP == '1' or $FIPA_PEP_ASOC == '1' or $FIPA_PEP_OTR == '1'){
				$pde = 'PEP|';
			}
			if($FIPA_VAR_CRIT == '1' or $FIPA_VAR_CRIT_ASOC == '1'){
				if(strlen($VC) > strlen($VC2)){
					$pde2 = $VC;	
				}else{
					$pde2 = $VC2;
				}				
			}				
																			if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sql EN FIPA");PRE(beautiful_sql($sql,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
				while (($r12 = ClxCommon::$db->getNextRecord($rs12, ASSOCIATIVE))) {				
					$sql23="INSERT INTO CLRM_ACCO_RISKEVAL (ACCOUNTCODE, RISK_MODEL, EVAL_METHOD, MODEL_SCORE, CLX_EFFTDATE, RISK_LEVEL, PDE, CDATE, CREATEDBY, MDATE, MODIFIEDBY)
							VALUES('".$r12['ACCO_IDCODE']."','".$modelo."', '01', ".$ALTO.", '".$FECHA."','A', '".$pde.$pde2."','".$FECHA."','".$USER."','".$FECHA."','".$USER."')";
					ClxCommon::$db->executeQuery($sql23);
																			if ($debug==1 && $SI3==1){echo ("LINE:". __LINE__ ." SELECT sql23 IN WHILE ");PRE(beautiful_sql($sql23,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$SI3=0;}		
					$sql28="INSERT INTO CLRM_ACCOPROD_RISKEVAL (ACCOUNTCODE, CONTRACT_CODE, RISK_MODEL,  MODEL_SCORE, CLX_EFFTDATE, RISK_LEVEL, PDE, CDATE, CREATEDBY, MDATE, MODIFIEDBY)
							VALUES('".$r12['ACCO_IDCODE']."', ".singleQuote($r12['FICO_IDCODE']).",'".$modelo."', ".$ALTO.", '".$FECHA."','A', '".$pde.$pde2."','".$FECHA."','".$USER."','".$FECHA."','".$USER."')";
					ClxCommon::$db->executeQuery($sql28);
																			if ($debug==1 && $SI4==1){echo ("LINE:". __LINE__ ." SELECT sql28 IN WHILE");PRE(beautiful_sql($sql28,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$SI4=0;}
					$sql24="UPDATE CRM_ACCOUNTS ACCO SET ACCO.RISK_LEVEL = 'A', ACCO.MDATE = '".$FECHA."' WHERE IDCODE = '".$r12['ACCO_IDCODE']."'";
					ClxCommon::$db->executeQuery($sql24);
																			if ($debug==1 && $SI5==1){echo ("LINE:". __LINE__ ." SELECT sql24 IN WHILE ");PRE(beautiful_sql($sql24,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$SI5=0;}					
				}
				$sql16="UPDATE FIDU_CONTRACTS SET RISK_LEVEL = 'A', MDATE = '".$FECHA."' WHERE ID = ".$s_idcode_list;
				ClxCommon::$db->executeQuery($sql16);
																			if ($debug==1 ){echo ("LINE:". __LINE__ ." SELECT sql16");PRE(beautiful_sql($sql16,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$SI6=0;}	
				addMessage("Proceso Completado. </br>   "); 
				return;
			}
			$rs = ClxCommon::$db->executeQuery($sql);
																			if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sql  EXECUTE SIN REINSCRITURA SQL ");PRE(beautiful_sql($sql,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
		}else if($pre === 'FIPA'){
			$FIPA_PEP ='0';
			$FIPA_PEP_ASOC ='0';
			$FIPA_PEP_OTR ='0';
			$FIPA_VAR_CRIT ='0';
			$FIPA_VAR_CRIT_ASOC ='0';
			$pde = '';
			$VC = $VC2 = '';
	//PARTICIPANTE
			$sql = 'SELECT DISTINCT FIPA.ACCOUNTCODE ACCO_IDCODE, FIPA.CONTRACT_CODE FICO_IDCODE, ACCO.ISINDIVIDUAL, ACCO.PEP_CLASS, GROUP_CONCAT(CLX_DBLI_ITEM_LABEL("KYVC",KYVC.CRITICAL_VAR,'.singlequote($_SESSION ["prefs"] ["LANGUAGE"]).')SEPARATOR "|")  AS VAR_CRITICA
				FROM FIDU_PARTICIPANTS FIPA , CRM_ACCOUNTS ACCO
				LEFT JOIN KYC_CRITICAL_RISK_VAR KYVC ON ACCO.IDCODE = KYVC.ACCOUNTCODE	AND STATUS = "A" 
					WHERE FIPA.ACCOUNTCODE = ACCO.IDCODE
						AND FIPA.ID = '.singleQuote($s_idcode_list).$limitdebug;
			$r = ClxCommon::$db->getOneRecord($sql);
	//VERIFICO SI EL PARTICIPANTE ES PEP o TIENE VARIABLES CRITICAS
			if ($r['PEP_CLASS'] <> 0 ){ 
				$FIPA_PEP ='1';
			}
			if ($r['VAR_CRITICA'] <> '' ){ 
				$FIPA_VAR_CRIT ='1';
				$VC = $r['VAR_CRITICA'];
			}
																			if ($debug==1){echo ("LINE:". __LINE__ ." select sql PARTINCIPANTE SELECT  ");	PRE(beautiful_sql($sql,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
	//BORRO RESULTADO DE FACTOR POR PERSONA O CLIENTE DEL PARTICIPANTE
			$sql0 ='DELETE FROM CLRM_ACCOCRIT_VAL WHERE CLX_EFFTDATE= '.singleQuote($FECHA).'  AND RISK_MODEL ='.singleQuote($modelo).' AND ACCOUNTCODE ='.singleQuote($r['ACCO_IDCODE']).' AND CONTRACT_CODE = '.singleQuote($r['FICO_IDCODE']);
			//echo $sql0; die;
			$rs0 = ClxCommon::$db->executeQuery($sql0);
																			if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sql0 BORRO RESULTADO DE FACTOR POR PERSONA O CLIENTE DEL PARTICIPANTE");PRE(beautiful_sql($sql0,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
	
	// BORRO EL RIESGO POR CLIENTE DEL PARTICIPANTE
			$sql4 ='DELETE FROM CLRM_ACCO_RISKEVAL WHERE CLX_EFFTDATE= '.singleQuote($FECHA).'  AND RISK_MODEL ='.singleQuote($modelo).' AND ACCOUNTCODE ='.singleQuote($r['ACCO_IDCODE']);
			$rs4 = ClxCommon::$db->executeQuery($sql4);
																			if ($debug==1){	echo ("LINE:". __LINE__ ." SELECT sql4 BORRO EL RIESGO POR CLIENTE DEL PARTICIPANTE");PRE(beautiful_sql($sql4,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
		
	//BORRO EL RIESGO POR PRODUCTO DEL PARTICIPANTE
			$sql6 ='DELETE FROM CLRM_ACCOPROD_RISKEVAL WHERE CLX_EFFTDATE= '.singleQuote($FECHA).'  AND RISK_MODEL ='.singleQuote($modelo).' AND ACCOUNTCODE ='.singleQuote($r['ACCO_IDCODE']).' AND CONTRACT_CODE = '.singleQuote($r['FICO_IDCODE']);
			$rs6 = ClxCommon::$db->executeQuery($sql6);
			$DEL = ' AND ACCOUNTCODE ='.singleQuote($r['ACCO_IDCODE']);
																			if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sql6 BORRO EL RIESGO POR PRODUCTO DEL PARTICIPANTE");PRE(beautiful_sql($sql6,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}				
				
	//VERIFICO SI ALGUN RELACIONADO EL PEP
			$sql35='SELECT DISTINCT
						PARENT_IDCODE,
						ACCO.PEP_CLASS,
						GROUP_CONCAT(CLX_DBLI_ITEM_LABEL("KYVC",KYVC.CRITICAL_VAR,'.singlequote($_SESSION ["prefs"] ["LANGUAGE"]).')SEPARATOR "|")  AS VAR_CRITICA
					FROM
						CRM_ACCOUNTS ACCO,
						CRM_REL_ACCOUNTS DYAC
						LEFT JOIN KYC_CRITICAL_RISK_VAR KYVC
						ON DYAC.CHILD_IDCODE = KYVC.ACCOUNTCODE
						AND STATUS = "A"
					WHERE ACCO.IDCODE = DYAC.CHILD_IDCODE
						AND DYAC.RELATIONSHIP IN('.$ASOC.')
						AND  PARENT_IDCODE = '.singleQuote($r['ACCO_IDCODE']).'
					GROUP BY PARENT_IDCODE'.$limitdebug;
			$rs35 = ClxCommon::$db->executeQuery($sql35);
			while (($r35 = ClxCommon::$db->getNextRecord($rs35, ASSOCIATIVE))) {
				if ($r35['PEP_CLASS'] == '1' or  $r35['PEP_CLASS'] == '2' or  $r35['PEP_CLASS'] == '3'){
					$FIPA_PEP_ASOC ='1';
				}
				if ($r35['VAR_CRITICA'] <> '' ){
					$FIPA_VAR_CRIT_ASOC ='1';
				if(strlen($r35['VAR_CRITICA']) > strlen($VC2)){
					$VC2 = $r35['VAR_CRITICA'];
				}
				}
			}

																			if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sql35 VERIFICO SI ALGUN RELACIONADO EL PEP");PRE(beautiful_sql($sql35,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}				

	//verifico si es PEPS o si tienes variables criticas
			if ($FIPA_PEP == '1' || $FIPA_PEP_ASOC == '1' || $FIPA_VAR_CRIT =='1' || $FIPA_VAR_CRIT_ASOC ='1' ){
				$pde = $pde2 = '';
				if($FIPA_PEP == '1' or $FIPA_PEP_ASOC == '1'){$pde = 'PEP|';} 
				if($FIPA_VAR_CRIT == '1' or $FIPA_VAR_CRIT_ASOC == '1'){
					if(strlen($VC) > strlen($VC2)){
						$pde2 = $VC;	
					}else{
						$pde2 = $VC2;
					}				
				}			 
				$sql23="INSERT INTO CLRM_ACCO_RISKEVAL (ACCOUNTCODE, RISK_MODEL, EVAL_METHOD, MODEL_SCORE, CLX_EFFTDATE, RISK_LEVEL, PDE, CDATE, CREATEDBY, MDATE, MODIFIEDBY)
					VALUES('".$r['ACCO_IDCODE']."','".$modelo."', '01', ".$ALTO.", '".$FECHA."','A', '".$pde.$pde2."','".$FECHA."','".$USER."','".$FECHA."','".$USER."')";
				ClxCommon::$db->executeQuery($sql23);
																			if ($debug==1){echo  ("LINE:". __LINE__ ."  SELECT sql23 verifico si es PEPS");PRE(beautiful_sql($sql23,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
				$sql28="INSERT INTO CLRM_ACCOPROD_RISKEVAL (ACCOUNTCODE, CONTRACT_CODE, RISK_MODEL,  MODEL_SCORE, CLX_EFFTDATE, RISK_LEVEL, PDE, CDATE, CREATEDBY, MDATE, MODIFIEDBY)
					VALUES('".$r['ACCO_IDCODE']."', ".singleQuote($r['FICO_IDCODE']).",'".$modelo."', ".$ALTO.", '".$FECHA."','A', '".$pde.$pde2."','".$FECHA."','".$USER."','".$FECHA."','".$USER."')";
				ClxCommon::$db->executeQuery($sql28);
																			if ($debug==1){echo  ("LINE:". __LINE__ ."  SELECT sql28 verifico si es PEPS");PRE(beautiful_sql($sql28,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
				$sql24="UPDATE CRM_ACCOUNTS ACCO SET ACCO.RISK_LEVEL = 'A', ACCO.MDATE = '".$FECHA."' WHERE IDCODE = '".$r['ACCO_IDCODE']."'";
				ClxCommon::$db->executeQuery($sql24);
				addMessage("Proceso Completado. </br>   ");
																			if ($debug==1){echo  ("LINE:". __LINE__ ."  SELECT sql24 verifico si es PEPS");PRE(beautiful_sql($sql24,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}				
				return;
			}//else {

			$rs = ClxCommon::$db->executeQuery($sql);
			//}
		}
		else{

	/////LIMPIO LA TABLA TEMPORAL//////
			$sq6 = "DROP TABLE IF EXISTS CLRM_MATRIZ_RIESGO_CLIENTE_TMP";
			ClxCommon::$db->executeQuery ($sq6);
																			if ($debug==1){echo  ("LINE:". __LINE__ ."  SELECT sq6 LIMPIO LA TABLA TEMPORAL");PRE(beautiful_sql($sq6,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
	//////SE CREA TABLA TEMPORAL CON TODOS LOS CONTRATOS Y CLIENTES ACTIVOS A LA FECHA//////////
			$sq7 = "CREATE TEMPORARY TABLE CLRM_MATRIZ_RIESGO_CLIENTE_TMP	
						SELECT 
							DISTINCT ACCO.IDCODE ACCO_IDCODE, ACCO.IDNAME ACCO_IDNAME, ACCO.ID_TYPE ACCO_ID_TYPE, ACCO.IDENTIFICATION ACCO_IDENTIFICATION, ACCO.RISK_LEVEL ACCO_RISK_LEVEL, 
							ACCO.PEP_CLASS ACCO_PEP_CLASS, ACCO.ISINDIVIDUAL, ACCO.BIRTH_COUNTRY ACCO_BIRTH_COUNTRY,ACCO.PROFESSION_CODE ACCO_PROFESSION_CODE,
							ACCO.COUNTRY PAIS_DOMICILIO, ACCO.CITIZENSHIP NACIONALIDAD, ACCO.INDUSTRYCLASS ACCO_INDUSTRYCLASS, ACCO.INCORPORATION_COUNTRY ACCO_INCORPORATION_COUNTRY, FICO.IDCODE FICO_IDCODE, FICO.CONTRACT_NUMBER FICO_CONTRACT_NUMBER, FICO.IDNAME FICO_IDNAME, FICO.EFFTDATE FICO_EFFTDATE, FICO.FI_TYPE FICO_FI_TYPE, 
							ACCO.COTYPE ACCO_COTYPE, '0000-00-00' FECHA,'NULL' RIESGO_CALCULADO, GROUP_CONCAT(CLX_DBLI_ITEM_LABEL('KYVC',KYVC.CRITICAL_VAR,".singlequote($_SESSION ['prefs'] ['LANGUAGE']).")SEPARATOR '|')  AS VAR_CRITICA
						FROM FIDU_CONTRACTS FICO, FIDU_PARTICIPANTS FIPA, CRM_ACCOUNTS ACCO
						LEFT JOIN KYC_CRITICAL_RISK_VAR KYVC ON ACCO.IDCODE = KYVC.ACCOUNTCODE AND STATUS = 'A'  
						WHERE FICO.IDCODE = FIPA.CONTRACT_CODE
							AND FIPA.ACCOUNTCODE = ACCO.IDCODE
							AND FICO.CONTRACT_STATUS = 'ACTI'
							AND FIPA.STATUS = 'A'
							AND FICO.COMP_CODE = '".$COMP_CODE."'
							AND FIPA.PARTICIPANT_TYPE IN (".$BEF1.") GROUP BY FIPA.ACCOUNTCODE, FIPA.CONTRACT_CODE".$limitdebug;
					//echo 'UNO '.$sq7;
			ClxCommon::$db->executeQuery ($sq7);
																					if ($debug==1){echo  ("LINE:". __LINE__ ."  SELECT sq7 SE CREA TABLA TEMPORAL CON TODOS LOS CONTRATOS Y CLIENTES");PRE(beautiful_sql($sq7,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
	//ACTUALIZO A RIESGO ALTO TODOS LOS PEP PARA NO EVALUARLOS EN EL PROCESO GENERAL
			/*$sq8 = "UPDATE CLRM_MATRIZ_RIESGO_CLIENTE_TMP CMRCT1
					SET CMRCT1.RIESGO_CALCULADO = 'A', CMRCT1.FECHA ='".$FECHA."', CMRCT1.VAR_CRITICA = CONCAT('PEP|',IFNULL(CMRCT1.VAR_CRITICA,''))
					WHERE EXISTS  
						 (SELECT 1  FROM CRM_ACCOUNTS ACCO WHERE CMRCT1.ACCO_IDCODE=ACCO.IDCODE AND ACCO.PEP_CLASS in ('1','2','3'))";*/

			$sq8 = "UPDATE CLRM_MATRIZ_RIESGO_CLIENTE_TMP CMRCT1
						 SET CMRCT1.RIESGO_CALCULADO = 'A', CMRCT1.FECHA ='".$FECHA."', CMRCT1.VAR_CRITICA = CONCAT('PEP|',IFNULL(CMRCT1.VAR_CRITICA,''))
						 WHERE CMRCT1.ACCO_PEP_CLASS IN ('1', '2', '3')";
						 //echo 'DOS '.$sq8;
			ClxCommon::$db->executeQuery ($sq8);
	//ACTUALIZO A RIESGO ALTO TODOS LOS QUE TENGAN VARIABLES CRITICAS PARA NO EVALUARLOS EN EL PROCESO GENERAL
			$sq81 = "UPDATE CLRM_MATRIZ_RIESGO_CLIENTE_TMP 
					SET RIESGO_CALCULADO = 'A', FECHA ='".$FECHA."' WHERE VAR_CRITICA IS NOT NULL";
					//echo 'TRES '.$sq81;
				ClxCommon::$db->executeQuery ($sq81);
																if ($debug==1){	echo  ("LINE:". __LINE__ ."  SELECT sq8 ACTUALIZO A RIESGO ALTO TODOS LOS PEP PARA NO EVALUARLOS");PRE(beautiful_sql($sq8,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
	//ACTUALIZO A LOS RELACIONADOS CON ALGUN PEP
			$sq11 = "UPDATE CLRM_MATRIZ_RIESGO_CLIENTE_TMP CMRCT1
					SET CMRCT1.RIESGO_CALCULADO = 'A', CMRCT1.FECHA = '".$FECHA."' , CMRCT1.VAR_CRITICA = CONCAT('PEP|',IFNULL(CMRCT1.VAR_CRITICA,''))
					WHERE EXISTS   
						(SELECT 1 FROM	CRM_REL_ACCOUNTS DYAC, CRM_ACCOUNTS ACCO
						WHERE CMRCT1.ACCO_IDCODE=DYAC.PARENT_IDCODE AND ACCO.IDCODE = DYAC.CHILD_IDCODE
								AND DYAC.RELATIONSHIP IN (".$ASOC.")
								AND ACCO.PEP_CLASS in ('1','2','3')
						GROUP BY PARENT_IDCODE)";
						//echo 'CUATRO '.$sq11;		
			ClxCommon::$db->executeQuery ($sq11);
		
	//ACTUALIZO A LOS RELACIONADOS CON VARIABLES CRITICAS
			/*$sq112 = "UPDATE CLRM_MATRIZ_RIESGO_CLIENTE_TMP CMRCT1
			SET CMRCT1.RIESGO_CALCULADO = 'A', CMRCT1.FECHA = '".$FECHA."'
			WHERE EXISTS   
				(SELECT 1 FROM	CRM_REL_ACCOUNTS DYAC, KYC_CRITICAL_RISK_VAR KYVC
				WHERE CMRCT1.ACCO_IDCODE=DYAC.PARENT_IDCODE 
						AND KYVC.ACCOUNTCODE = DYAC.CHILD_IDCODE
						AND KYVC.STATUS = 'A'
						AND DYAC.RELATIONSHIP IN (".$ASOC.")
				GROUP BY PARENT_IDCODE)";*/
			
			$sq112 = "SELECT 
						CMRCT1.ACCO_IDCODE,
						CMRCT1.FICO_IDCODE,
						GROUP_CONCAT(CLX_DBLI_ITEM_LABEL('KYVC',KYVC.CRITICAL_VAR,".singlequote($_SESSION ['prefs'] ['LANGUAGE']).")SEPARATOR '|') AS VAR_CRITICA
					FROM	CRM_REL_ACCOUNTS DYAC, KYC_CRITICAL_RISK_VAR KYVC,CLRM_MATRIZ_RIESGO_CLIENTE_TMP CMRCT1
					WHERE CMRCT1.ACCO_IDCODE=DYAC.PARENT_IDCODE 
					AND KYVC.ACCOUNTCODE = DYAC.CHILD_IDCODE
					AND KYVC.STATUS = 'A'
					AND DYAC.RELATIONSHIP IN (".$ASOC.")
			GROUP BY PARENT_IDCODE";
			//echo 'SEIS '.$sq112;
				$r9M1 = ClxCommon::$db->executeQuery ($sq112);
					while (($rc9M1 = ClxCommon::$db->getNextRecord($r9M1, ASSOCIATIVE))) {
						$variable = $rc9M1['VAR_CRITICA'];
						$array = explode("|",$variable);
						$array=array_unique($array);
						$variable=implode($array,"|");
						$sq1011="UPDATE CLRM_MATRIZ_RIESGO_CLIENTE_TMP SET RIESGO_CALCULADO = 'A', VAR_CRITICA = CONCAT('".$variable."|',IFNULL(VAR_CRITICA,'')), FECHA = '".$FECHA."' WHERE  ACCO_IDCODE = '".$rc9M1['ACCO_IDCODE']."'";
						//echo 'SEISHIJOS '.$sq1011;
						ClxCommon::$db->executeQuery($sq1011);
					}		
																				if ($debug==1){echo  ("LINE:". __LINE__ ."  SELECT sq11 ACTUALIZO A LOS RELACIONADOS CON ALGUN PEP");PRE(beautiful_sql($sq11,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}

	//ACTUALIZO EN LA TEMPORAL CON RIESGO ALTO A TODOS LOS ASOCIADOS AL MISMO CONTRATO Y A LOS QUE TENGAN OTROS PARTICIPANTES VARIABLES CRITICAS
			$sq9M = "SELECT DISTINCT(FICO_IDCODE), VAR_CRITICA 
					FROM CLRM_MATRIZ_RIESGO_CLIENTE_TMP 
					WHERE VAR_CRITICA IS NOT NULL 
					GROUP BY FICO_IDCODE";
			//echo 'SIETE '.$sq9M;		
			$r9M= ClxCommon::$db->executeQuery($sq9M);
																				if ($debug==1){echo  ("LINE:". __LINE__ ."  SELECT sq9 ACTUALIZO EN LA TEMPORAL CON RIESGO ALTO A TODOS LOS ASOCIADOS AL MISMO CONTRATO");PRE(beautiful_sql($sq9,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
			
			while (($rc9M = ClxCommon::$db->getNextRecord($r9M, ASSOCIATIVE))) {
				$sq10="UPDATE CLRM_MATRIZ_RIESGO_CLIENTE_TMP SET RIESGO_CALCULADO = 'A', VAR_CRITICA = CONCAT('".$rc9M['VAR_CRITICA']."|',IFNULL(VAR_CRITICA,'')), FECHA = '".$FECHA."' WHERE FICO_IDCODE = '".$rc9M['FICO_IDCODE']."'";
				//echo 'SIETEHIJOS '.$sq10;
				ClxCommon::$db->executeQuery($sq10);
																				if ($debug==1&& $SI7==1){echo  ("LINE:". __LINE__ ."  SELECT sq10 TERCER WHILE");PRE(beautiful_sql($sq10,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$SI7=0;}
			}
		//ACTUALIZO EN LA TEMPORAL CON RIESGO ALTO A TODOS LOS ASOCIADOS AL MISMO CONTRATO Y A LOS QUE TENGAN OTROS PARTICIPANTES PEP
		$sq9 = "SELECT FICO_IDCODE 
		FROM CLRM_MATRIZ_RIESGO_CLIENTE_TMP 
		WHERE ACCO_PEP_CLASS IN ('1', '2', '3') GROUP BY FICO_IDCODE
		UNION
		SELECT 	DISTINCT(FICO.IDCODE)
		FROM FIDU_CONTRACTS FICO, CRM_ACCOUNTS ACCO, FIDU_PARTICIPANTS FIPA 
		WHERE FICO.IDCODE = FIPA.CONTRACT_CODE
			AND FIPA.ACCOUNTCODE = ACCO.IDCODE
			AND FICO.CONTRACT_STATUS = 'ACTI'
			AND FIPA.STATUS = 'A'
			AND FICO.COMP_CODE = '".$COMP_CODE."'
			AND ACCO.PEP_CLASS IN ('1','2','3')
			AND FIPA.PARTICIPANT_TYPE IN (".$BEF2.")".$limitdebug;
			//echo 'OCHO '.$sq9;	
$r9 = ClxCommon::$db->executeQuery($sq9);
																	if ($debug==1){echo  ("LINE:". __LINE__ ."  SELECT sq9 ACTUALIZO EN LA TEMPORAL CON RIESGO ALTO A TODOS LOS ASOCIADOS AL MISMO CONTRATO");PRE(beautiful_sql($sq9,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}

while (($rc9 = ClxCommon::$db->getNextRecord($r9, ASSOCIATIVE))) {
	$sq10="UPDATE CLRM_MATRIZ_RIESGO_CLIENTE_TMP SET RIESGO_CALCULADO = 'A', FECHA = '".$FECHA."',VAR_CRITICA = CONCAT('PEP|',IFNULL(VAR_CRITICA,'')) WHERE FICO_IDCODE = '".$rc9['FICO_IDCODE']."'";
	//echo 'OCHOHIJOS '.$sq10;
	
	ClxCommon::$db->executeQuery($sq10);
																	if ($debug==1&& $SI7==1){echo  ("LINE:". __LINE__ ."  SELECT sq10 TERCER WHILE");PRE(beautiful_sql($sq10,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$SI7=0;}
}
	///LIMPIO LAS VARIABLES CRITICAS REPETIDAS///
	$sq9M = "SELECT FICO_IDCODE, ACCO_IDCODE, VAR_CRITICA FROM CLRM_MATRIZ_RIESGO_CLIENTE_TMP WHERE VAR_CRITICA IS NOT NULL"; 
	//echo 'NUEVE '.$sq9M;
		
	$r9M= ClxCommon::$db->executeQuery($sq9M);
	while (($rc9M1 = ClxCommon::$db->getNextRecord($r9M, ASSOCIATIVE))) {
		$variable1 = $rc9M1['VAR_CRITICA'];
		$array = explode("|",$variable1);
		$array=array_unique($array);
		$variable=implode($array,"|");
		$sq1011="UPDATE CLRM_MATRIZ_RIESGO_CLIENTE_TMP SET VAR_CRITICA = '".$variable."' WHERE FICO_IDCODE = '".$rc9M1['FICO_IDCODE']."' AND  ACCO_IDCODE = '".$rc9M1['ACCO_IDCODE']."'";		
		//echo ';NUEVEHIJOS '.$variable1.' AJA '.$variable.' AJA '.$sq1011;
		ClxCommon::$db->executeQuery($sq1011);
		$variable = '';
		}

	//BORRO RESULTADO DE FACTOR POR PERSONA O CLIENTE PARA LA FECHA Y MODELO
			$sql0 ='DELETE FROM CLRM_ACCOCRIT_VAL WHERE CLX_EFFTDATE= '.singleQuote($FECHA).'  AND RISK_MODEL ='.singleQuote($modelo);
			$rs0 = ClxCommon::$db->executeQuery($sql0);
																				if ($debug==1){echo  ("LINE:". __LINE__ ."  SELECT sql0 BORRO RESULTADO DE FACTOR POR PERSONA O CLIENTE");PRE(beautiful_sql($sql0,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
	//BORRO EL RIESGO POR CLIENTE PARA LA FECHA Y MODELO
			$sql4 ='DELETE FROM CLRM_ACCO_RISKEVAL WHERE CLX_EFFTDATE= '.singleQuote($FECHA).'  AND RISK_MODEL ='.singleQuote($modelo);
			$rs4 = ClxCommon::$db->executeQuery($sql4);
																				if ($debug==1){echo  ("LINE:". __LINE__ ."  SELECT sql4 BORRO EL RIESGO POR CLIENTE PARA LA FECHA Y MODELO");PRE(beautiful_sql($sql4,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}		
	//BORRO EL RIESGO POR PRODUCTO PARA LA FECHA Y MODELO
			$sql6 ='DELETE FROM CLRM_ACCOPROD_RISKEVAL WHERE CLX_EFFTDATE= '.singleQuote($FECHA).'  AND RISK_MODEL ='.singleQuote($modelo);
			$rs6 = ClxCommon::$db->executeQuery($sql6);	
																				if ($debug==1){echo  ("LINE:". __LINE__ ."  SELECT sql6 BORRO EL RIESGO POR PRODUCTO PARA LA FECHA Y MODELO");PRE(beautiful_sql($sql6,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
	//CONSULTA DE LOS CLIENTE HA EVALUAR 
			$sql = 'SELECT DISTINCT ACCO_IDCODE,FICO_IDCODE,ISINDIVIDUAL FROM CLRM_MATRIZ_RIESGO_CLIENTE_TMP WHERE RIESGO_CALCULADO = "NULL" '.$limitdebug;
			$rs = ClxCommon::$db->executeQuery($sql);
																				if ($debug==1){echo  ("LINE:". __LINE__ ."  SELECT sql CONSULTA DE LOS CLIENTE HA EVALUAR");PRE(beautiful_sql($sql,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
		}
			
	//BUSCO LOS FACTORES QUE LE CORRESPONDE AL TIPO DE PERSONA

		$sql2 ='SELECT DISTINCT RMCE.FIELDNAME FIELDNAME, RMCE.SRCH_FLD SRCH_FLD, RMCE.RMLT_CODE RMLT_CODE, CDT.IDNAME IDNAME, 
					CDT.MODULECODE MODULECODE, RMCE.IDNAME IDNAMEFAC, RMCE.QUERYCODE RMCE_QUERYCODE, RMCR.MODEL_WGHT_PERS RMCR_MODEL_WGHT_PERS, 
					RMCR.MODEL_WGHT_CORP RMCR_MODEL_WGHT_CORP
				FROM CLRM_MODELS_TBL RMMO
				LEFT JOIN  CLRM_MODEL_CRITERIA RMCR ON RMCR.RISK_MODEL = RMMO.IDCODE 
				LEFT JOIN  CLRM_CRITELEM_TBL RMCE ON RMCR.RMCE_CODE = RMCE.IDCODE AND RMCE.ISINDIVIDUAL = 1
				INNER JOIN CLX_DB_TABLES CDT ON RMCE.TABLECODE = CDT.IDCODE
				WHERE
					RMMO.IDCODE ='.$modelo.$limitdebug;

		$rs2 = ClxCommon::$db->executeQuery($sql2);
																				if ($debug==1){echo  ("LINE:". __LINE__ ."  SELECT sql2 primero");PRE(beautiful_sql($sql2,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
		$arregloindividual=array();
		while (($rec2 = ClxCommon::$db->getNextRecord($rs2, ASSOCIATIVE))) {
			$arregloindividual[]=$rec2;

		}
		$sql2 ='SELECT DISTINCT RMCE.FIELDNAME FIELDNAME, RMCE.SRCH_FLD SRCH_FLD, RMCE.RMLT_CODE RMLT_CODE, CDT.IDNAME IDNAME, 
					CDT.MODULECODE MODULECODE, RMCE.IDNAME IDNAMEFAC, RMCE.QUERYCODE RMCE_QUERYCODE, RMCR.MODEL_WGHT_PERS RMCR_MODEL_WGHT_PERS, 
					RMCR.MODEL_WGHT_CORP RMCR_MODEL_WGHT_CORP
				FROM CLRM_MODELS_TBL RMMO
				LEFT JOIN  CLRM_MODEL_CRITERIA RMCR ON RMCR.RISK_MODEL = RMMO.IDCODE 
				LEFT JOIN  CLRM_CRITELEM_TBL RMCE ON RMCR.RMCE_CODE = RMCE.IDCODE AND RMCE.ISLEGALENTITY = 1
				INNER JOIN CLX_DB_TABLES CDT ON RMCE.TABLECODE = CDT.IDCODE
				WHERE
					RMMO.IDCODE ='.$modelo.$limitdebug;
		$rs2 = ClxCommon::$db->executeQuery($sql2);
																			if ($debug==1){echo  ("LINE:". __LINE__ ."  SELECT sql2 sequndo");PRE(beautiful_sql($sql2,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
		$arreglolegal=array();
		while (($rec2 = ClxCommon::$db->getNextRecord($rs2, ASSOCIATIVE))) {
			$arreglolegal[]=$rec2;
		}
	/* WHILE  PARA TENER TODOS LOS CLIENTES HA EVALUAR*/
		while (($rec = ClxCommon::$db->getNextRecord($rs, ASSOCIATIVE))) {

			$ACCO_IDCODE =  $rec['ACCO_IDCODE'];
			$FICO_IDCODE=  $rec['FICO_IDCODE'];
			$ISINDIVIDUAL =  $rec['ISINDIVIDUAL'];

			if ($ISINDIVIDUAL == '1')
				$recx = &$arregloindividual;
			else
				$recx = &$arreglolegal;
			
			foreach ($recx as $key=>$rec2) {

				if ($ISINDIVIDUAL == '1')
					$RMCR_MODEL_WGHT = $rec2['RMCR_MODEL_WGHT_PERS'];
				else
					$RMCR_MODEL_WGHT = $rec2['RMCR_MODEL_WGHT_CORP'];

				$FIELDNAME = $rec2['FIELDNAME'];
				$IDNAME = $rec2['MODULECODE'].'_'.$rec2['IDNAME'];
				$SRCH_FLD = $rec2['SRCH_FLD'];
				$RMLT_CODE = $rec2['RMLT_CODE'];
				$IDNAMEFAC= $rec2['IDNAMEFAC'];
				$QUERYCODE= $rec2['RMCE_QUERYCODE'];

				//SE INSERTAN EL RESULTADO DE LOS FACTORES POR PERSONA
				if ($RMLT_CODE AND $FIELDNAME AND $QUERYCODE == ''){
					$sql3=  'INSERT  INTO CLRM_ACCOCRIT_VAL (RISK_MODEL,ACCOUNTCODE,CONTRACT_CODE,IDNAME,CLX_EFFTDATE,CRIT_ELEMENT,CRITELEM_VAL,RMCATWT_PCT, MODEL_WGHT,CRITVAL_SCORE, CDATE, CREATEDBY, MDATE, MODIFIEDBY) 
							SELECT DISTINCT '.singleQuote($modelo).',
								'.singleQuote($ACCO_IDCODE).',
								'.singleQuote($FICO_IDCODE).',
								'.singleQuote($IDNAMEFAC).',
								'.singleQuote($FECHA).',
								'.singleQuote($FIELDNAME).',
								A.'.$FIELDNAME.',
								RMLI.CRITVAL_SCORE,
								'.$RMCR_MODEL_WGHT.',
								(RMLI.CRITVAL_SCORE * '.$RMCR_MODEL_WGHT.'  / 100),'.singleQuote($FECHA).','.singleQuote($USER).','.singleQuote($FECHA).','.singleQuote($USER).'
							 FROM '.$IDNAME.' A, CLRM_CRITLIST_ITEMS RMLI
							 WHERE (A.'.$SRCH_FLD.' ='.singleQuote($ACCO_IDCODE).' OR  A.'.$SRCH_FLD.' ='.singleQuote($FICO_IDCODE).')
								AND RMLI.RMLT_CODE = '.singleQuote($rec2['RMLT_CODE']) .'
								AND ( A.'.$FIELDNAME.'  = RMLI.CRITELEM_VAL OR A.'.$FIELDNAME.' BETWEEN RMLI.CRITELEM_VALFROM AND RMLI.CRITELEM_VALTO)'.$limitdebug ; 
					//echo $sql3;
					$rs3 = ClxCommon::$db->executeQuery($sql3);
																					if ($debug==1&&$si14==1){echo  ("LINE:". __LINE__ ."  SELECT sql3 in foreach");PRE(beautiful_sql($sql3,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$si14=0;}
				}else if($RMLT_CODE AND $FIELDNAME AND $QUERYCODE <> ''){
					$PARAMS = ' AND ACCOUNTCODE = '.singleQuote($ACCO_IDCODE).' AND CONTRACT_CODE = '.singleQuote($FICO_IDCODE);
					$DBQY = &getTool('DBQY',false);
					$tool='DBQY';
					$QRYSQL = $DBQY->getSql($tool,$QUERYCODE);
					$QRYSQL = str_replace("'(","(",$QRYSQL);
					$QRYSQL = str_replace(")'",")",$QRYSQL);
					$QRYSQL = str_replace("#ACCO#",$ACCO_IDCODE,$QRYSQL);
					$QRYSQL = str_replace("#FICO#",$FICO_IDCODE,$QRYSQL);
					$QRYSQL = str_replace("#LISTA#",$RMLT_CODE,$QRYSQL);
					$QRYSQL = str_replace("#FE_INI#",$FECHA_INI,$QRYSQL);
					$QRYSQL = str_replace("#FE_FIN#",$FECHA_FIN,$QRYSQL);
					$QRYSQL = str_replace("#CUENTA#","'Contingent'",$QRYSQL);

					$sql8=$QRYSQL;

					$RESULT = ClxCommon::$db->getOne($sql8);
																					if ($debug==1&&$si16==1){echo  ("LINE:". __LINE__ ."  SELECT sql8 in foreach");PRE(beautiful_sql($sql8,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$si16=0;}
					if(is_numeric($RESULT)){
						$COND =' AND ( '.$RESULT.'  = RMLI.CRITELEM_VAL OR '.$RESULT.' BETWEEN RMLI.CRITELEM_VALFROM AND RMLI.CRITELEM_VALTO)' ;
					}
					else{
						$COND =' AND ( '.singleQuote($RESULT).'  = RMLI.CRITELEM_VAL OR '.singleQuote($RESULT).' BETWEEN RMLI.CRITELEM_VALFROM AND RMLI.CRITELEM_VALTO)' ;
					}
					if($RESULT){
						$sql9=  'INSERT  INTO CLRM_ACCOCRIT_VAL (RISK_MODEL,ACCOUNTCODE,CONTRACT_CODE,IDNAME,CLX_EFFTDATE,CRIT_ELEMENT,CRITELEM_VAL,RMCATWT_PCT, MODEL_WGHT,CRITVAL_SCORE, CDATE, CREATEDBY, MDATE, MODIFIEDBY) 
								SELECT DISTINCT '.singleQuote($modelo).',
									'.singleQuote($ACCO_IDCODE).',
									'.singleQuote($FICO_IDCODE).',
									'.singleQuote($IDNAMEFAC).',
									'.singleQuote($FECHA).',
									'.singleQuote($FIELDNAME).',
									'.singleQuote($RESULT).' ,
									RMLI.CRITVAL_SCORE,
									'.$RMCR_MODEL_WGHT.',
									(RMLI.CRITVAL_SCORE * '.$RMCR_MODEL_WGHT.'  / 100),'.singleQuote($FECHA).','.singleQuote($USER).','.singleQuote($FECHA).','.singleQuote($USER).
									'
								FROM  CLRM_CRITLIST_ITEMS RMLI
								WHERE RMLI.RMLT_CODE = '.singleQuote($RMLT_CODE).$COND.$limitdebug;	
						$rs9 = ClxCommon::$db->executeQuery($sql9);
																				if ($debug==1&&$si15==1){echo  ("LINE:". __LINE__ ."  SELECT sql9");PRE(beautiful_sql($sql9,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$si15=0;}
					}
				}
			}
		}//die;
		
		
	//SE INSERTAN POR CLIENTES//
		$sql5='INSERT INTO CLRM_ACCO_RISKEVAL
					(ACCOUNTCODE, RISK_MODEL, EVAL_METHOD, MODEL_SCORE, CLX_EFFTDATE, RISK_LEVEL, PDE, CDATE, CREATEDBY, MDATE, MODIFIEDBY)
				SELECT ACCOUNTCODE, RISK_MOD,EVAL_METHOD, MAX(SCORE) RISK_SCORE,'.singleQuote($FECHA).',
						CASE WHEN MAX(SCORE) >= RMSC.SCOREGT_HIGH THEN "A"
							WHEN MAX(SCORE) <= RMSC.SCORELT_LOW THEN "B"
							ELSE "M"
						END RISK, 
						"FACTORES",'.singleQuote($FECHA).','.singleQuote($USER).','.singleQuote($FECHA).','.singleQuote($USER).'
				FROM
					(SELECT RMMO.IDCODE RISK_MOD, RMMO.EVAL_METHOD, RMAV.ACCOUNTCODE, RMAV.CONTRACT_CODE, SUM(RMAV.CRITVAL_SCORE) SCORE
					FROM CLRM_ACCOCRIT_VAL RMAV, CLRM_MODELS_TBL RMMO
					WHERE RMAV.RISK_MODEL = RMMO.IDCODE AND RMAV.RISK_MODEL = '.$modelo.' AND RMAV.CLX_EFFTDATE = '.singleQuote($FECHA).' '.$DEL.'
					GROUP BY RMAV.RISK_MODEL, RMAV.ACCOUNTCODE, RMAV.CONTRACT_CODE) A, CLRM_SCORING_CFG RMSC
				WHERE RISK_MOD = RMSC.RISK_MODEL
				GROUP BY RISK_MOD, ACCOUNTCODE'.$limitdebug;
		$rs5 = ClxCommon::$db->executeQuery($sql5);

																				if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sql5 SE INSERTAN POR CLIENTES");PRE(beautiful_sql($sql5,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
		
		
			$sqlx5='SELECT DISTINCT ACCOUNTCODE,
				CASE WHEN SCORE >= RMSC.SCOREGT_HIGH THEN "A" WHEN SCORE <= RMSC.SCORELT_LOW THEN "B" ELSE "M" END RISK
				FROM
					(SELECT RMMO.IDCODE RISK_MOD, RMMO.EVAL_METHOD, RMAV.ACCOUNTCODE, RMAV.CONTRACT_CODE, SUM(RMAV.CRITVAL_SCORE) SCORE
					FROM CLRM_ACCOCRIT_VAL RMAV, CLRM_MODELS_TBL RMMO
					WHERE RMAV.RISK_MODEL = RMMO.IDCODE AND RMAV.RISK_MODEL = '.$modelo.' AND RMAV.CLX_EFFTDATE = '.singleQuote($FECHA).' '.$DEL.'
					GROUP BY RMAV.RISK_MODEL, RMAV.ACCOUNTCODE, RMAV.CONTRACT_CODE) A, CLRM_SCORING_CFG RMSC
				WHERE RISK_MOD = RMSC.RISK_MODEL
				GROUP BY RISK_MOD, ACCOUNTCODE'.$limitdebug;
		$rsx5 = ClxCommon::$db->executeQuery($sqlx5);
														if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sqlsx5 SE 	ACTUALIZA ACCO");PRE(beautiful_sql($sqlsx5,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
		
		while (($recx5 = ClxCommon::$db->getNextRecord($rsx5, ASSOCIATIVE))) {
		
			$sqlsx5="UPDATE CRM_ACCOUNTS ACCO SET ACCO.RISK_LEVEL = '".$recx5['RISK']."', ACCO.MDATE = '".$FECHA."' WHERE IDCODE = '".$recx5['ACCOUNTCODE']."'";
			//PRE( $sqlsx5);
			ClxCommon::$db->executeQuery($sqlsx5);
															if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sqlsx5 SE 	ACTUALIZA ACCO");PRE(beautiful_sql($sqlsx5,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
		
		
	
		}



//SE INSERTAN POR PRODUCTOS//

		$sql7='INSERT INTO CLRM_ACCOPROD_RISKEVAL
				(ACCOUNTCODE, CONTRACT_CODE, RISK_MODEL, MODEL_SCORE, CLX_EFFTDATE, RISK_LEVEL, PDE, CDATE, CREATEDBY, MDATE, MODIFIEDBY)
				SELECT DISTINCT ACCOUNTCODE, CONTRACT_CODE, RISK_MOD, SCORE RISK_SCORE,'.singleQuote($FECHA).',
						CASE WHEN SCORE >= RMSC.SCOREGT_HIGH THEN "A"
							WHEN SCORE <= RMSC.SCORELT_LOW THEN "B"
							ELSE "M"
						END RISK,
						"FACTORES",'.singleQuote($FECHA).','.singleQuote($USER).','.singleQuote($FECHA).','.singleQuote($USER).'
			FROM
				(SELECT RMMO.IDCODE RISK_MOD, RMAV.ACCOUNTCODE, RMAV.CONTRACT_CODE, SUM(RMAV.CRITVAL_SCORE) SCORE
				FROM CLRM_ACCOCRIT_VAL RMAV, CLRM_MODELS_TBL RMMO
				WHERE RMAV.RISK_MODEL = RMMO.IDCODE AND RMAV.RISK_MODEL = '.$modelo.' AND RMAV.CLX_EFFTDATE = '.singleQuote($FECHA). ' '.$DEL.'
				GROUP BY RMAV.RISK_MODEL, RMAV.ACCOUNTCODE, RMAV.CONTRACT_CODE) A, CLRM_SCORING_CFG RMSC
			WHERE RISK_MOD = RMSC.RISK_MODEL'.$limitdebug;
		$rs7 = ClxCommon::$db->executeQuery($sql7);
																		if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sql7 SE INSERTAN POR PRODUCTOS");PRE(beautiful_sql($sql7,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
	
	
//ACTUALIZO LOS PROVEEDORES DEL ESTADO A RIESGO MEDIO EN CASO DE QUE SEAN RIESGO BAJO
		$sql29 = "	SELECT DISTINCT RMAP.CONTRACT_CODE, RMAP.ACCOUNTCODE FROM CLRM_ACCOPROD_RISKEVAL RMAP, CRM_ACCOUNTS ACCO 
				WHERE RMAP.ACCOUNTCODE = ACCO.IDCODE
					AND RMAP.RISK_LEVEL = 'B'
					AND ACCO.STA_SUPL	= 1
					AND RMAP.RISK_MODEL = '".$modelo."'
					AND RMAP.CLX_EFFTDATE = '".$FECHA."'
					AND EXISTS (
						SELECT 1
						FROM CLRM_ACCOPROD_RISKEVAL A 
						WHERE RMAP.CONTRACT_CODE=A.CONTRACT_CODE AND  A.RISK_MODEL = '".$modelo."'	AND A.CLX_EFFTDATE = '".$FECHA."' 
							AND A.MODEL_SCORE = (SELECT MAX(B.MODEL_SCORE) FROM CLRM_ACCOPROD_RISKEVAL B WHERE A.CONTRACT_CODE = B.CONTRACT_CODE
							AND B.RISK_MODEL = '".$modelo."'	AND B.CLX_EFFTDATE = '".$FECHA."')
							AND A.RISK_LEVEL = 'B'
						GROUP BY A.CONTRACT_CODE
					)".$limitdebug;
		$rs29 = ClxCommon::$db->executeQuery($sql29);
																			if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sql29");PRE(beautiful_sql($sql29,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
		while (($rec29 = ClxCommon::$db->getNextRecord($rs29, ASSOCIATIVE))) {
			$sql27="UPDATE CLRM_ACCOPROD_RISKEVAL SET RISK_LEVEL = 'M', MODEL_SCORE = '".$MEDIO."', PDE = 'PROVEEDOR' 
					WHERE CONTRACT_CODE = '".$rec29['CONTRACT_CODE']."' AND RISK_MODEL = '".$modelo."' AND CLX_EFFTDATE = '".$FECHA."'";
			ClxCommon::$db->executeQuery($sql27);
			
			$sql25= "SELECT DISTINCT RMAR.ACCOUNTCODE FROM CLRM_ACCOPROD_RISKEVAL RMAR
					WHERE CONTRACT_CODE = '".$rec29['CONTRACT_CODE']."'
						AND RMAR.RISK_MODEL = '".$modelo."'
						AND RMAR.CLX_EFFTDATE = '".$FECHA."'".$limitdebug;	
					$rs25 = ClxCommon::$db->executeQuery($sql25);
																				if ($debug==1&&$si27==1){echo ("LINE:". __LINE__ ." SELECT sql25 ");PRE(beautiful_sql($sql25,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$si27=0;}
			
			while (($rec25 = ClxCommon::$db->getNextRecord($rs25, ASSOCIATIVE))) {
				$sql26="UPDATE CLRM_ACCO_RISKEVAL SET RISK_LEVEL = 'M', MODEL_SCORE = '".$MEDIO."', PDE = 'PROVEEDOR' 
						WHERE ACCOUNTCODE = '".$rec25['ACCOUNTCODE']."' AND RISK_MODEL = '".$modelo."' AND CLX_EFFTDATE = '".$FECHA."'";
				ClxCommon::$db->executeQuery($sql26);
																				if ($debug==1 && $si26==1){echo ("LINE:". __LINE__ ." SELECT sql26");PRE(beautiful_sql($sql26,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$si26=0;}


				$sqlsx6="UPDATE CRM_ACCOUNTS ACCO SET ACCO.RISK_LEVEL = 'M', ACCO.MDATE = '".$FECHA."' WHERE IDCODE ='".$rec25['ACCOUNTCODE']."'";
			//PRE( $sqlsx5);
				ClxCommon::$db->executeQuery($sqlsx6);
															if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sqlsx6 SE 	ACTUALIZA ACCO");PRE(beautiful_sql($sqlsx6,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
			
			}
		}
	//ACTUALIZO LOS PROVEEDORES DEL ESTADO A RIESGO MEDIO EN CASO DE QUE SEAN RIESGO BAJO QUE QUEDA PENDIENTE PORQUE NO SE AFECTO EL CONTRATO
		$sql30="SELECT DISTINCT RMAP.CONTRACT_CODE, RMAP.ACCOUNTCODE FROM CLRM_ACCOPROD_RISKEVAL RMAP, CRM_ACCOUNTS ACCO
				WHERE RMAP.ACCOUNTCODE = ACCO.IDCODE
					AND RMAP.RISK_LEVEL = 'B'
					AND ACCO.STA_SUPL	= 1
					AND RMAP.RISK_MODEL = '".$modelo."'
					AND RMAP.CLX_EFFTDATE = '".$FECHA."'".$limitdebug;
		$rs30 = ClxCommon::$db->executeQuery($sql30);
																				if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sql30 ACTUALIZO LOS PROVEEDORES DEL ESTADO A RIESGO MEDIO");PRE(beautiful_sql($sql30,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
		while (($rec30 = ClxCommon::$db->getNextRecord($rs30, ASSOCIATIVE))) {
			$sql33="UPDATE CLRM_ACCOPROD_RISKEVAL SET RISK_LEVEL = 'M', MODEL_SCORE = '".$MEDIO."', PDE = 'PROVEEDOR' 
								WHERE CONTRACT_CODE = '".$rec30['CONTRACT_CODE']."' AND RISK_LEVEL = 'B' AND RISK_MODEL = '".$modelo."' AND CLX_EFFTDATE = '".$FECHA."'";
			ClxCommon::$db->executeQuery($sql33);
																				if ($debug==1&&$si20==1){echo ("LINE:". __LINE__ ." SELECT sql33 WHILE");PRE(beautiful_sql($sql33,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$si20=0;}

			$sql31="SELECT DISTINCT RMAR.ACCOUNTCODE FROM CLRM_ACCOPROD_RISKEVAL RMAR
					WHERE CONTRACT_CODE = '".$rec30['CONTRACT_CODE']."'
						AND RMAR.RISK_MODEL = '".$modelo."'
						AND RMAR.RISK_LEVEL = 'B'
						AND RMAR.CLX_EFFTDATE = '".$FECHA."'".$limitdebug;	
			$rs31 = ClxCommon::$db->executeQuery($sql31);
																				if ($debug==1&&$si41==1){echo ("LINE:". __LINE__ ." SELECT sql31");PRE(beautiful_sql($sql31,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$si41=0;}
			while (($rec31 = ClxCommon::$db->getNextRecord($rs31, ASSOCIATIVE))) {
				$sql32="UPDATE CLRM_ACCO_RISKEVAL SET RISK_LEVEL = 'M', MODEL_SCORE = '".$MEDIO."', PDE = 'PROVEEDOR' 
						WHERE ACCOUNTCODE = '".$rec31['ACCOUNTCODE']."' AND RISK_LEVEL = 'B' AND RISK_MODEL = '".$modelo."' AND CLX_EFFTDATE = '".$FECHA."'";
				ClxCommon::$db->executeQuery($sql32);
																				if ($debug==1&&$si22==1){echo ("LINE:". __LINE__ ." SELECT sql32");PRE(beautiful_sql($sql32,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$si22=0;}

				$sql34="UPDATE CRM_ACCOUNTS ACCO SET ACCO.RISK_LEVEL = '".$rec31['RISK_LEVEL']."', ACCO.MDATE = '".$FECHA."' WHERE IDCODE = '".$rec31['ACCOUNTCODE']."'";
				ClxCommon::$db->executeQuery($sql34);
																				if ($debug==1&&$si23==1){echo ("LINE:". __LINE__ ." SELECT sql34");PRE(beautiful_sql($sql34,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$si23=0;}

			}
		}

		if ($pre === 'PROC'){
	//ACTUALIZO LOS CLIENTE QUE SON PEP POR LO TANTO SU RIESGO ES ALTO EN LA CALIFICACION POR CLIENTE **OJO**
			$sql18="SELECT  DISTINCT(ACCO_IDCODE), VAR_CRITICA  FROM CLRM_MATRIZ_RIESGO_CLIENTE_TMP A			
					RIGHT JOIN CLRM_ACCO_RISKEVAL B ON A.ACCO_IDCODE = B.ACCOUNTCODE AND B.CLX_EFFTDATE = '".$FECHA."' AND B.RISK_MODEL = '".$modelo."'
					WHERE A.RIESGO_CALCULADO <> 'NULL' AND  A.FECHA = '".$FECHA."'
					GROUP BY A.ACCO_IDCODE".$limitdebug;
					
			$rs18 = ClxCommon::$db->executeQuery($sql18);
																			if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sql18");PRE(beautiful_sql($sql18,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
			while (($rec18 = ClxCommon::$db->getNextRecord($rs18, ASSOCIATIVE))) {
				$sql10="UPDATE CLRM_ACCO_RISKEVAL SET RISK_LEVEL = 'A', MODEL_SCORE = ".$ALTO.", PDE = '".$rec18['VAR_CRITICA']."' 
						WHERE ACCOUNTCODE = '".$rec18['ACCO_IDCODE']."' AND RISK_MODEL = '".$modelo."' AND CLX_EFFTDATE = '".$FECHA."'";
				//echo sql10;
						ClxCommon::$db->executeQuery($sql10);			
																			if ($debug==1&&$si24==1){echo ("LINE:". __LINE__ ." SELECT sql10");PRE(beautiful_sql($sql10,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
				$sqlsx7="UPDATE CRM_ACCOUNTS ACCO SET ACCO.RISK_LEVEL = 'A', ACCO.MDATE = '".$FECHA."' WHERE IDCODE ='".$rec18['ACCO_IDCODE']."'";
			//PRE( $sqlsx5);
				ClxCommon::$db->executeQuery($sqlsx7);
															if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sqlsx7 SE 	ACTUALIZA ACCO");PRE(beautiful_sql($sqlsx7,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}

			
			
			
			}
		}

		if ($pre === 'PROC'){

//INSERTO LOS CLIENTE QUE SON PEP POR LO TANTO SU RIESGO ES ALTO EN LA CALIFICACION POR CLIENTE
			$sql19="SELECT  DISTINCT ACCO_IDCODE,RIESGO_CALCULADO, VAR_CRITICA  FROM CLRM_MATRIZ_RIESGO_CLIENTE_TMP A	WHERE A.RIESGO_CALCULADO <>	 'NULL'	
						AND NOT EXISTS  (
							SELECT 1 FROM CLRM_ACCO_RISKEVAL B WHERE ACCO_IDCODE= B.ACCOUNTCODE AND B.CLX_EFFTDATE = '".$FECHA."' AND B.RISK_MODEL = '".$modelo."'
						)
						GROUP BY A.ACCO_IDCODE".$limitdebug;
			$rs19 = ClxCommon::$db->executeQuery($sql19);
																				if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sql19 INSERTO LOS CLIENTE QUE SON PEP POR LO TANTO SU RIESGO");PRE(beautiful_sql($sql19,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
			while (($rec19 = ClxCommon::$db->getNextRecord($rs19, ASSOCIATIVE))) {
				$sql20="INSERT INTO CLRM_ACCO_RISKEVAL (ACCOUNTCODE, RISK_MODEL, EVAL_METHOD, MODEL_SCORE, CLX_EFFTDATE, RISK_LEVEL, PDE, CDATE, CREATEDBY, MDATE, MODIFIEDBY )
						VALUES('".$rec19['ACCO_IDCODE']."','".$modelo."', '01', ".$ALTO.", '".$FECHA."','".$rec19['RIESGO_CALCULADO']."', '".$rec19['VAR_CRITICA']."','".$FECHA."','".$USER."','".$FECHA."','".$USER."')";
				ClxCommon::$db->executeQuery($sql20);			
																				if ($debug==1&&$si13==1){echo ("LINE:". __LINE__ ." SELECT sql20");	PRE(beautiful_sql($sql20,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$si13=0;}


				$sqlsx8="UPDATE CRM_ACCOUNTS ACCO SET ACCO.RISK_LEVEL = ".$ALTO.", ACCO.MDATE = '".$FECHA."' WHERE IDCODE ='".$rec19['ACCO_IDCODE']."'";
						//PRE( $sqlsx5);
							ClxCommon::$db->executeQuery($sqlsx8);
																		if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sqlsx8 SE 	ACTUALIZA ACCO");PRE(beautiful_sql($sqlsx8S,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}



			}
		}

		if ($pre === 'PROC'){

//INSERTO LOS PRODUCTOS QUE SON PEP POR LO TANTO SU RIESGO ES ALTO EN LA CALIFICACION POR PRODUCTO
			$sql17="INSERT INTO CLRM_ACCOPROD_RISKEVAL
						(ACCOUNTCODE, CONTRACT_CODE, RISK_MODEL, MODEL_SCORE, CLX_EFFTDATE, RISK_LEVEL, PDE, CDATE, CREATEDBY, MDATE, MODIFIEDBY )		
					SELECT DISTINCT ACCO_IDCODE, FICO_IDCODE, '".$modelo."', ".$ALTO.", '".$FECHA."', RIESGO_CALCULADO, VAR_CRITICA,'".$FECHA."','".$USER."','".$FECHA."','".$USER."'
					FROM CLRM_MATRIZ_RIESGO_CLIENTE_TMP
					WHERE RIESGO_CALCULADO <> 'NULL'".$limitdebug;
					//echo $sql17;// die;
			ClxCommon::$db->executeQuery($sql17);
																			if ($debug==1){	echo ("LINE:". __LINE__ ." SELECT sql17");PRE(beautiful_sql($sql17,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}

		}

		if ($pre === 'PROC'){
	
//ACTUALIZO LOS CLIENTES EN ACCO
			$sql11 = "SELECT  RISK_LEVEL,ACCOUNTCODE  
						FROM CLRM_ACCO_RISKEVAL RMAR 
						WHERE RISK_MODEL = '".$modelo."' AND 
						CLX_EFFTDATE = '".$FECHA."'
						AND MODEL_SCORE =  (SELECT MAX(MODEL_SCORE) FROM CLRM_ACCO_RISKEVAL RMAR2 
											WHERE RISK_MODEL = '".$modelo."' AND 
												  CLX_EFFTDATE = '".$FECHA."' AND 
												  RMAR.ACCOUNTCODE=RMAR2.ACCOUNTCODE)"
									.$limitdebug;
			$rs11 = ClxCommon::$db->executeQuery($sql11);
																			if ($debug==1){	echo ("LINE:". __LINE__ ." SELECT 11 ACTUALIZO LOS CLIENTES EN ACCO");PRE(beautiful_sql($sql11,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
			while (($rec11 = ClxCommon::$db->getNextRecord($rs11, ASSOCIATIVE))) {
				$sql12="UPDATE CRM_ACCOUNTS ACCO SET ACCO.RISK_LEVEL = '".$rec11['RISK_LEVEL']."', ACCO.MDATE = '".$FECHA."' WHERE IDCODE = '".$rec11['ACCOUNTCODE']."'";
				ClxCommon::$db->executeQuery($sql12);
																			if ($debug==1&&$si11==1){echo ("LINE:". __LINE__ ." SELECT sql12 WHILE ACTUALIZO LOS CLIENTES EN ACCO");PRE(beautiful_sql($sql12,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$si11=0;}
				
			}
		

//ACTUALIZO LOS CONTRATOS  EN FICO
			$sql13="SELECT DISTINCT CONTRACT_CODE, MODEL_SCORE, RISK_LEVEL
					FROM CLRM_ACCOPROD_RISKEVAL A 
					WHERE A.RISK_MODEL = '".$modelo."'	AND A.CLX_EFFTDATE = '".$FECHA."' 
						AND A.MODEL_SCORE = (SELECT MAX(B.MODEL_SCORE) FROM CLRM_ACCOPROD_RISKEVAL B WHERE A.CONTRACT_CODE = B.CONTRACT_CODE
						AND B.RISK_MODEL = '".$modelo."'	AND B.CLX_EFFTDATE = '".$FECHA."')
					GROUP BY A.CONTRACT_CODE".$limitdebug;
			$rs13 = ClxCommon::$db->executeQuery($sql13);
																			if ($debug==1){	echo ("LINE:". __LINE__ ." SELECT sql13 ACTUALIZO LOS CONTRATOS  EN FICO");PRE(beautiful_sql($sql13,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
			while (($rec13 = ClxCommon::$db->getNextRecord($rs13, ASSOCIATIVE))) {
					$sql14="UPDATE FIDU_CONTRACTS SET RISK_LEVEL = '".$rec13['RISK_LEVEL']."', MDATE = '".$FECHA."' WHERE IDCODE = '".$rec13['CONTRACT_CODE']."'";
					ClxCommon::$db->executeQuery($sql14);
																			if ($debug==1&&$si8==1){echo ("LINE:". __LINE__ ."  SELECT sql14");PRE(beautiful_sql($sql14,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$si8=0;}

			}
		}

		if ($pre === 'FICO'){
//ACTUALIZO EL CONTRATO EN FICO
			$sql15="SELECT CONTRACT_CODE, MAX(MODEL_SCORE), RISK_LEVEL 
					FROM CLRM_ACCOPROD_RISKEVAL 
					WHERE RISK_MODEL = '".$modelo."'	AND CLX_EFFTDATE = '".$FECHA."'	AND CONTRACT_CODE = '".$FICO_IDCODE."'
					GROUP BY CONTRACT_CODE,RISK_LEVEL
					ORDER BY MODEL_SCORE DESC LIMIT 1";
			$rs15 = ClxCommon::$db->executeQuery($sql15);
																			if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sql15 ACTUALIZO EL CONTRATO EN FICO ");PRE(beautiful_sql($sql15,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
			while (($rec15 = ClxCommon::$db->getNextRecord($rs15, ASSOCIATIVE))) {
				$sql16="UPDATE FIDU_CONTRACTS SET RISK_LEVEL = '".$rec15['RISK_LEVEL']."', MDATE = '".$FECHA."' WHERE IDCODE = '".$rec15['CONTRACT_CODE']."'";
				ClxCommon::$db->executeQuery($sql16);	
																			if ($debug==1&&$si19==1){	echo ("LINE:". __LINE__ ." SELECT sql16");PRE(beautiful_sql($sql16,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$si19=0;}
			}
		
//ACTUALIZO LOS CLIENTES EN ACCO
			$sql221 = "SELECT  DISTINCT RISK_LEVEL,ACCOUNTCODE  
						FROM CLRM_ACCOPROD_RISKEVAL RMAR 
						WHERE RISK_MODEL = '".$modelo."' AND CLX_EFFTDATE = '".$FECHA."' 
						AND CONTRACT_CODE ='".$FICO_IDCODE."' ORDER BY MODEL_SCORE DESC".$limitdebug;
			$rs221 = ClxCommon::$db->executeQuery($sql221);
																			if ($debug==1){echo ("LINE:". __LINE__ ." SELECT sql221 ACTUALIZO LOS CLIENTES EN ACCO");PRE(beautiful_sql($sql221,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
			while (($rec221 = ClxCommon::$db->getNextRecord($rs21, ASSOCIATIVE))) {
				$sql222="UPDATE CRM_ACCOUNTS ACCO SET ACCO.RISK_LEVEL = CASE WHEN ACCO.RISK_LEVEL = 'A' OR '".$rec21['RISK_LEVEL']."'='A' THEN 'A'
																			WHEN ACCO.RISK_LEVEL = 'M' OR '".$rec21['RISK_LEVEL']."'='M' THEN 'M'
																			ELSE 'B'
																	   END			
												, ACCO.MDATE = '".$FECHA."' 
						WHERE IDCODE = '".$rec21['ACCOUNTCODE']."'";

				
				ClxCommon::$db->executeQuery($sql222);
																			if ($debug==1&&$si9==1){echo ("LINE:". __LINE__ ." SELECT sql222 ANTEPENULTIMO WHILE");PRE(beautiful_sql($sql222,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$si9=0;}
			}
		}
		
		if ($pre === 'FIPA'){
	//ACTUALIZO LOS CLIENTES EN ACCO
			$sql21 = "SELECT  DISTINCT RISK_LEVEL,ACCOUNTCODE  FROM CLRM_ACCOPROD_RISKEVAL RMAR WHERE RISK_MODEL = '".$modelo."' AND CLX_EFFTDATE = '".$FECHA."' AND CONTRACT_CODE ='".$FICO_IDCODE."'".$limitdebug;
			//echo $sql21;
			$rs21 = ClxCommon::$db->executeQuery($sql21);
																			if ($debug==1){	echo ("LINE:". __LINE__ ." SELECT sql21 ACTUALIZO LOS CLIENTES EN ACCO");PRE(beautiful_sql($sql21,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));}
			while (($rec21 = ClxCommon::$db->getNextRecord($rs21, ASSOCIATIVE))) {
				$sql22="UPDATE CRM_ACCOUNTS ACCO SET ACCO.RISK_LEVEL = CASE WHEN ACCO.RISK_LEVEL = 'A' OR '".$rec21['RISK_LEVEL']."'='A' THEN 'A'
																			WHEN ACCO.RISK_LEVEL = 'M' OR '".$rec21['RISK_LEVEL']."'='M' THEN 'M'
																			ELSE 'B'
																	   END			
												, ACCO.MDATE = '".$FECHA."' 
						WHERE IDCODE = '".$rec21['ACCOUNTCODE']."'";
				ClxCommon::$db->executeQuery($sql22);
																			if ($debug==1&&$si10==1){echo ("LINE:". __LINE__ ." SELECT sql22 ACTUALIZO LOS CLIENTES EN ACCO ULTIMO WHILE");PRE(beautiful_sql($sql22,'<br>', " &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;",false));$si10=0;}
			}
		}
		addMessage("Proceso Completado. </br>   "); 
	}


}