<?php

/**
 * General Code File
 * For more information contact  support@alenet.com
 *
 * @author	   $Author: fsantana $
 * @copyright	Alenet, Inc.
 * @since		$Date: 2015-09-03 12:24:19 -0400 (Thu, 03 Sep 2015) $
 * @version		$Rev: 6814 $
 *
 * CHANGE LOG
 *  Included svn prop
 */
class Fibp {

    var $display = false;

    /**
     * Constructor
     * @param array [$procParameters]
     */
    function __construct($procParameters = array()) {
        multiTableName($this, array('FICO', 'FIBK', 'FIBP'));
        $this->batch_id = (!empty($procParameters['BATCH_ID'])) ? $procParameters['BATCH_ID'] : batch_id();
        $this->username = $_SESSION['user_record']['username'];
        $this->now = xFormat::getNow('Y-m-d H:i:s');
        $this->today = xFormat::getNow('Y-m-d');
        $this->je_source = '';
    }

    /**
     * Init Form
     * @param array $record
     */
    function init_form(&$record) {
        $this->load_form($record);
    }

    /**
     * Load Form
     * @param array $record
     */
    function load_form(&$record) {
        $record['FIBP_COMP_CODE'] = ClxCommon::$db->getField($this->fibkname, 'COMP_CODE', 'BANK_ACCOUNT_NO = ' . singleQuote($record['FIBP_BANKACT_CODE']));
    }

}
