/*
 * Asiganando valores de tasa, periodo y tipo de periodo segun el programa seleccionado en redescuento
 */
function rediSetAmts()
{ 	
	//obtengo el codigo del programa
	var redi_repg_code = $('select[name="REDI_REPG_CODE"]').val();
	//obtengo el valor a deseleccionar de la lista
	var repg_period_type_actual = $('select[name="REDI_PERIOD_TYPE"]').val();
	
	var url = "window.php?to=DBQY&ac=QXML&no_menu=1&no_alerts=1&qy=REPG_JS&fn[]=REPG.IDCODE&fv[]="+ redi_repg_code;
    $.ajax({
        type : "GET",
        url : url,
        async : false,
        dataType : "xml",
        success : function(xml) {
            $(xml).find('REPG_JS').each(function() {
                var repg_tasa_int = $(this).find('REPG_TASA_INT').text();
                var repg_redi_period = $(this).find('REPG_REDI_PERIOD').text();
                var repg_period_type = $(this).find('REPG_PERIOD_TYPE').text();
                
				//coloco la taza
				$("#REDI_PASSIVE_RT").val(repg_tasa_int);
				//coloco periodo
                $("#REDI_REDI_PERIOD").val(repg_redi_period);
                
				//deselecciono el valor actual en la lista
				$("#REDI_PERIOD_TYPE option[value='"+repg_period_type_actual+"']").attr("selected",false);
				//selecciono el valor en la lista y que fue obtenido de la consulta query
				$("#REDI_PERIOD_TYPE option[value='"+repg_period_type+"']").attr("selected",true);

            });
        }
    });
	
	
}


function rediSetcalAmts()
{
	var p = parseFloat($("#REDI_CAPITAL_AMT").val());
    var q = parseFloat($("#REDI_INTEREST_AMT").val());
    $("#REDI_PAYMENT_AMT").val(numDec(p+q,2));
	
}

function rediSetListeners()
{
    $('#REDI_REPG_CODE').change(rediSetAmts);
	
    $('#REDI_CAPITAL_AMT').change(rediSetcalAmts);
    $('#REDI_INTEREST_AMT').change(rediSetcalAmts);
	

	//rediSetAmts();
}

function retrSetAmts()
{
	var p = parseFloat($("#RETR_ABONO_CAPITAL").val());
    var q = parseFloat($("#RETR_INTPAID_AMT").val());
    $("#RETR_TRANS_AMT").val(numDec(p+q,2));
	
}

function retrSetListeners()
{
    $('#RETR_ABONO_CAPITAL').change(retrSetAmts);
    $('#RETR_INTPAID_AMT').change(retrSetAmts);
	
}


function reilSetAmts()
{
	var p = parseFloat($("#REIL_CAPITAL").val());
    var q = parseFloat($("#REIL_INTEREST_AMT").val());
    $("#REIL_LINE_AMT").val(numDec(p+q,2));
	
}

function reilSetListeners()
{
    $('#REIL_CAPITAL').change(reilSetAmts);
    $('#REIL_INTEREST_AMT').change(reilSetAmts);
	
}

/*
 * funcin para crear dinamicamente lista desplegable de programas segun ente redescontante seleccionado en la forma
 */
function rediSetListProgram()
{ 	
	//Obtengo el codigo de ente Redescontante
    var redi_rein_code = $('select[name="REDI_REIN_CODE"]').val();

    //limpiamos la lista de opciones de programas y dejamos una entrada en blanco en la lista
    $('#REDI_REPG_CODE option').remove();
    $('#REDI_REPG_CODE').append('<option value=""></option>');

    var url = "window.php?to=DBQY&ac=QXML&no_menu=1&no_alerts=1&qy=REPG_JS&fn[]=REPG.REIN_CODE&fv[]="+ redi_rein_code;
    $.ajax({
        type : "GET",
        url : url,
        async : false,
        dataType : "xml",
        success : function(xml) {
            $(xml).find('REPG_JS').each(function() {
                //obtenemos campos del nodo xml
                var idcode = $(this).find('REPG_IDCODE').text();
                var idname = $(this).find('REPG_IDNAME').text();
                //creamos la entrada en la lista desplegable
                $('#REDI_REPG_CODE').append('<option value="'+idcode+'">'+idcode+', '+idname+'</option>');
            });
        }
    });
}


function rediSetProgram()
{
    $('#REDI_REIN_CODE').change(rediSetListProgram);
	//rediSetAmts();
}

