var dbqc_editform_msg1 = 'Please select a operator';
function criteria_add() {
    if (criteria_check()) {
        var tform = $('#theForm')[0];
//	var list = document.getElementById('criteria_table');
//	var rows = list.getElementsByTagName('tr');
//        var row_qty = rows.length;

        var row_number = row_create('&nbsp;');

        var logical_id = tform.elements['logical_' + row_number].selectedIndex;

        var table_id = tform.elements['DBQC_tables'].selectedIndex;
        var field_id = tform.elements['DBQC_fields'].selectedIndex;
        var operator_id = tform.elements['DBQC_operators'].selectedIndex;
        var value = '';
        var type_id = '';
        var i = 0;
		
        if (tform.elements['DBQC_value'][0].checked) { // Constant
            type_id = 'k';
            value = tform.elements['DBQC_constant'].value;
			
            if(value=='null'){
                value = 'NULL';
            }
        } else if (tform.elements['DBQC_value'][1].checked) { // Join Field
            type_id = 'f';
            i = tform.elements['DBQC_joinfields'].selectedIndex;
            value = tform.elements['DBQC_joinfields'][i].text;

        } else if (tform.elements['DBQC_value'][2].checked) { // Variable
            type_id = 'v';
            i = tform.elements['DBQC_variables'].selectedIndex;
            value = tform.elements['DBQC_variables'][i].value + '|DOT|' + tform.elements['DBQC_variables'][i].text;

        } else if (tform.elements['DBQC_value'][3].checked) { // Ask the User
            type_id = 'u';
            value = 'Ask the user';
        }
        else {
            type_id = '';
        }

        var open_brackets = '';
        var close_brackets = '';
		value=value.replace(/'/g,'((singlequote))');
        var row_set_data = [row_number, logical_id, open_brackets, table_id, field_id, operator_id, type_id, value, close_brackets];
        row_set(row_set_data);

        row_highlight(row_number);
        form_set_buttons();
    }
}

function criteria_modify() {
	
   if (criteria_check()) {
        var form = $('#theForm')[0];
        var row_number = form.elements['selected_row'].value;
        var row_cells = row_cells_get(row_number);

        var logical_id = form.elements['logical_' + row_number].selectedIndex;

        var table_id = form.elements['DBQC_tables'].selectedIndex;
        var field_id = form.elements['DBQC_fields'].selectedIndex;
        var operator_id = form.elements['DBQC_operators'].selectedIndex;
        var type_id;
        var value;
        var i;
		
        if (form.elements['DBQC_value'][0].checked) { // Constant
            type_id = 'k';
            value = form.elements['DBQC_constant'].value;
			

        } else if (form.elements['DBQC_value'][1].checked) { // Join Field
            type_id = 'f';
            i = form.elements['DBQC_joinfields'].selectedIndex;
            value = form.elements['DBQC_joinfields'][i].text;

        } else if (form.elements['DBQC_value'][2].checked) { // Variable
            type_id = 'v';
            i = form.elements['DBQC_variables'].selectedIndex;
            value = form.elements['DBQC_variables'][i].value + '|DOT|' + form.elements['DBQC_variables'][i].text;

        } else if (form.elements['DBQC_value'][3].checked) { // Ask the User
            type_id = 'u';
            value = 'Ask the user';
        }
        else {
            var type_id = '';
        }
        var open_brackets = row_cells[2].innerHTML;
        var close_brackets = row_cells[6].innerHTML;
        var row_set_data = [row_number, logical_id, open_brackets, table_id, field_id, operator_id, type_id, value, close_brackets];
        row_set(row_set_data);

    }
}

function criteria_delete() {
    var form = $('#theForm')[0];
    var row_qty = form.elements['selected_row'].value;

    var tr = document.getElementById('row_' + row_qty);

    while (tr.firstChild != null) {
        tr.removeChild(tr.firstChild);
    }

    var p = tr.parentNode;
    p.removeChild(tr);
    form.elements['selected_row'].value = '';
    row_fix();
    form_set_buttons();
}

function criteria_check() {
    var form = $('#theForm')[0];

    if (form.elements['DBQC_operators'].selectedIndex == -1) {
        alert(dbqc_editform_msg1);
        return false;
    }

    return true;
}

function form_init() {

    form_set_tables();
    form_set_fields();
    form_set_operators();
    form_set_joinfields();
    form_set_variables();

    var form = $('#theForm')[0];
    form.elements['DBQC_joinfields'].selectedIndex = -1;
    form.elements['DBQC_variables'].selectedIndex = -1;
    form.elements['DBQC_constant'].value = '';
    var criteria = form.elements['criteria'].value;
    if (criteria.length > 0) {
        var criterialines = criteria.split('|END|');
        var qty = criterialines.length;

        for (var i = 0; i < qty; i++) {
            var criteriainfo = criterialines[i].split('|SEP|');
            var row_number = row_create('');
            var logical_id = searchInArray(logicals, criteriainfo[0]);
            var open_brackets = criteriainfo[1];
            var table_id = searchInArray(tables, criteriainfo[2]);
            var field_id = searchInArray(fields[table_id], criteriainfo[3]);
            var operator_id = searchInArray(operators, criteriainfo[4]);
            var type_id = criteriainfo[5];
            var value;
            if (type_id == 'k') {
                value = criteriainfo[6];
				
            
	        } else if (type_id == 'v') {
                value = criteriainfo[6];
            } else if (type_id == 'f') {
                value = criteriainfo[6];
            } else if (type_id == 'u') {
                value = '';
            }
            else {
                value = '';
            }
            var close_brackets = criteriainfo[7];
            var row_set_data = [row_number, logical_id, open_brackets, table_id, field_id, operator_id, type_id, value, close_brackets];
            
			row_set(row_set_data);
        }
    }

    form_set_buttons();
}

function form_set_tables() {
    var form = $('#theForm')[0];
    pop_set(form.elements['DBQC_tables'], tables, '');
}

function form_set_fields() {
    var form = $('#theForm')[0];
    var table_id = form.elements['DBQC_tables'].selectedIndex;
    pop_set(form.elements['DBQC_fields'], fields[table_id], '');
}

function form_set_operators() {
    var form = $('#theForm')[0];
    pop_set(form.elements['DBQC_operators'], operators, '');
}

function form_set_joinfields() {
    var form = $('#theForm')[0];

    pop_clear(form.elements['DBQC_joinfields']);

    for (var t = 0; t < tables.length; t++) {
        var ti = tables[t].split('|DOT|');

        for (var f = 0; f < fields[t].length; f++) {
            var fi = fields[t][f].split('|DOT|');
            pop_additem(form.elements['DBQC_joinfields'], ti[0] + '.' + fi[0] + '|DOT|' + ti[0] + '.' + fi[0]);
        }
    }
}

function form_set_variables() {
    var form = $('#theForm')[0];
    pop_set(form.elements['DBQC_variables'], variables, '');
}

function form_set_buttons() {
    var form = $('#theForm')[0];
    var i = form.elements['selected_row'].value;
    var save_btn = form.elements['save_btn'];
    var delete_btn = form.elements['delete_btn'];
    save_btn.disabled = (i == '') ? true : false;
    delete_btn.disabled = (i == '') ? true : false;
}

function form_process() {

    var form = $('#theForm')[0];
    var list = document.getElementById('criteria_table');
    var rows = list.getElementsByTagName('tr');

    var row_qty = rows.length;
    var criteria = '';

    for (var i = 1; i < row_qty; i++) {// the headers are i=0
        var tr = rows[i];
        var pos = tr.id.indexOf('_');
        var id = tr.id.substr(pos + 1);

        var bs = document.getElementsByName('logical_' + id);
        var b = bs[0].value;
        if (i > 1) {
            criteria += '|END|';
        }
        var row_cells = row_cells_get(id);
		var row_info = form.elements['row_info_' + id].value.split('|PRE|');
        var table_code = tables[row_info[0]].split('|DOT|')[0];
        var field_code = fields[row_info[0]][row_info[1]].split('|DOT|')[0];
        var operand_code = form.elements['DBQC_operators'][row_info[2]].value;
		criteria += b + '|PRE|' + row_cells[2].innerHTML + '|PRE|' + table_code + '|PRE|' + field_code + '|PRE|' + operand_code + '|PRE|' + row_info[3] + '|PRE|' + row_info[4] + '|PRE|' + row_cells[6].innerHTML;
    }

    form.elements['criteria'].value = criteria;
    //unset check for submition
    $('input[type=checkbox]').prop('checked', false);
    return true;
}



function row_group() {
    row_group_ungroup('group');
}

function row_ungroup() {
    row_group_ungroup('ungroup');
}

function row_group_ungroup(action) {
    var form = $('#theForm')[0];
    var list = document.getElementById('criteria_table');

    var rows = list.getElementsByTagName('tr');
    var row_qty = rows.length;
    var first = -1;
    var last = -1;

//    var criteria = '';
    for (var i = 1; i < row_qty; i++) {
        var tr = rows[i];
        var pos = tr.id.indexOf('_');
        var id = tr.id.substr(pos + 1);

        var sel = form.elements['selector_' + id];
        if (sel.checked) {
            if (first == -1) {
                first = id;
            }
            last = id;
        }
    }
    var cells;
    if (action == 'group') {
        if (first != -1) {
            cells = row_cells_get(first);
            cells[2].innerHTML += '(';
        }
        else {
        }
        if (last != -1) {
            cells = row_cells_get(last);
            cells[6].innerHTML += ')';
        }
        else {
        }
    } else if (action == 'ungroup') {
        if (first != -1) {
            cells = row_cells_get(first);
            var la = cells[2].innerHTML.length;
            cells[2].innerHTML = cells[2].innerHTML.substr(1, la);
        }
        else {
        }
        if (last != -1) {
            cells = row_cells_get(last);
            var la = cells[6].innerHTML.length;
            cells[6].innerHTML = cells[6].innerHTML.substr(1, la);
        }
        else {
        }
    }
}

function row_select() {
    var e = event.srcElement;

    if (e.tagName == 'TD') {
        var f = e.parentElement;
        var row_id = f.id;
        var p = row_id.indexOf('_');
        var row_number = row_id.substr(p + 1);
        row_load(row_number);
    }
}

// copies a row to the criteria editor
function row_load(row_number) {
    row_highlight(row_number);

    var form = $('#theForm')[0];
    var row_info = form.elements['row_info_' + row_number].value.split('|PRE|');
	form.elements['DBQC_tables'].selectedIndex = row_info[0];
    form_set_fields();
    form.elements['DBQC_fields'].selectedIndex = row_info[1];
    form.elements['DBQC_operators'].selectedIndex = row_info[2];

    if (row_info[3] == 'k') {
        form.elements['DBQC_value'][0].checked = true;
		form.elements['DBQC_constant'].value = row_info[4].replace(/\(\(singlequote\)\)/g,"'");
        form.elements['DBQC_joinfields'].selectedIndex = -1;
        form.elements['DBQC_variables'].selectedIndex = -1;
	        
    } else if (row_info[3] == 'f') {

        form.elements['DBQC_value'][1].checked = true;
        form.elements['DBQC_joinfields'].selectedIndex = -1;
        $('#DBQC_joinfields').val(row_info[4]);
        form.elements['DBQC_constant'].value = '';
        form.elements['DBQC_variables'].selectedIndex = -1;

    } else if (row_info[3] == 'v') {

        form.elements['DBQC_value'][2].checked = true;
        form.elements['DBQC_variables'].selectedIndex = searchInArray(variables, row_info[4]);
        form.elements['DBQC_joinfields'].selectedIndex = -1;
        $('#DBQC_joinfields').val('');
    } else if (row_info[3] == 'u') {
        form.elements['DBQC_value'][3].checked = true;
        form.elements['DBQC_constant'].value = '';
        form.elements['DBQC_joinfields'].selectedIndex = -1;
        form.elements['DBQC_variables'].selectedIndex = -1;
    } else {
        form.elements['DBQC_value'][3].checked = false;
        form.elements['DBQC_constant'].value = '';
        form.elements['DBQC_variables'].selectedIndex = -1;

    }
    form_set_buttons();
}

// creates a new blank row
function row_create(contents) {

    var form = $('#theForm')[0];
    var list = document.getElementById('criteria_table');

    var source = '';
    var row_number = Number(form.elements['row_qty'].value);
    form.elements['row_qty'].value = row_number + 1;
    //var row_info = '';
    var row_id = 'row_' + row_number;

    var tr = list.insertRow(-1);
    tr.setAttribute('onclick', 'row_load(' + row_number + ')');
    tr.setAttribute('id', row_id);

    // Selector
    var td1 = document.createElement('td');
    td1.innerHTML = "<input type='checkbox' name='selector_" + row_number + "' value='1' >";  //onclick='form_set_selectors()'>";
    tr.appendChild(td1);

    // Logical
    var td2 = document.createElement('td');
    source = "<select name='logical_" + row_number + "'>";
    for (var i = 0; i < logicals.length; i++) {
        var l = logicals[i];
        var v = l.split('|DOT|');
        source += "<option value='" + v[0] + "'>" + v[1] + '</option>';
    }
    source += '</select>';
    td2.innerHTML = source;
    tr.appendChild(td2);

    // Open (
    var td3 = document.createElement('td');
    //	td.innerHTML =  "<input type='text' readonly name='open_" + row_number + "' size='5' maxlength='24' value='"+row_number+"'>";
    td3.innerHTML = '';
    tr.appendChild(td3);

    // Table and Field
    var td4 = document.createElement('td');
    td4.innerHTML = contents;
    tr.appendChild(td4);

    // Operator
    var td5 = document.createElement('td');
    td5.innerHTML = contents;
    tr.appendChild(td5);

    // Value
    var td6 = document.createElement('td');
    td6.innerHTML = contents;
    tr.appendChild(td6);

    // Close )
    var td7 = document.createElement('td');
    //	td.innerHTML =  "<input type='text' readonly name='close_" + row_number + "' size='5' maxlength='24' value=''>";
    td7.innerHTML = '';
    tr.appendChild(td7);

    // Control
    var td8 = document.createElement('td');
    td8.innerHTML = '';
    tr.appendChild(td8);

    //list.appendChild(tr);
    //alert("Created row number: " + row_number);
    return row_number;
}

// deletes the logical selector from the first row.
function row_fix() {
    return;
}

// sets the values in a row
function row_set(row_set_data) {

    var row_number = row_set_data[0];
    var logical_id = row_set_data[1];
    var open_brackets = row_set_data[2];
    var table_id = row_set_data[3];
    var field_id = row_set_data[4];
    var operator_id = row_set_data[5];
    var type_id = row_set_data[6];
    var value = row_set_data[7];
    var close_brackets = row_set_data[8];

    var form = $('#theForm')[0];
//		var row_id = 'row_' + row_number;
//		var tr = document.getElementById(row_id);
    var row_info = '';
    var row_cells = row_cells_get(row_number);

    // 0 - Selector
    // 1 - Logical
    form.elements['logical_' + row_number].selectedIndex = logical_id;

    // 2 - Open Bracket
    row_cells[2].innerHTML = open_brackets;

    // 3 - Table and Field

    var table_info = tables[table_id].split('|DOT|');
    var table_tx = table_info[1];
    var field_info = fields[table_id][field_id].split('|DOT|');
    var field_tx = field_info[1];
    row_info += table_id + '|PRE|' + field_id + '|PRE|';
    row_cells[3].innerHTML = table_tx + '.' + field_tx;
	
    // 4 - Operator
    var operator_info = operators[operator_id].split('|DOT|');
    var operator_tx = operator_info[1];
    row_info += operator_id + '|PRE|';
    row_cells[4].innerHTML = operator_tx;
    var v;
    var p;
    // 5 - Value
    if (type_id == 'k') { // Constant
        row_info += 'k|PRE|' + value;
        v = quote(value.replace(/\(\(singlequote\)\)/g,"'"));

    } else if (type_id == 'f') { // Join Field
        v = value;
        row_info += 'f|PRE|' + v;

    } else if (type_id == 'v') { // Variable
        p = value.indexOf('|DOT|');
        v = value.substr(p + 1);
        row_info += 'v|PRE|' + value.substr(0, p);

    } else if (type_id == 'u') { // Ask the User
        row_info += 'u|PRE|';
        v = 'Ask the user';
    }
    else {
        v = '';
    }
    // Value
    row_cells[5].innerHTML = v;
	
	// 6 - Close Bracket and Value
    row_cells[6].innerHTML = close_brackets;

    // Control
    row_cells[7].innerHTML = "<input type='hidden' name='row_info_" + row_number + "' value='" + row_info.replace(/'/g,'((singlequote))') + "'>";
	
}

// highlights a row
function row_highlight(row) {
    var form = $('#theForm')[0];
    var i = form.elements['selected_row'].value.toString();

    if (i.length != 0) {
        var row_obj = document.getElementById('row_' + i);
        row_obj.style.backgroundColor = 'white';
    }

    var row_obj = document.getElementById('row_' + row);
    row_obj.style.backgroundColor = '#CFCFCF';

    form.elements['selected_row'].value = row;
}

function row_cells_get(row_number) {
    var row_id = 'row_' + row_number;
    var tr = document.getElementById(row_id);
    var row_cells = tr.childNodes;
    return row_cells;
}



function pop_clear(pop) {
    var i = 0;
    var o = pop.options;

    for (var i = o.length; i >= 0; --i)
        o[i] = null;
    pop.disabled = true;
}

function pop_set(pop, list, def) {
    pop_clear(pop);

    var qty = list.length;
    var selected = 0;

    for (var i = 0; i < qty; i++) {
        var code = pop_additem(pop, list[i]);
        if (code == def) {
            selected = i;
        }
    }
    pop.selectedIndex = selected;
}

function pop_additem(pop, info) {
    var list = pop.options;
    var nIdx;

    if (list.length < 0) { //IE for Mac 4.5 sets length to -1 if list is empty
        nIdx = 0;
    }
    else {
        nIdx = list.length;
    }
    var values = info.split('|DOT|');
    list[nIdx] = new Option(values[1], values[0]);
    pop.disabled = false;
    return values[1];
}



function searchInArray(stack, needle) {
    var la = needle.length;
    var count = stack.length;

    for (var i = 0; i < count; i++) {
        if (stack[i].substr(0, la) == needle) {
            return i;
        }
    }

    return 0;
}


