var UIVW_editform_msg1 = 'You must first select an item.';
var UIVW_editform_msg2 = 'You must first select an item to move.';
var UIVW_editform_msg3 = 'You must first select an item to change its direction.';
var UIVW_editform_msg4 = 'Please give a name to this view.';
function changeList(fromListName, toListName) {
    var form = $('#theForm')[0];
    var fromList = form.elements[fromListName];
    var toList = form.elements[toListName];

    var index = fromList.selectedIndex;
    if (index == -1) {
        alert(UIVW_editform_msg1);
    } else {
        var option = fromList[index];
        var i = toList.length;
        toList[i] = new Option(option['text'], option['value']);
        toList.selectedIndex = i;
        fromList[index] = null;
    }
}

/*
 2007-06-13 FS-CJR
 para explorer 7 no funcionaba el cambio en el orden de las listas de ordenamiento ni de campos a incluir en la vista, porque no era
 suficiente asignar los valores haciendo el swap, sino que se debe hacer una nueva instanciación de ambos elementos de la lista
 con un 'new'.
 */
function moveItem(aListName, delta) {
    var form = $('#theForm')[0];
    var aList = form.elements[aListName];
    var el = aList.options;
    var index = el.selectedIndex;
    if (index == -1) {
        alert(UIVW_editform_msg2);
    } else {

        var newindex = index + delta;
        if (newindex >= el.length) {
            newindex = 0;
        }
        if (newindex < 0) {
            newindex = el.length - 1;
        }
        var oldVal = el[index].value;
        var oldText = el[index].text;
        var newVal = el[newindex].value;
        var newText = el[newindex].text;
        el[index] = new Option(newText, newVal);
        el[newindex] = new Option(oldText, oldVal);
        el.selectedIndex = newindex;
    }
}

function changeDirection() {
    var form = $('#theForm')[0];
    var aList = form.elements['sortList'];
    var index = aList.selectedIndex;
    if (index == -1) {
        alert(UIVW_editform_msg3);
    } else {
        var t = aList[index]['text'];
        var p = t.indexOf('[');

        if (p > -1) {
            var n = t.substr(0, p);
            if (t.substr(p, 6) == '[ASC]') {
                //aList[index]['text'] = n + '[DESC]';
                aList[index] = new Option(n + '[DESC]', aList[index]['value']);
            } else {
                //aList[index]['text'] = n + '[ASC]';
                aList[index] = new Option(n + '[ASC]', aList[index]['value']);
            }

        }
    }
}

function getIDs(alist) {
    var strIDs = '';
    var delim = '';

    for (var i = 0; i < alist.length; i++) {
        if (alist[i].text.indexOf('[ASC]') > 0) {
            strIDs += delim + '-' + alist[i].value;
        } else {
            strIDs += delim + '+' + alist[i].value;
        }
        delim = ',';
    }
    return strIDs;
}

function processForm() {

    var form = $('#theForm')[0];
    if (form.elements['UIVW_idname'].value == '') {
        alert(UIVW_editform_msg4);
        return false;
    } else {
        form.elements['viewfields'].value = getIDs(form.elements['fieldList']);
        form.elements['sortfields'].value = getIDs(form.elements['sortList']);
        return true;
    }
}
