<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @package		Clientix.Tool.Interface
 * @abstract		System Chart Manager
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 */
include_once kPathToObjects . 'cpty.php';

class cpty_gbcategoryaxes extends cpty {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'CAX1';
        $this->name = 'Grouped Bar Category Axes';
        $this->type = 'CPTB';
        $this->version = '0.2.0.0';
        $this->description = 'Grouped Bar Category Axes';
        $this->classname = '';
        $this->classfile = '';
        $this->fields = array();
    }

    function getPlot(&$graph, $args, $series = array()) {
        $graph->xaxis->SetTickLabels($series);
        return null;
    }

}
