<?php

/**
 * Object Class
 * For more information contact  support@alenet.com
 *
 * @author       $Author: jclerma $
 * @copyright    Alenet, Inc.
 * @since        $Date: 2017-11-03 15:09:40 -0400 (Fri, 03 Nov 2017) $
 * @version        $Rev: 9615 $
 *
 * CHANGE LOG
 *  Oracle uppercase record changed
 *  Included label
 */
if (!class_exists('ussh') && !defined('clxInstallProcess'))
    include_once kPathToObjects . 'ussh.php';

class ussh extends clx_object {

    // CONSTRUCTOR //
    function __construct() {
        $this->code = 'USSH';
        $this->name = 'Generic Clientix Shortcut';
        $this->type = '----';
        $this->version = '0.1.0.0';
        $this->description = 'This is a Generic Clientix Shortcut';
    }

    function getPanel(&$record) {
	ClxFreeReturn($record); //no se esta usando
    }

    function setPanel(&$record, $values) {
	ClxFreeReturn($values); //no se esta usando
	ClxFreeReturn($record); //no se esta usando
    }

    function defaultPanel(&$record) {
	ClxFreeReturn($record); //no se esta usando
    }

    function viewForm(&$table, $record) {
	ClxFreeReturn($table); //no se esta usando
	ClxFreeReturn($record); //no se esta usando
    }

    function describe($record) {
	ClxFreeReturn($record); //no se esta usando
        return CLX_CHAR_EMPTY_STRING;
    }

    function makeURL($record) {
	ClxFreeReturn($record); //no se esta usando
        return 'index.php';
    }

}
